#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 2 "pars.yacc"

/* $Id: pars.c,v 1.2 1995/06/30 22:32:11 pturner Exp pturner $
 * 
 * evaluate expressions, commands, parameter files
 * 
 */

#define PARS			/* to overide some defines in defines.h */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <sys/param.h>

#include "globals.h"
#include "noxprotos.h"

#ifndef M_PI
#     define M_PI  3.14159265358979323846
#endif

#ifndef TRUE
#     define TRUE 1
#endif

#ifndef FALSE
#     define FALSE 0
#endif

double result, resx, resy;	/* return value if expression */
double nonl_parms[10];

double drand48(void);
long lrand48(void);
double erf(double arg); /* doesn't seem to be in ANSI C */
double erfc(double arg); /* doesn't seem to be in ANSI C */
double rnorm(double mean, double sdev);
double fx(double x);
double normp(double b, double *s);
double invnorm(double p);
double invt(double p, int n);
double *getvptr(int gno, int setno, int v);
double vmin(double *x, int n);
double vmax(double *x, int n);
void yyerror(char *s);

static int interr;

static double *freelist[100]; 	/* temporary vectors */
static int fcnt;		/* number allocated */

int naxis = 0;	/* current axis */
int curline, curbox, curstring, curleg, curgrid;

int gotbatch, gotparams, gotread; /* these guys attempt to avoid reentrancy problems */
int readtype, readsrc, readxformat;
char batchfile[256], paramfile[256], readfile[256];

static char f_string[512];	/* buffer for string to parse */
static int pos = 0;
static double *aa, *bb, *cc, *dd, *xx, *yy;
static int setindex, lxy, ls;
static int setsetno;
static int whichgraph;
static int whichset;

extern int change_gno;
extern int change_type;

#line 74 "pars.yacc"
typedef union {
    double val;
    long ival;
    double *ptr;
    long func;
    long pset;
    char *str;
} YYSTYPE;
#line 86 "y.tab.c"
#define ABS 257
#define ACOS 258
#define ASIN 259
#define ATAN 260
#define ATAN2 261
#define CEIL 262
#define COS 263
#define DEG 264
#define DX 265
#define DY 266
#define ERF 267
#define ERFC 268
#define EXP 269
#define FLOOR 270
#define HYPOT 271
#define INDEX 272
#define INT 273
#define INVN 274
#define INVT 275
#define IRAND 276
#define JDAY 277
#define JDAY0 278
#define LGAMMA 279
#define LN 280
#define LOG 281
#define LOGISTIC 282
#define MAXP 283
#define MINP 284
#define MOD 285
#define NORM 286
#define NORMP 287
#define PI 288
#define RAD 289
#define RAND 290
#define RNORM 291
#define SETNO 292
#define SIN 293
#define SQR 294
#define SQRT 295
#define TAN 296
#define INUM 297
#define VX1 298
#define VX2 299
#define VY1 300
#define VY2 301
#define WX1 302
#define WX2 303
#define WY1 304
#define WY2 305
#define DELAYP 306
#define DOUBLEBUFFER 307
#define DOWN 308
#define ABSOLUTE 309
#define ABORT 310
#define ACTIVATE 311
#define ACTIVE 312
#define ALT 313
#define ALTERNATE 314
#define ALTXAXIS 315
#define ALTYAXIS 316
#define ANGLE 317
#define ANNOTATE 318
#define APPEND 319
#define AREA 320
#define ARRANGE 321
#define ARROW 322
#define ASCENDING 323
#define AUTO 324
#define AUTOSCALE 325
#define AUTOTICKS 326
#define AVG 327
#define AXIS 328
#define AXES 329
#define BACKBUFFER 330
#define BACKGROUND 331
#define BAR 332
#define BATCH 333
#define BLOCK 334
#define BIN 335
#define BOTH 336
#define BOTTOM 337
#define BOX 338
#define BOXPLOT 339
#define CD 340
#define CELLS 341
#define CENTER 342
#define CHAR 343
#define CHRSTR 344
#define CLEAR 345
#define CLICK 346
#define CMAP 347
#define COLOR 348
#define COMMENT 349
#define COPY 350
#define CYCLE 351
#define DECIMAL 352
#define DEF 353
#define DEFAULT 354
#define DELETE 355
#define DEVICE 356
#define DESCENDING 357
#define DFT 358
#define DIFFERENCE 359
#define DISK 360
#define DRAW2 361
#define DROP 362
#define DXDX 363
#define DXP 364
#define DYDY 365
#define DYP 366
#define ECHO 367
#define EDIT 368
#define ELSE 369
#define END 370
#define ERRORBAR 371
#define EXIT 372
#define EXPONENTIAL 373
#define FALSEP 374
#define FFT 375
#define FILEP 376
#define FILL 377
#define FIND 378
#define FIXEDPOINT 379
#define FLUSH 380
#define FOCUS 381
#define FOLLOWS 382
#define FONTP 383
#define FOREGROUND 384
#define FORMAT 385
#define FRONTBUFFER 386
#define FRAMEP 387
#define GETP 388
#define GRAPH 389
#define GRAPHNO 390
#define GRAPHS 391
#define GRAPHTYPE 392
#define GRID 393
#define HARDCOPY 394
#define HBAR 395
#define HBOXPLOT 396
#define HGAP 397
#define HIDDEN 398
#define HORIZONTAL 399
#define HPGLL 400
#define HPGLP 401
#define HISTO 402
#define IF 403
#define IGNORE 404
#define IHL 405
#define IMAGE 406
#define IN 407
#define INIT 408
#define INOUT 409
#define INTEGRATE 410
#define INTERP 411
#define INVDFT 412
#define INVFFT 413
#define JUST 414
#define KILL 415
#define LABEL 416
#define LAYOUT 417
#define LEAVE 418
#define LEFT 419
#define LEGEND 420
#define LENGTH 421
#define LEVEL 422
#define LEVELS 423
#define LINE 424
#define LINESTYLE 425
#define LINETO 426
#define LINEWIDTH 427
#define LINK 428
#define LOAD 429
#define LOCATOR 430
#define LOCTYPE 431
#define LOGX 432
#define LOGY 433
#define LOGXY 434
#define MAJOR 435
#define MIFL 436
#define MIFP 437
#define MINOR 438
#define MISSINGP 439
#define MOVE 440
#define MOVE2 441
#define MOVETO 442
#define NEGATE 443
#define NO 444
#define NONE 445
#define NORMAL 446
#define NXY 447
#define OFF 448
#define OFFSETX 449
#define OFFSETY 450
#define ON 451
#define OP 452
#define ORIENT 453
#define OUT 454
#define PAGE 455
#define PARA 456
#define PARALLEL 457
#define PARAMETERS 458
#define PARAMS 459
#define PATTERN 460
#define PERIMETER 461
#define PERP 462
#define PERPENDICULAR 463
#define PIE 464
#define PIPE 465
#define PLACE 466
#define POINT 467
#define POLAR 468
#define POLY 469
#define POWER 470
#define PREC 471
#define PREPEND 472
#define PRINT 473
#define PS 474
#define PSCOLORP 475
#define PSMONOP 476
#define PSCOLORL 477
#define PSMONOL 478
#define PUSH 479
#define POP 480
#define PUTP 481
#define RAWSPICE 482
#define READ 483
#define REDRAW 484
#define REGRESS 485
#define REGNUM 486
#define REGIONS 487
#define RENDER 488
#define REVERSE 489
#define RIGHT 490
#define RISER 491
#define ROT 492
#define RUNAVG 493
#define RUNMED 494
#define RUNSTD 495
#define RUNMIN 496
#define RUNMAX 497
#define SAMPLE 498
#define SAVEALL 499
#define SCALE 500
#define SCIENTIFIC 501
#define SET 502
#define SETNUM 503
#define SETS 504
#define SIGN 505
#define SIZE 506
#define SKIP 507
#define SLEEP 508
#define SLICE 509
#define SMITH 510
#define SORT 511
#define SOURCE 512
#define SPEC 513
#define SPECIFIED 514
#define SPECTRUM 515
#define STACK 516
#define STACKEDBAR 517
#define STACKEDHBAR 518
#define STACKEDLINE 519
#define STAGGER 520
#define START 521
#define STARTTYPE 522
#define STATUS 523
#define STOP 524
#define STRING 525
#define SUBTITLE 526
#define SWAPBUFFER 527
#define SYMBOL 528
#define TICKP 529
#define TICKLABEL 530
#define TICKMARKS 531
#define TIME 532
#define TITLE 533
#define TO 534
#define TOP 535
#define TRUEP 536
#define TYPE 537
#define UP 538
#define VELOCITY 539
#define VERTICAL 540
#define VGAP 541
#define VIEW 542
#define WITH 543
#define WORLD 544
#define WRITE 545
#define X 546
#define X0 547
#define X1 548
#define XAXES 549
#define XAXIS 550
#define XCOR 551
#define XMAX 552
#define XMIN 553
#define XY 554
#define XYARC 555
#define XYBOX 556
#define XYBOXPLOT 557
#define XYFIXED 558
#define XYHILO 559
#define XYRT 560
#define XYSEG 561
#define XYSTRING 562
#define XYDX 563
#define XYDY 564
#define XYDXDX 565
#define XYDYDY 566
#define XYDXDY 567
#define XYX2Y2 568
#define XYXX 569
#define XYYY 570
#define XYZ 571
#define XYZW 572
#define XYUV 573
#define TSV 574
#define Y 575
#define Y0 576
#define Y1 577
#define Y2 578
#define Y3 579
#define Y4 580
#define Y5 581
#define YAXES 582
#define YAXIS 583
#define YES 584
#define YMAX 585
#define YMIN 586
#define ZEROXAXIS 587
#define ZEROYAXIS 588
#define ABOVE 589
#define BELOW 590
#define POLYI 591
#define POLYO 592
#define GENERAL 593
#define DDMMYY 594
#define YYMMDD 595
#define MMDDYY 596
#define MMYY 597
#define MMDD 598
#define MONTHDAY 599
#define DAYMONTH 600
#define MONTHS 601
#define MONTHSY 602
#define MONTHL 603
#define DAYOFWEEKS 604
#define DAYOFWEEKL 605
#define DAYOFYEAR 606
#define HMS 607
#define MMDDHMS 608
#define MMDDYYHMS 609
#define YYMMDDHMS 610
#define DEGREESLON 611
#define DEGREESMMLON 612
#define DEGREESMMSSLON 613
#define MMSSLON 614
#define DEGREESLAT 615
#define DEGREESMMLAT 616
#define DEGREESMMSSLAT 617
#define MMSSLAT 618
#define DOT 619
#define STAR 620
#define PLUS 621
#define CROSS 622
#define CIRCLE 623
#define SQUARE 624
#define DIAMOND 625
#define TRIANGLE1 626
#define TRIANGLE2 627
#define TRIANGLE3 628
#define TRIANGLE4 629
#define SPLINE 630
#define LANDSCAPE 631
#define PORTRAIT 632
#define FREE 633
#define FIXED 634
#define STATUSBAR 635
#define LOCATORBAR 636
#define TOOLBAR 637
#define VAR 638
#define NUMBER 639
#define FITPARM 640
#define OR 641
#define AND 642
#define GT 643
#define LT 644
#define LE 645
#define GE 646
#define EQ 647
#define NE 648
#define UMINUS 649
#define NOT 650
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   36,   36,   36,   36,   36,   36,   36,
   17,   17,   17,   17,   17,   17,   17,   17,   18,   18,
   18,   18,   18,   18,   18,   18,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   22,   22,
   22,   22,   22,   22,   22,   27,   27,   27,   27,   27,
   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
   27,   27,   27,   27,   27,   27,   27,   27,   27,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   31,   31,   31,   31,   19,   19,   19,   19,
   19,   19,   35,   37,   37,   37,   37,   37,   37,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
   37,   37,   34,   34,   34,   34,   34,   34,   38,   38,
   38,   38,   38,   38,   40,   40,   40,   41,   41,   41,
   41,   41,   41,   41,   39,   39,   39,   39,   39,   42,
   42,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   43,   43,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   45,
   45,   45,   45,   21,   21,   21,   21,   21,   21,   24,
   24,   24,   24,   24,    7,    7,    8,    8,   28,   28,
   28,   28,   28,   29,   29,   29,   29,   26,   26,   25,
   25,   25,   15,   15,   15,   15,   15,   14,   14,   14,
   30,   30,    9,    9,   12,   12,   12,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   13,   13,   13,   16,
   16,   16,   16,   16,   16,   10,   10,   33,   33,   32,
   32,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    3,    3,    3,    3,    3,    5,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,
};
short yylen[] = {                                         2,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    4,    3,    2,    3,    1,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
    3,    3,    3,    9,    5,    4,    1,    3,    2,    2,
    1,    3,    8,    1,    3,    2,    2,    2,    4,    4,
    6,    2,    2,    2,    7,    2,    2,    3,    3,    2,
    2,    2,    1,    2,    2,    2,    2,    2,    2,    2,
    4,    6,    3,    5,    3,    5,    3,    5,    5,    7,
    5,    7,    4,    4,    8,    4,    8,    2,    2,    3,
    3,    2,    2,    1,    4,    7,    6,    6,    6,   10,
   10,    6,    4,    1,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    3,    3,    4,
    3,    3,    4,    3,    3,    5,    2,    4,    4,    6,
    2,    1,    1,    1,    2,   17,    2,    2,    2,    3,
    2,    2,    8,    3,    3,    3,    3,    3,    4,    4,
    2,    2,    3,    2,    2,    2,    8,    3,    3,    3,
    3,    3,    4,    4,    2,    2,    2,    3,    2,    2,
    4,    3,    3,    3,    3,    3,    3,    4,    3,    3,
    4,    5,    4,    4,    5,    3,    3,    3,    4,    3,
    4,    4,    8,    3,    3,    3,    3,    5,    8,    3,
    3,    3,    3,    2,    3,    3,    3,    3,    2,    3,
    3,    3,    3,    4,    2,    3,    3,    3,    3,    3,
    3,    4,    5,    5,    4,    4,    4,    4,    3,    3,
    4,    3,    3,    3,    3,    4,    2,    3,    3,    3,
    3,    3,    4,    2,    3,    4,    4,    3,    3,    3,
    4,    4,    3,    5,    6,    6,    4,    4,    3,    3,
    3,    3,    3,    3,    4,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    2,    1,    1,    2,    2,    2,    2,    2,
    3,    3,    3,    3,    3,    3,    3,    3,    2,    2,
    3,    3,    2,    3,    3,    3,    3,    3,    4,    4,
    4,    2,    1,    2,    1,    2,    3,    2,    1,    1,
    1,    1,    1,    1,    2,    2,    2,    1,    2,    2,
    2,    2,    3,    2,    2,    2,    2,    2,    1,    1,
    2,    1,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    1,    2,    2,    3,    3,    2,    2,    3,
    3,    3,    3,    3,    3,    3,    3,    2,    2,    2,
    2,    3,    1,    2,    1,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    3,    3,    3,
    3,    2,    2,    3,    2,    2,    2,    3,    1,    2,
    2,    2,    2,    4,    2,    3,    2,    2,    2,    1,
    2,    2,    2,    3,    1,    1,    2,    2,    2,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    6,    6,    8,    5,   10,    5,    3,    3,    3,    5,
    5,    7,    5,    7,    3,    3,    5,    7,    1,    1,
    3,    5,    1,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    4,    4,    4,    4,    4,    6,    4,
    4,    1,    4,    4,    4,    4,    6,    6,    6,    6,
    1,    1,    4,    4,    6,    6,    4,    4,    4,    4,
    8,    6,    6,    6,    4,    4,    1,    1,    1,    6,
    6,    6,    6,    4,    4,    4,    4,    5,    3,    3,
    3,    3,    3,    3,    3,    3,    2,    3,    2,    1,
    1,    4,    3,    4,    6,    8,    5,    7,    3,    5,
    3,    3,    3,    3,    3,    3,    4,    4,    4,    4,
    6,    4,    4,    1,    4,    4,    4,    4,    6,    3,
    3,    3,    3,    3,    3,    3,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    4,
    4,    6,    4,    8,   14,    4,    4,    4,    8,    6,
    6,    6,    4,    4,    1,    1,    1,    6,    4,    4,
    4,    4,    5,    3,    3,    3,    3,    3,    3,    3,
    3,    2,    3,    2,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  696,
  697,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  688,  689,  690,  691,  692,  693,  694,  695,    0,
    0,    0,    0,  351,  352,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  134,    0,
    0,  474,    0,    0,    0,   44,  475,   94,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  476,  477,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  132,  133,    0,    0,   37,    0,
    0,  469,  471,  470,  473,  472,    0,    0,  456,    0,
    0,    0,    0,   41,    0,    0,   63,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  542,  544,    0,  349,
  543,  545,  546,  547,  548,  549,  550,    0,  350,  353,
  354,    0,    0,    0,    0,    0,  650,  651,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  345,   13,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   65,  494,  493,   60,   66,    0,    0,    0,
    0,  107,  105,  106,    0,    0,    0,    0,    0,    0,
  466,  465,  358,  355,   62,    0,  287,  286,  288,  289,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
    0,    0,    0,    0,    0,    0,    0,    0,  674,    0,
    0,    0,    0,    0,  698,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  715,  716,
  717,    0,  699,    0,    0,    0,    0,    0,  151,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  141,   39,  138,  154,  137,  166,    0,   52,
    0,    0,    0,    0,    0,    0,    0,    0,   17,    0,
    0,    0,   40,  113,  112,  109,  111,  110,  498,  499,
  500,  501,  502,  504,  503,  505,  506,  507,  508,  509,
  510,  511,  512,  513,  514,  515,  516,  517,  518,  519,
  520,  521,  522,  523,  524,  525,  526,  116,   61,    0,
    0,    0,    0,    0,    0,  237,   67,    0,    0,    0,
    0,    0,    0,  457,    0,    0,    0,  244,    0,  459,
  458,    0,  348,    0,    0,    0,   92,   93,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  215,    0,    0,  165,    0,
    0,    0,    0,    0,  155,   54,   53,    0,    0,    0,
  108,    0,    0,    0,  531,  534,    0,    0,  533,  535,
  532,  530,   57,   56,    0,   28,   27,   26,   25,   24,
   23,   21,   22,    0,    0,    0,   68,    0,    0,  117,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   29,  131,    0,    0,    0,    0,    0,    0,   64,    0,
  478,  479,  114,    0,  135,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  169,  209,    0,    0,    0,
    0,    0,    0,  204,    0,    0,    0,    0,  115,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   69,    0,   70,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  356,  357,    0,   46,   48,   47,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    5,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    6,    0,    2,    3,    4,    0,    0,    8,
  463,    0,    0,    0,  462,    0,  315,  460,  461,    0,
    0,  464,    0,    0,    0,    0,  314,    0,  313,   10,
    7,    0,    0,    9,   11,   12,    0,    0,    0,    0,
  369,  344,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   75,    0,   38,    0,  359,
  362,  364,  361,  360,   42,  121,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  147,    0,  482,    0,
  148,    0,  145,  146,  537,  536,  144,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  188,    0,  190,  186,  187,    0,
    0,    0,    0,  241,  242,  239,  240,  238,    0,    0,
  248,    0,    0,    0,    0,    0,  253,  249,  245,    0,
  294,  300,  295,  301,  291,  292,  293,  298,  302,  296,
  297,  290,  299,  250,  680,  681,  682,  683,  684,  685,
  686,  687,    0,    0,  347,   18,    0,    0,   90,   91,
    0,    0,    0,    0,  221,    0,  235,  232,  219,  217,
  220,  233,  234,  216,    0,  218,    0,    0,    0,    0,
    0,  162,  161,  160,  159,  158,    0,   59,    0,    0,
    0,    0,    0,   58,  304,  305,  303,  306,   45,    0,
    0,   14,   20,  118,  119,    0,  124,  122,    0,    0,
   31,    0,   32,   33,  309,  310,  307,  308,  311,  312,
   30,    0,    0,    0,   77,   73,    0,    0,    0,  559,
  659,    0,    0,  540,  541,    0,    0,    0,  174,  179,
  176,  177,  173,  172,  175,    0,  212,  210,  213,  211,
    0,    0,    0,    0,    0,    0,  180,  207,  205,  208,
  206,    0,  263,  260,  262,  261,  264,  259,  201,  200,
  203,  202,    0,  140,  153,  168,    0,    0,    0,    0,
    0,  125,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  733,  648,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  342,    0,    0,
    0,    0,    0,  467,  468,    0,  330,    0,  319,    0,
  318,  333,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  316,    0,  329,    0,    0,    0,    0,    0,  450,
  368,    0,  439,    0,    0,    0,    0,    0,    0,  367,
    0,    0,    0,    0,  497,    0,    0,  495,    0,    0,
    0,    0,    0,    0,  496,    0,    0,    0,    0,  372,
  383,    0,  370,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  405,    0,  403,    0,  595,
  668,  596,  669,  597,  670,  598,    0,    0,  672,  600,
  673,  601,  675,  603,  676,  604,  677,  605,  678,  606,
    0,    0,  103,  700,  613,  701,  614,    0,    0,    0,
    0,    0,  706,  618,  707,  619,  708,  620,    0,    0,
    0,    0,    0,    0,    0,    0,  713,  625,  714,  626,
    0,    0,  719,  634,  720,  635,  721,  636,  722,  637,
    0,   95,  363,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  149,  150,    0,  653,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   84,  189,
  191,  192,    0,    0,  243,  258,  246,  247,  251,    0,
    0,  257,    0,  252,    0,    0,    0,    0,    0,    0,
  214,    0,    0,  225,    0,  222,    0,  226,  227,  231,
  236,    0,  163,  164,    0,   36,    0,    0,   86,    0,
    0,   15,  120,  123,    0,    0,    0,    0,    0,   71,
    0,    0,    0,    0,    0,    0,  538,  539,   83,    0,
  178,    0,    0,    0,  183,  181,  184,    0,  265,    0,
    0,    0,  128,    0,    0,    0,    0,    0,    0,    0,
    0,  334,  337,  336,    0,    0,  338,  487,  484,  485,
  486,  483,  335,  331,  332,  322,  324,    0,  321,  328,
  327,    0,  325,    0,    0,    0,  451,  452,  453,    0,
  448,  447,  490,  489,  488,  445,  441,  440,  449,  442,
  443,    0,  384,    0,    0,  379,  388,  382,  389,    0,
    0,    0,    0,    0,    0,  373,    0,    0,    0,    0,
    0,    0,  374,    0,    0,  398,  385,  401,  399,  400,
    0,  371,  420,  411,    0,  436,  435,  410,  409,  433,
  421,  413,  415,  414,  437,  417,  418,  416,  419,  424,
  408,  412,  528,  529,  527,  425,  422,  423,    0,    0,
    0,    0,  406,  407,  432,    0,  404,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   76,
  667,    0,    0,  703,    0,    0,    0,  652,    0,  654,
    0,    0,    0,  254,    0,    0,    0,   78,   74,    0,
    0,    0,  560,    0,    0,  126,  223,  224,    0,    0,
    0,    0,    0,    0,    0,    0,   81,    0,  561,    0,
    0,    0,  492,  491,  660,  657,    0,    0,    0,  182,
  185,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  340,  339,    0,    0,    0,  446,    0,  390,  396,
  394,  392,  386,  391,  397,  395,  393,  387,    0,  434,
  429,  428,  431,  430,  438,  671,  599,    0,  608,  609,
  607,    0,  616,    0,    0,    0,    0,  710,  622,  711,
  623,  712,  624,    0,  631,  632,  630,    0,    0,    0,
    0,    0,    0,    0,    0,  102,  255,    0,    0,   72,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   97,
    0,    0,    0,   51,    0,    0,  130,    0,    0,    0,
    0,    0,   98,   99,  444,    0,    0,    0,    0,  679,
  702,  718,    0,  655,    0,    0,    0,   82,    0,  562,
    0,    0,  658,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   55,    0,  704,    0,  709,  621,    0,
    0,   43,   85,    0,    0,    0,   87,    0,    0,    0,
    0,    0,    0,    0,  656,    0,    0,    0,    0,    0,
    0,    0,  101,    0,  100,    0,    0,    0,    0,    0,
    0,  705,    0,    0,    0,    0,
};
short yydgoto[] = {                                     162,
  965,  649,  165,  166,  167,  312,  233,  998,  216,  737,
  368, 1051, 1366, 1306, 1283,  444,  455,  169,  871,  794,
  170,  171,  172,  608,  731,  483,  261,  173,  174, 1446,
  849,  886, 1249,  175,  176,  177,  609,  178,  622,  179,
  234, 1052, 1077, 1030, 1021, 1053, 1078,
};
short yysindex[] = {                                   8798,
    9,   17,   69,   70,   78,  202,  240,  244,    0,    0,
    0,  254,  259,  260,  263,  312,    0,  317,  320,  326,
  339,  345,  363,  371,  378,  381,  386,  387,  389,  398,
  399,  400,    0,    0,    0,  404,    0,  463,  467,  472,
  473,    0,    0,    0,    0,    0,    0,    0,    0, -537,
 -368, -368, -378,    0,    0, -189,   -5, -140,  837, -368,
  168, 8945, 9842,  173, -190, -118, -116, -227,    0, -167,
 -112,    0,  484,11890,  190,    0,    0,    0,  841,10619,
 -368, -304,  205, 3504, 1377,  198,  538,   30,    0,    0,
   33, 9192,10167,  -54,  -53, -359,  -51, -331, -211,11890,
  762,   47, 1105,  166,    0,    0,  251,10983,    0,  564,
  -43,    0,    0,    0,    0,    0,  262,  -22,    0,  -31,
   93, -182, -306,    0, 9517,   14,    0,11890,   84,   88,
 8945, -261,11313, -103,11392, -392,    0,    0,  837,    0,
    0,    0,    0,    0,    0,    0,    0,  837,    0,    0,
    0,  572, -331, -331, -331,  -21,    0,    0,12284,12284,
12284,    0, 1719,  733,  609,  610,  611,  447,  612, 3887,
  613,  618,  590,  607,  638,  650,  651, -302,    0,    0,
12284,12284,12284,12284,12284,12284,12284,12284,12284,12284,
12284,12284,12334,12284,12284,   36,   38,   42,12284,12284,
12284,12284,12284,12284,12284,12284,12284,12284,12284,12284,
12284,12284,    0,    0,    0,    0,    0,  644,   52,  648,
 -331,    0,    0,    0,  188,   56,   57, -331,   58,   91,
    0,    0,    0,    0,    0,   92,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  369,  692,  694,  695,  696,  702,  713,  714,    0,  717,
  718,  719,  721,  722,    0,  729,  731,  732,  742,  743,
  744,  757,  758,  763,  764,  765,  766,  767,    0,    0,
    0,  768,    0,  772,  776,  785,  788,  134,    0,  -12,
  746,  149,  163, -499,  783,  787,  754,11890,11890,11890,
  555,  756,    0,    0,    0,    0,    0,    0,  793,    0,
  803,  305,  344,  212, -501,  224,  226,  360,    0,  364,
  746, 3280,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  521,
  231, -331,  238,  242,  243,    0,    0,  375, -259,  385,
 -380, -368, -331,    0,  390, 3127,   72,    0,  388,    0,
    0, -302,    0,  264,  395,  265,    0,    0,  394,  401,
  121,  393,  266,  268,  269,  270,  272,  288,  291, -499,
  292,  313,11890,11890, 3402,    0, -220,  314,    0,  746,
  315,  331, -499, 3729,    0,    0,    0, -331,  376,  332,
    0,  880,  402, 4037,    0,    0,  333,   40,    0,    0,
    0,    0,    0,    0,11890,    0,    0,    0,    0,    0,
    0,    0,    0, 1157,  596,  361,    0,  655, -326,    0,
  661, -322,  485,  368,11890,  370,  372, -360,11890, 1144,
    0,    0,  373,  377,   74,11890, -149,  680,    0, -529,
    0,    0,    0,11890,    0,  511,  384,  681,  391,  746,
  397,  406, -499,  407, 4423,    0,    0,  408,  409,  411,
  430, 4979, -271,    0,  436,  437,  440,  459,    0,  489,
  460, -331,  461,  465, -499,  466,  468,  474,  476,  477,
 5111,  478,    0,  479,    0,  488,11890,11890,11890,11890,
 5252,  683, -343,11890,    0,    0,  529,    0,    0,    0,
12284,11890,  999, 1032, 1060,  754, 1056, 1066,  756, 1056,
 1066, 4744,  301,11890,11890,11890,11890,11890,11890,11890,
11890,12284,12284,12284,12284,11890,12284,    0,11890,12284,
12284,12284,12284,12284,12284,12284,12284,12284,12284,12284,
12284,12284,    0,12284,    0,    0,    0,12284,11890,    0,
    0,  779,   10, -307,    0,10619,    0,    0,    0,11890,
  496,    0,  497,10492, 8945,11890,    0,  498,    0,    0,
    0,  640,  643,    0,    0,    0,  126,  396,12362,11887,
    0,    0, 4776, 3579, 5235, 3737, 5456, 3924, 5479, 5746,
 5492, 3100, 5524, 6101, 5604, 7180, 5633, 8007, 5642, 8336,
 5683, 9202, 5698, 9270, 5537, 8098,  252, 5723, 9308, 5738,
 9346, 5761,10451, 1106, 1094, 1104, 5773, 9518, 5796, 9527,
 5809, 9555, 5821,10546, 5864,10756, 5875,10799, 5886,10816,
 5898, 9583, 5909, 9592, 5920,11112, 5934, 9609, 5948, 9617,
 5957, 9655, 5976, 9663,  646,    0,  512,    0,  523,    0,
    0,    0,    0,    0,    0,    0,11890,11890,11890,11890,
11890,11890,11890,11890,11890,11890,11890,11890,11890,11890,
11890,  526,11890,11890,11890,11890,11890,11890,11890,11890,
11890,11890,11890,11890,11890,11890,    0,  527,    0,  528,
    0,  556,    0,    0,    0,    0,    0, 1144, 1023,11890,
 1056, 1056, 5989,11890,11890,11890,11890,11890,11890,11890,
  531,  674,  679,  544,    0,  551,    0,    0,    0,  553,
 1151,11890,  566,    0,    0,    0,    0,    0,  567, -314,
    0,  571,10619,  573,  575,11890,    0,    0,    0,  576,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -11,  578,    0,    0, 1163, 1167,    0,    0,
  579,  -47,  580,  582,    0,  583,    0,    0,    0,    0,
    0,    0,    0,    0,  885,    0, 8381, 8381,11890,  585,
  594,    0,    0,    0,    0,    0,11890,    0,  844, 1191,
  737,  738,11890,    0,    0,    0,    0,    0,    0, 6001,
  892,    0,    0,    0,    0,  899,    0,    0,  902, 1204,
    0, 6012,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 6024, 1188, 1206,    0,    0,  909, 6047, 1208,    0,
    0, 1202,  414,    0,    0,   26, 6110,  628,    0,    0,
    0,    0,    0,    0,    0,11890,    0,    0,    0,    0,
11890,  769,  629,  630,  632, 1229,    0,    0,    0,    0,
    0,  645,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,11890,    0,    0,    0, 8381, 8381, 8381, 8381,
11890,    0,  930,  942, 6149, 1243, 8390,10989, 6160,12284,
  854, 1023,    0,    0,  789, 1097,  748,  748,  748,  748,
  748,  748,  752,  801,  752,  801,  293,  424,  293,  424,
  425,  293,  424, 6171, 8390, 2757, 1622,  568,  568,  568,
  568,  568,  568,  752,  801,  752,  801,  365,  424,  365,
  424,  365,  424,10493, 8390,10989, 6219,    0,  652,  654,
  657,  125, -321,    0,    0, -175,    0,  658,    0, 8381,
    0,    0, -368,  659,11890,  660,  662,  663,11890,  664,
 8381,    0, 6254,    0, 1246, 1250,  665,  666,  668,    0,
    0,  802,    0,  670,  671, -200, -174,  672, -315,    0,
 -331,11890,11890, -331,    0,  673,  675,    0,  677,10663,
10988,11890,11890, -321,    0,  678,  682, -298, 1269,    0,
    0,12362,    0,  684,  975,  814,  685,  687,11450,  688,
 -200, -234,  689, -319, -321,  690,  978, -206,  691,  701,
11447,11841, -296,  720, 1287,    0,11887,    0,    0,    0,
    0,    0,    0,    0,    0,    0,11890,12284,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
12284,12284,    0,    0,    0,    0,    0,  734,  745,    0,
  747,  749,    0,    0,    0,    0,    0,    0,11890,11890,
11890,12284,11890,12284,11890,12284,    0,    0,    0,    0,
12284,12284,    0,    0,    0,    0,    0,    0,    0,    0,
  750,    0,    0, 6385, 6441, 6636, 6665, 6674, 6735, 6783,
 6794, 6811, 6844, 6867, 6876, 6890, 6899, 6912, 1292, 6926,
 6940, 6949, 6972, 7002, 7011, 7034, 7057, 7066, 7079, 7090,
 7102, 7125, 7134,    0,    0, 1288,    0,  213, 7148,  966,
  966,  425,  425,  425, 7157, 7170, 1291,  826,    0,    0,
    0,    0,  753, 8381,    0,    0,    0,    0,    0,10619,
 1317,    0, 7192,    0,  760,  770,   74,11890, -115, 1144,
    0,11890,  773,    0, -175,    0,  775,    0,    0,    0,
    0, 8381,    0,    0, 7203,    0,11890,  838,    0, 8381,
11890,    0,    0,    0,  790,11890,11890,11890,  799,    0,
11890,  879,11890,12284,  261,11890,    0,    0,    0,11890,
    0, 8381, 7251,  800,    0,    0,    0,  804,    0, 7290,
 7299,  998,    0,11890,11890, 1324, 1341,  213,11890,12284,
 1330,    0,    0,    0,  806,  809,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 8381,    0,    0,
    0, 8381,    0,11890,  810,  811,    0,    0,    0,  812,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1349,    0, 8381, 8381,    0,    0,    0,    0,  813,
 -331,  816,  817,  818, 8381,    0,  820, -331,  821,  822,
  824, 8381,    0, 8381, 8381,    0,    0,    0,    0,    0,
11890,    0,    0,    0,  825,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -293, 8381,
 -287, 8381,    0,    0,    0, 1058,    0, 7322, 9863, 7349,
 9880, 7431, 9917, 1363, 1364, 1369, 1371, 7623, 7815, 7824,
 9934, 7863, 9959, 7911, 9982, 7935, 9991, 7965,10229,    0,
    0,11890,  827,    0,11890, 1144,11890,    0,11890,    0,
  828, 1017, 1375,    0,  830,11890, 1382,    0,    0, 1083,
 7974, 1394,    0,  480, 7988,    0,    0,    0,11890, 7997,
 1038, 8381, 1400, 8020, 8381, 8381,    0, 8381,    0, 8381,
 8390,10989,    0,    0,    0,    0, 8043, 8052,  832,    0,
    0,11890,11890, 1098, 8065, 8076,11890, 1144, 8381,10989,
11890,    0,    0, 8381, 1424, 1429,    0,  853,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 8381,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  855,  856,11890,11890,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 8088, 1439, 8111,
  256, 8120, 8134, 1449, 1437,    0,    0, 8381,  857,    0,
11890,  997,12284,   12,11890,11890, 8143,11890, 1455,    0,
11890, 1441,11890,    0, 8156, 8178,    0, 1159,11890, 8381,
  256, 8381,    0,    0,    0, 1463, 1464, 8189, 8212,    0,
    0,    0,11890,    0,11890,  868, 1006,    0, 8381,    0,
 8390,10989,    0, 8237, 8248,11890, 8381, 1007, 8260,11890,
 8271,11890,11890,    0, 8282,    0,  872,    0,    0, 8296,
 8381,    0,    0, 1457,  882, 8381,    0,11890, 8381,11890,
 8381, 8381,  884, 1481,    0,11890, 1487, 8381, 8310, 1490,
  897, 8381,    0,11890,    0, 1493, 8319,  911,11890, 1497,
 8349,    0,11890, 8358,11890, 8381,
};
short yyrindex[] = {                                   1548,
    0,    0,    0,    0,    0,    0,    0,    0,   11,    0,
    0,    0,    0,    0,    0,    0,   41,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  271,  349,  410,    0,  439,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1542,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1543,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,11458,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2583,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2738,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1545,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1549,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1551,    0,    0,    0,    0,    0,    0, 1552, 1553,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1473,    0,    0,    0,    0,    0, 1555,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1558,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1562,    0, 1565,    0, 1566,    0,    0,    0,    0,
    0,    0, 1567,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1067, 1131,  420, 1472, 1601,
 2562,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1568,    0, 1569,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1353, 1502,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,11861,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1570, 1572,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1574,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1878,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3170,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1576, 1577, 1578, 1580,
    0,    0,    0,    0,    0,    0, 1582, 1596,    0,    0,
    0,    0,    0,    0, 4665, 3565, 3747, 3896, 4078, 4239,
 4413, 4452,   22,  635, 2067, 2869, 2122,  448, 2554, 2394,
 1785, 2750, 2826,    0,  957,  309,   87,   96,  114,  279,
  281,  287,  297, 2926, 2986, 3108, 3222, 2847, 2970, 3006,
 3047, 3083, 3092,    0, 1597, 1598,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1599,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1602,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1603,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1605,    0,  723,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  777,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2649,
 2901, 2037, 2217, 2469,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1607,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1616,    0,    0,    0,    0,    0,    0,    0, 1617,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1618,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1619,    0,    0,    0, 1939,    0, 1639,    0,    0,
 1995,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1620,    0,    0,
    0, 1621,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 3150, 3526,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 4977,    0,    0,    0,    0,    0,
    0, 5027,    0, 5156, 5205,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 4693,
    0, 4931,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 3209,    0,    0,    0,    0,    0,    0,
    0, 1630,    0,    0, 1631, 1637,    0, 1640,    0, 1641,
 1642, 1643,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 4814, 1087,
    0,    0,    0, 1644,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 5265,    0,
    0,    0,    0,    0,    0,    0,    0,  831,    0,    0,
    0,  843,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  977,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1645,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2306,    0,    0,    0,    0,    0,    0,    0, 1646,
 2130, 1647,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1648,    0,
 1651, 1652,    0,    0,    0,    0, 1653,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1658,    0,    0, 2835,    0, 1661,    0,    0, 1663,    0,
 1664, 1665,    0,    0,    0,    0,    0, 1666,    0,    0,
    0, 1667,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1668,
};
short yygindex[] = {                                      0,
    1,  774,    0,    0,    0,   62,   -3, -799,  -52, -374,
 -549,    0,    0,  626, -952,    0, 1178,    0,    0,    0,
    0,    0,    0,    0,    0, -455, -106,    0,    0,  155,
    0,    0,    0,    0,    0,    0,    0, 1609, 1296, 1613,
  -32,    0,    0,    0,    0,  647,  623,
};
#define YYTABLESIZE 13001
short yytable[] = {                                     217,
  163,  462,  470,  856,  773,  214,  859,  235, 1310, 1197,
  756,  218, 1217,  532, 1278, 1279,  884,  855,  180,  877,
  602,  858, 1356,  478,  509, 1339,  370, 1373,  369,  617,
 1481,  573,  933,  481, 1210,  824, 1483,  481,  477,  541,
  994,  934,  735,  371,  736,  885,  999,  674,  836, 1209,
  611,  602,  602,  602,  602,  602,  181,  602,  865,  313,
  510,  168,  573,  311,  574,  573,  574,  231,  602,  542,
  232,  902,  372,  602,  332,  338,  903,  698,  376,  573,
  388,  611,  611,  611,  611,  611,  511,  611,  416,  425,
  774, 1336,  415,  424,  431,  428,  645, 1280,  611, 1357,
  434,  213, 1363,  611,  602,  639,  535,  471,  182,  183,
  533,  904, 1360,  618,  214,  536,  231,  184,  894,  232,
  373,  496,  374,  640,  219,  495,  429,  645,  502,  866,
  645, 1358,  534,  521,  611,  531,  639,  757,  482,  639,
  917, 1303,  482,  231,  645,  231,  232,  315,  232,  538,
  539,  540,  995,  639,  640,  905,  775,  640,  512,  547,
  550,  552,  321,  513, 1352,  514,  607,  215, 1281,  515,
 1359,  640,  994,  776,  621,  323,  231,  481,  432,  232,
  324,  623,  625,  627,  629,  631,  633,  635,  637,  639,
  641,  643,  645,  648,  650,  652, 1284, 1311, 1198,  657,
  659,  661,  663,  665,  667,  669,  671,  673,  675,  677,
  679,  681,  683, 1282, 1340,  325, 1374,  688, 1304, 1482,
  549,  549,  549, 1200,  692, 1484,  619,  620,  867,  868,
  869,  870,  375,  316,  522,  996, 1364,  484,  516, 1365,
  879,  185,  549,  549,  549,  549,  549,  549,  549,  549,
  549,  549,  549,  549,  549,  549,  549,  326, 1245,  327,
  549,  549,  549,  549,  549,  549,  549,  549,  549,  549,
  549,  549,  549,  549, 1422,  322,  215,  770, 1353,  186,
  627, 1307,  482,  187,  995,  830,  523, 1308,  641, 1305,
  642,  433, 1103,  188, 1443, 1444,  643,  942,  189,  190,
  994, 1524,  191, 1407,  464, 1354,  644,  715,  741,  742,
  743,  627,  627,  627,  627,  627,  831,  627,  646,  641,
  524,  642,  641, 1312,  642,  317,  771,  643,  627,  778,
  643,  997,  485,  627,  318,  728,  641,  644,  642,  473,
  644,  944,  580,  578,  643,  579, 1553,  581, 1247,  646,
 1205,  192,  646,  880,  644,  569,  193,  497,  628,  194,
  328,  498,  222,  584,  627,  195,  646,  906,  765,  795,
  796,  797,  798,  799,  800,  801,  802,  777,  196,  779,
  465,  466, 1248,  467,  197,  716,  567, 1423,  621,  628,
  628,  628,  628,  628,  582,  628,  499,  815,  474,  525,
  231,  566,  198,  232,  231,  475,  628,  232,  223, 1206,
  199,  628,  995,  827,  828, 1427, 1207,  200,  832,  629,
  201,  526,  397,  398,  838,  202,  203,  569,  204,  649,
  989,  504,  729,  481,  990,  505,  991,  205,  206,  207,
  500,  224,  628,  208,  476,  850,  717,  730,  612,  220,
  629,  629,  629,  629,  629, 1208,  629,  584,  567, 1245,
  649,  649,  649,  649,  649,  862,  649,  629,  811,  872,
  506,  876,  629, 1017, 1244,  699,  878,  649,  221,  612,
  612,  612,  612,  612,  887,  612,  584,  569,  584,  584,
  584,  584,  584,  468,  584, 1215,  612,  812, 1012,  907,
  992,  612,  209,  629, 1246,  584,  210,  588,  914, 1349,
  469,  211,  212,  649,  507,  236,  314,  582,  748,  501,
  319,  231,  320,  330,  232, 1524,  329,  927,  928,  929,
  930,  873,  612,  333,  935,  399,  400,  589,  482,  883,
 1523,  937,  939, 1443, 1444,  813,  993,  814,  377, 1275,
 1018, 1276, 1019,  394,  945,  946,  947,  948,  949,  950,
  951,  952,  953,  955,  957,  959,  961,  962,  231,  964,
 1525,  232,  231,  231,  803,  232,  232,  395,  974,  976,
  978,  980,  982,  396,  426,  427,  430, 1445,  985,  987,
  445,  566,  456,  508,  457,  480,  746,  744,  749,  745,
 1000,  747,  549,  463, 1011,  472, 1013,  479,  503,  580,
  578,  537,  579, 1020,  581, 1050, 1076,  569,  585,  586,
  587,  590,  610,  549,  549,  549,  549,  611,  549,  612,
  584,  549,  549,  549,  549,  549,  549,  549,  549,  549,
  549,  549,  549,  549,  576,  549,  613,  614,  748,  549,
 1414,  602,  602,  602,  602,  602,  602,  602,  602,  615,
  616,  582,  574,  574,  574,  574,  574,  574,  574,  574,
  845,  846,  847,  848,  654,  576,  655,  576,  576,  576,
  656,  611,  611,  611,  611,  611,  611,  611,  611,  685,
  686,  687,  576,  689,  690,  691,  693, 1144, 1145, 1146,
 1147, 1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155, 1156,
 1157, 1158,  696, 1160, 1161, 1162, 1163, 1164, 1165, 1166,
 1167, 1168, 1169, 1170, 1171, 1172, 1173,  645,  645,  694,
  695,  697,  594,  698,  699,  700,  639,  639, 1022, 1023,
 1179,  701,  583, 1024, 1180, 1181, 1182, 1183, 1184, 1185,
 1186, 1420,  702,  703,  640,  640,  704,  705,  706,  667,
  707,  708, 1194,  594,  594,  594,  594,  594,  709,  594,
  710,  711,  727,  164,  580,  578, 1203,  579, 1025,  581,
  594,  712,  713,  714,  566,  594,  617,  733,  566,  746,
  744,  732,  745,  564,  747,  584,  715,  716,  565, 1177,
 1178,  734,  717,  718,  719,  720,  721,  722, 1216, 1026,
  569,  723, 1027,  703,  569,  724,  594,  617,  617,  617,
  617,  617, 1028,  617,  725,  566,  582,  726,  738, 1222,
  746,  744,  739,  745,  617,  747,  751, 1225,  753,  617,
  610,  748,  580, 1230,  740,  567,  750,  581,  752,  754,
  755,  569,  615,  795,  796,  797,  798,  799,  800,  801,
  802, 1029,  758,  584,  759,  760,  761,  679,  763,  764,
  617,  610,  610,  610,  610,  610,  766,  610,  769,  702,
  767,  768,  748,  615,  615,  615,  615,  615,  610,  615,
  772,  804,  809,  610,  582,  780, 1252,  807,  816,  810,
  615, 1253,  806,  808,  817,  615,  818,  819,  820,  839,
  821,  627,  627,  627,  627,  627,  627,  627,  627,  641,
  641,  642,  642, 1260,  610,  841,  822,  643,  643,  823,
  825, 1261,  548,  551,  553,  842,  615,  644,  644,  852,
  648,  570,  571,  572,  573,  574,  575,  576,  577,  646,
 1286,  826,  833,  834,  624,  626,  628,  630,  632,  634,
  636,  638,  640,  642,  644,  646,  573,  651,  653,  835,
  840,  844,  658,  660,  662,  664,  666,  668,  670,  672,
  674,  676,  678,  680,  682,  684,  633,  860, 1277,  628,
  628,  628,  628,  628,  628,  628,  628,  573,  854,  853,
  573,  549,  566, 1268,  857, 1288,  861,  746,  863, 1292,
  864,  874,  747,  718,  573,  875,  888,  633,  633,  633,
  633,  633,  889,  633,  890,  912,  932, 1313,  569,  891,
 1316,  936, 1314, 1315,  633,  892, 1326, 1333,  940,  633,
 1325, 1332, 1334, 1335,  893,  895,  897,  898, 1050,  899,
  629,  629,  629,  629,  629,  629,  629,  629, 1176,  748,
  649,  649,  649,  649,  649,  649,  649,  649,  900,  435,
  633, 1370, 1372, 1076,  908,  909,  569,  941,  910,  612,
  612,  612,  612,  612,  612,  612,  612, 1378,  584,  584,
  584,  584,  584,  584,  584,  584,  638,  911,  913,  915,
  881, 1380, 1382,  916,  918,  942,  919,  569,  569,  569,
  569,  569,  920,  569,  921,  922,  924,  925,  569, 1388,
 1389, 1390,  988, 1392,  569, 1394,  926,  638,  584,  569,
  638, 1396, 1398,  566, 1001, 1002, 1014, 1111,  746,  744,
  573,  745, 1015,  747,  638, 1016, 1110, 1112, 1141,  549,
 1142,  795,  796,  797,  798,  799,  800,  801,  802,  569,
  569, 1143,  549,  549, 1159, 1174, 1175,  734,  436, 1187,
  437,  573,  734,  734,  573,  734, 1188,  734,  438,  225,
  439, 1189, 1190,  549,  226,  549,  334,  549,  573, 1191,
  748, 1192,  549,  549, 1193,  554,  555,  556,  557,  558,
  559,  560,  561, 1419, 1195, 1196, 1212,  882, 1421, 1199,
 1213, 1201, 1425, 1202, 1204,  440, 1211, 1214, 1218,  227,
 1219, 1220,  335, 1223,  734,  137,  138, 1430, 1221,  228,
  336, 1432, 1224, 1226, 1227, 1232, 1434, 1435, 1436, 1228,
 1229, 1438, 1233, 1440, 1441, 1234, 1447, 1235, 1238, 1239,
 1448,  441, 1240, 1242,  141,  142,  143,  144,  145,  146,
  147,  229, 1243,  230, 1455, 1456, 1251, 1255, 1256, 1459,
 1257, 1424, 1258, 1262, 1254,  576,  576,  576,  576,  576,
  576,  576,  576, 1259,  231, 1263, 1265,  232,  231, 1295,
 1272,  232, 1273, 1296, 1464, 1274, 1285, 1287, 1289,  442,
 1290, 1291, 1293, 1297, 1298,  549, 1299, 1300, 1301, 1302,
 1309, 1317, 1341, 1318,  938, 1319, 1337, 1470, 1344, 1345,
 1338, 1362, 1343, 1346, 1475, 1347, 1350, 1355, 1361, 1367,
 1376,  549, 1404, 1406, 1411,  954,  956,  958,  960, 1368,
  963, 1479,  337,  966,  967,  968,  969,  970,  971,  972,
  973,  975,  977,  979,  981,  983, 1267,  984, 1375, 1412,
 1415,  986,  734,  594,  594,  594,  594,  594,  594,  594,
  594, 1431, 1384,  570,  571,  572,  573,  574,  575,  576,
  577, 1439, 1454, 1385, 1457, 1386, 1458, 1387, 1400,  734,
 1461, 1413, 1468,  734,  734,  734,  734,  734, 1417,  734,
  443, 1485, 1508, 1492, 1493, 1510, 1515, 1512, 1418, 1513,
  734, 1426, 1494, 1428, 1495, 1516, 1518,  617,  617,  617,
  617,  617,  617,  617,  617, 1519, 1520, 1529, 1433, 1527,
  555,  556,  557,  558,  559,  560,  561, 1437, 1450, 1522,
 1530, 1537, 1451,  881, 1462,  734,  734, 1463, 1465, 1466,
 1467, 1469, 1535, 1536, 1471, 1472, 1473, 1540, 1474, 1476,
 1477, 1542, 1478, 1480, 1543, 1509, 1514, 1511, 1517, 1544,
 1534,  610,  610,  610,  610,  610,  610,  610,  610, 1551,
  446,  570, 1557,  615,  615,  615,  615,  615,  615,  615,
  615, 1545, 1556, 1546, 1547, 1558, 1548, 1549,  447, 1560,
 1568, 1570, 1574, 1576,  448,  449, 1582, 1577, 1583, 1587,
 1594,  732,  570,  570,  570,  570,  570, 1596,  570, 1541,
 1597, 1559, 1600, 1561, 1601, 1564, 1565, 1603, 1567,  570,
 1605, 1569,  446, 1571,  570, 1606, 1608, 1612,  732, 1575,
  450,  451,  732,  732,  732,  732,  732,    1,  732, 1610,
  447,  104,   19, 1580,  343, 1581,  448,  449,  142,  732,
  346,   88,   89,  546,  156,  570, 1586,  170,  137,  138,
 1589,  139, 1591, 1592,  152,  167,  127,  481,  480,  229,
  452,  230,  453,   16,  549,  195,  194,  197, 1598,  196,
 1599,  565,  450,  451,  732,  732, 1602,  141,  142,  143,
  144,  145,  146,  147, 1607,  557,  566,  558,  317, 1611,
  573,  320,  365, 1614,  366, 1616,   49,  633,  633,  633,
  633,  633,  633,  633,  633,  228,   50,  171,  129,  326,
  323,  851,  452,  734,  453,  734,  734,  732,  454,  198,
   35,  573,  732,  732,  573,  732,  556,  732,  571,   79,
  554,  567,  563,  341,  256,  551,  552,   80,  573,  389,
  568,  564,   96,  580,  578,  734,  579,  143,  581,  734,
  157,  734,  553,  199,  193,   34,  555,  136, 1563,  571,
  571,  571,  571,  571,  584,  571, 1351,  805,  734,  137,
  138,   54,   55,  392,  732,  734,  571,  393, 1342, 1377,
  734,  571,    0,    0,    0,   59,  734,  569,  569,  569,
  569,  569,  569,  569,  569,  582,    0,    0,  141,  142,
  143,  144,  145,  146,  147,    0,    0,    0,  568,    0,
    0,    0,  571,    0,    0,  734,    0,  734,    0,  556,
  557,  558,  559,  560,  561,    0,    0,    0,    0,  734,
    0,    0,    0,    0,    0,  566,    0,    0,    0,  734,
  564,  562,    0,  563,    0,  565,  734,    0,    0,  734,
    0,  734,  734,  734,  734,  734,  734,  734,  734,  734,
    0,  569,  732,  734,  732,  732,    0,  734,    0,    0,
  734,    0,    0,    0,  665,    0,    0,    0,    0,    0,
  734,  734,  734,  734,  734,    0,  734,    0,    0,    0,
    0,    0,  567,    0,  732,    0,    0,    0,  732,    0,
  732,  665,    0,  734,  734,  665,  665,  665,  665,  665,
    0,  665,    0,    0,    0,    0,    0,  732,    0,    0,
    0,    0,  665,    0,  732,    0,    0,    0,    0,  732,
    0,    0,    0,    0,    0,  732,    0,  734,  734,  734,
    0, 1379,    0,    0,    0,  734,    0,    0,    0,    0,
    0,    0,  734,  734, 1381, 1383,  734,  665,    0,  390,
  391,  734,    0,    0,  732,    0,  732,  653,    0,  734,
    0,    0,    0,  734,    0, 1391,    0, 1393,  732, 1395,
    0,    0,    0,    0, 1397, 1399,    0,    0,  732,    0,
    0,    0,    0,    0,  653,  732,    0,    0,  732,  653,
  653,    0,  653,    0,  653,  139,  140,    0,  732,    0,
    0,    0,  732,    0,    0,    0,  732,    0,    0,  732,
  653,    0,    0,    0,    0,    0,    0,    0,  652,  732,
  732,  732,  732,  732,    0,  732,    0,    0,  148,  149,
    0,    0,    0,  150,  151,    0,    0,    0,    0,    0,
    0,  653,  732,  732,    0,  652,    0,    0,    0,    0,
  652,  652,    0,  652,    0,  652,    0,    0,    0,    0,
    0,  734,    0,  734,  734,  734,  734,  734,  734,  734,
  734,  652,    0,    0,  654,    0,  732,  732,  732,    0,
    0,    0,    0,    0,  732,    0,    0, 1442,    0,    0,
    0,  732,  732,    0,    0,  732,    0,    0,    0,    0,
  732,  654,  652,    0,    0,    0,  654,  654,  732,  654,
    0,  654,  732, 1460,    0,    0,  663,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  654,    0,    0,
    0,    0,    0,    0,    0,  665,    0,  665,  665,    0,
    0,    0,    0,  663,    0,    0,  573,  663,  663,  663,
  663,  663,    0,  663,    0,    0,    0,    0,  654,    0,
    0,    0,    0,    0,  663,    0,    0,  665,    0,    0,
    0,  665,    0,  665,    0,    0,    0,  573,    0,  578,
  573,  578,  570,  570,  570,  570,  570,  570,  570,  570,
  665,    0,    0,    0,  573,    0,    0,  665,    0,  663,
    0,  573,  665,    0,    0,    0,    0,    0,  665,  572,
  732,    0,  732,  732,  732,  732,  732,  732,  732,  732,
    0,    0,    0,    0,    0,    0,    0,    0,  663,    0,
    0,    0,  573,  582,  582,  573,  582,  665,  582,  665,
  572,  572,  572,  572,  572,    0,  572,    0,    0,  573,
    0,  665,    0,    0,    0,    0,    0,  572,    0,    0,
    0,  665,  572,    0,    0,    0,    0,    0,  665,    0,
    0,  665,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  665,    0,    0,    0,  665,    0,    0,    0,  665,
    0,    0,  665,  572,    0,    0,  664,    0,    0,    0,
    0,    0,  665,  665,  665,  665,  665,    0,  665,    0,
    0,  732,  732,  732,  732,  732,  732,  732,  732,    0,
    0,    0,    0,  664,    0,  665,  665,  664,  664,  664,
  664,  664,    0,  664,  572,  573,  574,  575,  576,  577,
    0,    0,    0,    0,  664,    0,    0,    0,    0,  571,
  571,  571,  571,  571,  571,  571,  571,    0,    0,  665,
  665,  665,    0,    0,    0,    0, 1562,  665,    0,    0,
    0,    0,    0,    0,  665,  665,    0,    0,  665,  664,
    0,    0,    0,  665,    0,  655,    0,  663,    0,  663,
  663,  665,    0,    0,    0,  665,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  655,    0,    0,    0,    0,  655,  655,  663,
  655,    0,  655,  663,    0,  663,    0,    0,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,  655,    0,
    0,    0,  663,    0,    0,    0,    0,    0,    0,  663,
    0,    0,    0,    0,  663,    0,    0,    0,    0,    0,
  663,    0,    0,    0,    0,    0,    0,    0,    0,  655,
    0,    0,    0,  588,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  663,
    0,  663,    0,  665,    0,  665,  665,  665,  665,  665,
  665,  665,  665,  663,  588,  588,  588,  588,  588,    0,
  588,    0,    0,  663,    0,    0,    0,    0,    0,    0,
  663,  588,    0,  663,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  663,    0,    0,    0,  663,    0,    0,
    0,  663,    0,    0,  663,    0,    0,    0,  666,    0,
    0,    0,    0,    0,  663,  663,  663,  663,  663,    0,
  663,    0,    0,    0,    0,    0,    0,  664,    0,  664,
  664,    0,    0,    0,    0,  666,    0,  663,  663,  666,
  666,  666,  666,  666,    0,  666,    0,    0,  653,  653,
  653,  653,  653,  653,  653,  653,  666,    0,    0,  664,
    0,    0,    0,  664,    0,  664,    0,    0,    0,    0,
    0,  663,  663,  663,    0,    0,    0,    0,    0,  663,
    0,    0,  664,    0,    0,    0,  663,  663,    0,  664,
  663,  666,    0,  573,  664,  663,    0,    0,    0,    0,
  664,  647,    0,  663,    0,    0,    0,  663,    0,  652,
  652,  652,  652,  652,  652,  652,  652,    0,    0,    0,
  664,    0,  569,    0,  573,  586,  586,  573,  586,  664,
  586,  664,  647,  647,  647,  647,  647,    0,  647,    0,
    0,  573,    0,  664,    0,    0,    0,    0,    0,  647,
    0,    0,    0,  664,  569,  569,    0,  569,    0,  569,
  664,    0,    0,  664,    0,  654,  654,  654,  654,  654,
  654,  654,  654,  664,    0,  569,    0,  664,    0,    0,
    0,  664,    0,    0,  664,  647,    0,    0,  661,    0,
    0,    0,    0,    0,  664,  664,  664,  664,  664,    0,
  664,    0,    0,    0,    0,  663,  569,  663,  663,  663,
  663,  663,  663,  663,  663,    0,    0,  664,  664,  661,
    0,  661,  661,  661,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  661,  578,  578,  578,
  578,  578,  578,  578,  578,    0,    0,    0,    0,    0,
    0,  664,  664,  664,    0,    0,    0,    0,    0,  664,
    0,    0,    0,    0,    0,    0,  664,  664,    0,    0,
  664,  661,    0,    0,    0,  664,    0,  570,    0,  666,
    0,  666,  666,  664,    0,    0,    0,  664,    0,  573,
    0,    0,  582,  582,  582,  582,  582,  582,  582,  582,
  572,  572,  572,  572,  572,  572,  572,  572,    0,  570,
  570,  666,  570,    0,  570,  666,  666,  666,    0,    0,
  573,  590,  590,  573,  590,    0,  590,    0,  580,  578,
  570,  579,    0,  581,  666,    0,    0,  573,    0,    0,
    0,  666,    0,    0,    0,    0,  666,    0,    0,  584,
    0,    0,  666,    0,    0,    0,    0,    0,    0,    0,
    0,  570,    0,    0,    0,  591,    0,    0,    0,    0,
    0,    0,    0,    0,  656,    0,    0,    0,    0,    0,
  582,  666,    0,  666,    0,  664,  573,  664,  664,  664,
  664,  664,  664,  664,  664,  666,  591,  591,  591,  591,
  591,  656,  591,    0,    0,  666,  656,  656,  580,  656,
    0,  656,  666,  591,    0,  666,    0,  573,  585,  585,
  573,  585,    0,  585,    0,  666,    0,  656,    0,  666,
    0,    0,    0,  666,  573,    0,  666,    0,    0,  580,
  662,  580,  580,  580,    0,    0,  666,  666,  666,  666,
  666,    0,  666,    0,    0,    0,  580,    0,  656,  661,
    0,  661,  661,    0,    0,  573,    0,    0,    0,  666,
  666,  662,    0,  662,  662,  662,  655,  655,  655,  655,
  655,  655,  655,  655,    0,    0,    0,    0,  662,    0,
    0,  661,    0,    0,    0,  661,  573,  661,  577,  573,
  577,    0,    0,  666,  666,  666,    0,    0,    0,  583,
    0,  666,    0,  573,  661,    0,    0,    0,  666,  666,
    0,  661,  666,  662,    0,  575,  661,  666,    0,    0,
    0,    0,  661,    0,    0,  666,    0,    0,    0,  666,
  583,  583,  583,  583,  583,  573,  583,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  575,  583,  575,  575,
  575,  661,    0,  661,  588,  588,  588,  588,  588,  588,
  588,  588,    0,  575,    0,  661,  573,  589,  589,  573,
  589,    0,  589,    0,    0,  661,  587,    0,    0,    0,
    0,    0,  661,  573,    0,  661,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  661,    0,    0,    0,  661,
    0,    0,    0,  661,    0,    0,  661,  587,  587,  587,
  587,  587,  573,  587,    0,    0,  661,  661,  661,  661,
  661,  593,  661,    0,  587,    0,    0,  666,    0,  666,
  666,  666,  666,  666,  666,  666,  666,  573,    0,  661,
  661,    0,    0,  573,  592,  592,  573,  592,    0,  592,
    0,    0,  593,  593,  593,  593,  593,    0,  593,    0,
  573,  580,  578, 1088,  579,    0,  581,    0,  573,  593,
  581,  573,  581,  661,  661,  661,    0,    0,    0,  381,
    0,  661,  584,    0,    0,  573,    0,    0,  661,  661,
    0,    0,  661,    0,    0,    0,    0,  661,    0,  571,
    0,  662,    0,  662,  662,  661,    0,    0,    0,  661,
    0,    0,    0,  582,  586,  586,  586,  586,  586,  586,
  586,  586,  647,  647,  647,  647,  647,  647,  647,  647,
    0,  571,  571,  662,  571,    0,  571,  662,  572,  662,
    0,    0,    0,  569,  569,  569,  569,  569,  569,  569,
  569,  579,  571,    0,    0,    0,  662,    0,    0,    0,
    0,    0,    0,  662,    0,    0,    0,    0,  662,    0,
  572,  572,    0,  572,  662,  572,    0,    0,    0,    0,
    0,    0,  579,  571,  579,  579,  579,    0,    0,    0,
    0,  572,    0,    0,    0,    0,    0,    0,    0,  579,
    0,    0,    0,  662,    0,  662,    0,  661,    0,  661,
  661,  661,  661,  661,  661,  661,  661,  662,    0,    0,
    0,    0,  572,    0,    0,    0,    0,  662,    0,    0,
    0,    0,    0,    0,  662,    0,  566,  662,    0,    0,
    0,  746,  744,  762,  745,    0,  747,  662,    0,    0,
    0,  662,    0,    0,    0,  662,    0,    0,  662,    0,
    0,    0,  569,    0,    0,    0,    0,    0,  662,  662,
  662,  662,  662,    0,  662,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  662,  662,  748,    0,    0,    0,    0,  570,  570,
  570,  570,  570,  570,  570,  570,    0,    0,    0,    0,
  590,  590,  590,  590,  590,  590,  590,  590,  571,  572,
  573,  574,  575,  576,  577,  662,  662,  662,    0,    0,
    0,    0,    0,  662,    0,    0,    0,    0,    0,    0,
  662,  662,    0,    0,  662,    0,    0,    0,    0,  662,
  381,    0,  381,  381,    0,    0,    0,  662,  566,    0,
    0,  662,    0,  746,  744,  829,  745,    0,  747,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  781,    0,
    0,    0,  381,    0,  569,  782,  591,  591,  591,  591,
  591,  591,  591,  591,    0,  656,  656,  656,  656,  656,
  656,  656,  656,    0,    0,  381,    0,  585,  585,  585,
  585,  585,  585,  585,  585,  748,    0,  381,    0,    0,
    0,    0,    0,  381,    0,    0,    0,    0,    0,  580,
  580,  580,  580,  580,  580,  580,  580,    0,    0,    0,
    0,  783,  784,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  380,    0,    0,    0,  662,
    0,  662,  662,  662,  662,  662,  662,  662,  662,  387,
    0,    0,    0,    0,    0,    0,  381,    0,  785,  786,
  787,    0,    0,    0,    0,    0,  577,  577,  577,  577,
  577,  577,  577,  577,  730,    0,  381,    0,    0,    0,
    0,    0,    0,    0,  381,    0,    0,  381,    0,    0,
    0,    0,    0,    0,  788,    0,    0,  381,  381,  381,
  381,  381,    0,  381,    0,  730,    0,    0,  730,    0,
  583,  583,  583,  583,  583,  583,  583,  583,    0, 1080,
  580,  578,  730,  579,    0,  581,  575,  575,  575,  575,
  575,  575,  575,  575,    0,    0,  789,    0,    0,    0,
    0,  584,    0,  790,  791,    0,  589,  589,  589,  589,
  589,  589,  589,  589,    0,  381,    0,  730,    0,    0,
    0,    0,  381,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  582,    0,    0,    0,    0,    0,    0,    0,
  792,    0,    0,    0,  793,    0,  381,  587,  587,  587,
  587,  587,  587,  587,  587,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  592,  592,  592,  592,  592,  592,  592,
  592,    0,  593,  593,  593,  593,  593,  593,  593,  593,
  570,  571,  572,  573,  574,  575,  576,  577,  581,  581,
  581,  581,  581,  581,  581,  581,  724,    0,    0,    0,
    0,    0,    0,    0,    0,  566,    0,    0,    0,    0,
  746,  744,  837,  745,    0,  747,    0, 1082,  580,  578,
    0,  579,    0,  581,    0,    0,  378,  724,  381,    0,
  724,  569,    0,    0,    0,    0,    0,    0,    0,  584,
    0,    0,    0,    0,  724,    0,  380,    0,  380,  380,
  571,  571,  571,  571,  571,  571,  571,  571,    0,    0,
    0,    0,  748,    0,    0,    0,    0,    0,  379,    0,
  582,    0,    0,    0,    0,  380,    0,    0,  380,  724,
    0,    0,    0,    0,    0,  730,    0,  730,  730,  572,
  572,  572,  572,  572,  572,  572,  572,    0,    0,    0,
    0,  380,  579,  579,  579,  579,  579,  579,  579,  579,
    0,    0,    0,  380,    0,    0,    0,  730,    0,  380,
    0,  730,  381,  730,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  730,  382,    0,    0,    0,  725,    0,  730,    0,    0,
    0,    0,  730,    0,    0,    0,    0,    0,  730,  383,
  554,  555,  556,  557,  558,  559,  560,  561,    0,    0,
    0,    0,  380,    0,    0,    0,  725,    0,    0,  725,
    0,    0,    0,    0,    0,    0,    0,  730,    0,  730,
    0,  231,  380,  725,  232,    0,    0,    0,    0,    0,
  380,  730,    0,  380, 1084,  580,  578,    0,  579,    0,
  581,  730,    0,  380,  380,  380,  380,  380,  730,  380,
    0,  730,    0,    0,    0,    0,  584,    0,  725,    0,
    0,  730,    0,    0,    0,  730,    0,    0,    0,  730,
    0,    0,  730,    0,    0,    0,    0,  384,    0,    0,
    0,    0,  730,  730,  730,  730,  730,  582,  730,    0,
  385,    0,    0,    0,    0,    0,    0,  724,    0,  724,
  724,  380,    0,    0,    0,  730,  730,    0,  380,    0,
  386,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  724,
    0,    0,  380,  724,    0,  724,    0,    0,    0,  730,
  730,  730,    0,  566,    0,    0,    0,  730,  746,  744,
  843,  745,  724,  747,  730,  730,    0,  726,  730,  724,
    0,    0,    0,  730,  724,    0,    0,    0,    0,  569,
  724,  730,    0,    0,    0,  730,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  726,    0,
    0,  726,    0,    0,    0,    0,    0,    0,    0,  724,
  748,  724,    0,    0,    0,  726,    0,    0,    0,    0,
    0,    0,    0,  724,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  724,    0,    0,    0,    0,    0,    0,
  724,    0,    0,  724,  380,    0,    0,    0,    0,    0,
  726,    0,    0,  724,    0,    0,  725,  724,  725,  725,
    0,  724,    0,    0,  724,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  724,  724,  724,  724,  724,    0,
  724,    0,    0,  730,    0,  730,  730,    0,  725,    0,
    0,    0,  725,    0,  725,    0,    0,  724,  724,  570,
  571,  572,  573,  574,  575,  576,  577,    0,    0,    0,
    0,  725,    0,    0,  591,  592,    0,    0,  725,    0,
    0,    0,    0,  725,    0,    0,    0,    0,  727,  725,
    0,  724,  724,  724,    0,    0,    0,  593,    0,  724,
    0,    0,    0,  594,    0,    0,  724,  724,    0,  595,
  724,  596,    0,    0,    0,  724,    0,    0,  725,  727,
  725,    0,  727,  724,    0,    0,    0,  724,    0,    0,
  597,    0,  725,    0,    0,    0,  727,    0,    0,    0,
    0,    0,  725,    0,    0,    0,    0,    0,    0,  725,
    0,  598,  725,  599,    0,    0,    0,    0,    0,    0,
    0,    0,  725,    0,    0,  600,  725,    0,    0,    0,
  725,  727,    0,  725,  231,    0,    0,  232,    0,    0,
    0,    0,    0,  725,  725,  725,  725,  725,    0,  725,
    0,    0,    0,    0,    0,    0,    0,  601,  726,    0,
  726,  726,    0,    0,    0,    0,  725,  725,    0,  554,
  555,  556,  557,  558,  559,  560,  561,  570,  571,  572,
  573,  574,  575,  576,  577,  724,    0,  724,  724,    0,
  726,    0,  602,  603,  726,    0,  726,    0,    0,    0,
  725,  725,  725,    0,    0,    0,    0,    0,  725,    0,
    0,    0,    0,  726,  604,  725,  725,    0,    0,  725,
  726,    0,  728,  605,  725,  726,    0,    0,    0,    0,
    0,  726,  725,    0,    0,    0,  725,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  728,    0,    0,  728,  606,    0,  566,
  726,  729,  726,    0,  746,  744,  896,  745,    0,  747,
  728,    0,    0,    0,  726,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  726,  569,    0,    0,    0,    0,
    0,  726,  729,    0,  726,  729,    0,    0,    0,    0,
    0,    0,    0,    0,  726,  728,    0,    0,  726,  729,
    0,    0,  726,    0,    0,  726,  748,    0,    0,  727,
    0,  727,  727,    0,    0,  726,  726,  726,  726,  726,
    0,  726,    0,    0,  725,    0,  725,  725,    0,    0,
    0,    0,    0,    0,  729,    0,    0,    0,  726,  726,
    0,  727,    0,    0,    0,  727,    0,  727,    0,    0,
    0,    0,    0,    0,  570,  571,  572,  573,  574,  575,
  576,  577,    0,    0,  727,    0,    0,    0,    0,    0,
    0,  727,  726,  726,  726,    0,  727,    0,    0,    0,
  726,    0,  727,    0,    0,    0,    0,  726,  726,    0,
    0,  726,    0,    0,    0,    0,  726,    0,    0,    0,
    0,    0,    0,    0,  726,    0,    0,    0,  726,    0,
    0,  727,    0,  727,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  727,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  727,    0,    0,    0,    0,
    0,    0,  727,    0,    0,  727,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  727,    0,    0,    0,  727,
    0,    0,    0,  727,  731,    0,  727,  554,  555,  556,
  557,  558,  559,  560,  561,    0,  727,  727,  727,  727,
  727,    0,  727,  728,    0,  728,  728,    0,    0,    0,
    0,    0,  426,    0,    0,  731,    0,    0,  731,  727,
  727,    0,    0,    0,    0,    0,  726,    0,  726,  726,
    0,    0,  731,    0,    0,  728,    0,    0,    0,  728,
    0,  728,  729,    0,  729,  729,    0,    0,    0,    0,
    0,    0,    0,  727,  727,  727,    0,    0,  728,    0,
    0,  727,    0,    0,    0,  728,    0,  731,  727,  727,
  728,    0,  727,    0,  729,    0,  728,  727,  729,    0,
  729,    0,    0,    0,    0,  727,    0,    0,    0,  727,
  566,    0,    0,    0,  943,  564,  562,  729,  563,    0,
  565,    0,    0,    0,  729,  728,    0,  728,    0,  729,
    0,    0,    0,    0,    0,  729,  569,    0,    0,  728,
    0,    0,  566,    0,    0,    0, 1079,  564,  562,  728,
  563,    0,  565,  723,    0,    0,  728,    0,    0,  728,
    0,    0,    0,    0,  729,    0,  729,  567,  569,  728,
    0,    0,    0,  728,    0,    0,    0,  728,  729,    0,
  728,    0,    0,    0,  723,    0,    0,  723,  729,    0,
  728,  728,  728,  728,  728,  729,  728,    0,  729,  567,
    0,  723,    0,    0,    0,    0,    0,  727,  729,  727,
  727,    0,  729,  728,  728,    0,  729,    0,    0,  729,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  729,
  729,  729,  729,  729,    0,  729,  723,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  728,  728,  728,
    0,    0,  729,  729,    0,  728,    0,    0,    0,    0,
    0,    0,  728,  728,    0,    0,  728,    0,    0,    0,
  427,  728,    0,    0,    0,  731,    0,  731,  731,  728,
    0,    0,    0,  728,    0,    0,  729,  729,  729,    0,
    0,    0,    0,    0,  729,    0,    0,    0,    0,    0,
    0,  729,  729,    0,    0,  729,    0,  731,    0,    0,
  729,  731,    0,  731,    0,    0,  375,    0,  729,    0,
    0,    0,  729,    0,    0,    0,    0,    0,    0,    0,
  731,    0,    0,    0,    0,    0,    0,  731,    0,  426,
    0,  426,  731,    0,    0,  566,    0,    0,  731,    0,
  746,  744,  901,  745,    0,  747,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  426,  376,    0,    0,    0,
  426,  569,    0,    0,    0,    0,    0,  731,    0,  731,
    0,  728,    0,  728,  728,    0,    0,    0,    0,    0,
    0,  731,    0,  554,  555,  556,  557,  558,  559,  560,
  561,  731,  748,    0,    0,  426,    0,  426,  731,    0,
    0,  731,    0,    0,    0,    0,    0,    0,    0,  426,
  729,  731,  729,  729,  723,  731,  723,  723,    0,  731,
    0,    0,  731,    0,    0,    0,  426,    0,    0,  426,
    0,    0,  731,  731,  731,  731,  731,    0,  731,  426,
    0,    0,    0,  426,    0,    0,  723,    0,    0,    0,
  723,    0,  723,    0,    0,  731,  731,    0,    0,    0,
  426,    0,    0,  426,  426,    0,    0,  566,    0,  723,
    0,    0,  746,  744,  923,  745,  723,  747,    0,    0,
    0,  723,    0,  426,  426,  377,    0,  723,    0,  731,
  731,  731,    0,  569,    0,    0,    0,  731,    0,    0,
    0,    0,    0,    0,  731,  731,    0,    0,  731,    0,
    0,    0,    0,  731,    0,    0,  723,  426,  723,  426,
    0,  731,    0,    0,  748,  731,    0,    0,    0,    0,
  723,    0,  426,  426,  378,    0,  426,    0,    0,    0,
  723,    0,    0,    0,    0,    0,    0,  723,    0,  426,
  723,    0,    0,  426,    0,    0,    0,    0,    0,    0,
  723,    0,    0,    0,  723,    0,    0,  427,  723,  427,
    0,  723,    0,    0,    0,    0,    0,  375,    0,  375,
  375,  723,  723,  723,  723,  723,    0,  723,    0,    0,
    0,  566,    0,  427,  402, 1081,  564,  562,  427,  563,
    0,  565,    0,    0,  723,  723,    0,    0,  566,  375,
    0,    0,    0,  746,  744,  931,  745,  569,  747,    0,
    0,    0,    0,  731,    0,  731,    0,  376,    0,  376,
  376,    0,  375,  427,  569,  427,    0,    0,  723,  723,
  723,    0,    0,    0,  375,    0,  723,  427,  567,    0,
  375,  426,    0,  723,  723,    0,    0,  723,    0,  376,
    0,    0,  723,    0,  427,  748,    0,  427,    0,    0,
  723,    0,    0,    0,  723,    0,    0,  427,    0,    0,
    0,  427,  376,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  376,    0,    0,    0,  427,    0,
  376,  427,  427,  375,  554,  555,  556,  557,  558,  559,
  560,  561,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  427,  427,  375,    0,    0,    0,    0,    0,    0,
    0,  375,    0,    0,  375,    0,  554,  555,  556,  557,
  558,  559,  560,  561,  375,  375,  375,  375,  375,    0,
  375,    0,    0,  376,    0,  427,  377,  427,  377,  377,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  427,  427,  723,  376,  427,    0,    0,    0,    0,    0,
    0,  376,    0,    0,  376,    0,    0,  427,  377,    0,
    0,  427,    0,    0,  376,  376,  376,  376,  376,    0,
  376,    0,  375,    0,    0,  378,    0,  378,  378,  375,
    0,  377,  566,    0,    0,    0, 1083,  564,  562,    0,
  563,    0,  565,  377,    0,    0,    0,    0,    0,  377,
    0,    0,    0,  375,    0,  566,    0,  378,  569, 1085,
  564,  562,    0,  563,    0,  565,    0,    0,  566,    0,
    0,    0,  376,  564,  562, 1087,  563,    0,  565,  376,
  378,  569,    0,    0,    0,  402,    0,  402,  402,  567,
    0,    0,  378,    0,  569,    0,    0,    0,  378,    0,
  566,    0,  377,  376, 1089,  564,  562,    0,  563,  427,
  565,    0,  567,  566,    0,    0,    0,  402,  564,  562,
 1101,  563,  377,  565,    0,  567,  569,    0,    0,    0,
  377,    0,    0,  377,    0,    0,    0,    0,    0,  569,
  402,    0,    0,  377,  377,  377,  377,  377,    0,  377,
    0,  378,  402,    0,    0,  375,    0,  567,  402,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
  567,  378,    0,    0,    0,    0,    0,    0,    0,  378,
  566,    0,  378,    0, 1091,  564,  562,    0,  563,    0,
  565,    0,  378,  378,  378,  378,  378,    0,  378,    0,
    0,  377,    0,    0,    0,  376,  569,    0,  377,  566,
    0,  402,    0, 1093,  564,  562,    0,  563,  566,  565,
    0,    0, 1095,  564,  562,    0,  563,    0,  565,    0,
    0,  402,  377,    0,    0,  569,    0,  567,    0,  402,
    0,    0,  402,    0,  569,    0,    0,    0,    0,    0,
  378,    0,  402,  402,  402,  402,  402,  378,  402,  566,
    0,    0,    0, 1097,  564,  562,  567,  563,    0,  565,
    0,    0,    0,    0,  566,  567,    0,    0, 1099,  564,
  562,  378,  563,    0,  565,  569,    0,    0,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,  566,
  569,    0,    0, 1104,  564,  562,    0,  563,    0,  565,
  402,    0,    0,    0,  566,    0,  567,  402, 1106,  564,
  562,    0,  563,    0,  565,  569, 1086,  580,  578,    0,
  579,  567,  581,    0,  377,    0,    0,  566,    0,    0,
  569,  402,  564,  562, 1108,  563,    0,  565,  584,  566,
    0,    0,    0, 1113,  564,  562,  567,  563,    0,  565,
    0,    0,    0,  569,    0,    0,    0,    0,    0,    0,
    0,  567,  566,    0,    0,  569, 1115,  564,  562,  582,
  563,    0,  565,  378,    0,  566,    0,    0,    0, 1117,
  564,  562,    0,  563,  567,  565,    0,  566,  569,    0,
    0,    0,  564,  562, 1119,  563,  567,  565,    0,    0,
    0,  569,    0,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,  569,    0,    0,    0,    0,    0,  567,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
  566,    0,  567,  402,    0,  564,  562, 1121,  563,    0,
  565,  566,    0,    0,  567,    0,  564,  562, 1123,  563,
    0,  565,  566,    0,    0,    0,  569,  564,  562, 1125,
  563,    0,  565,    0,  566,    0,    0,  569, 1127,  564,
  562,    0,  563,    0,  565,  566,    0,    0,  569, 1129,
  564,  562,    0,  563,    0,  565,  566,  567,    0,    0,
  569,  564,  562, 1131,  563,    0,  565,    0,  567,    0,
  566,  569,    0,    0, 1133,  564,  562,    0,  563,  567,
  565,    0,  569,    0,  566,    0,    0,    0, 1135,  564,
  562,  567,  563,  566,  565,    0,  569, 1137,  564,  562,
    0,  563,  567,  565,    0,    0,    0,    0,    0,    0,
  569,    0,  566,  567,    0,    0, 1139,  564,  562,  569,
  563,    0,  565,    0,    0,  566,    0,  567,    0,  943,
  746,  744,    0,  745,    0,  747,    0,  566,  569,    0,
    0,  567,  746,  744, 1231,  745,    0,  747,  566,    0,
  567,  569,    0,  746,  744, 1236,  745,    0,  747,    0,
  566,    0,    0,  569,    0,  746,  744, 1237,  745,  567,
  747,    0,    0,    0,  569,    0,    0,    0,    0,    0,
    0,    0,  748,  566,    0,    0,  569,    0,  746,  744,
 1241,  745,    0,  747,  748,    0,  554,  555,  556,  557,
  558,  559,  560,  561,    0,  748,    0,    0,    0,  569,
    0,    0,    0,    0,    0,    0,    0,  748,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
  748, 1090,  580,  578,    0,  579,  566,  581,    0,    0,
    0,  746,  744, 1250,  745,    0,  747,    0,    0,    0,
    0,    0,    0,  584,  554,  555,  556,  557,  558,  559,
  560,  561,  569,    0,    0,    0,    0,  554,  555,  556,
  557,  558,  559,  560,  561,  566,    0,    0,    0,    0,
  746,  744, 1264,  745,  582,  747,  566,    0,    0,    0,
    0,  746,  744,  748,  745,    0,  747,  566,    0,    0,
    0,  569,  746,  744,    0,  745,    0,  747,    0,    0,
    0,    0,  569,    0,    0,    0,    0,    0, 1269,    0,
    0,    0,    0,  569,    0,    0,    0,    0,    0,    0,
    0,    0,  748,    0,  554,  555,  556,  557,  558,  559,
  560,  561, 1266,  748,    0,  566,    0,    0,    0,    0,
  746,  744,    0,  745,  748,  747,    0,    0,    0,    0,
    0,    0,    0,  554,  555,  556,  557,  558,  559,  560,
  561,  569,  554,  555,  556,  557,  558,  559,  560,  561,
  566,    0,    0,    0,    0,  746,  744, 1294,  745,    0,
  747,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1271,  748,    0,    0,    0,  569,    0,    0,    0,
    0,    0,    0,  554,  555,  556,  557,  558,  559,  560,
  561,    0,    0,    0,    0,    0,    0,    0,  554,  555,
  556,  557,  558,  559,  560,  561,    0,  748,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  554,  555,  556,  557,  558,  559,  560,
  561,    0,    0,    0,    0,    0,    0,    0,  554,  555,
  556,  557,  558,  559,  560,  561,  570,  571,  572,  573,
  574,  575,  576,  577,    0,    0,    0,    0,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,    0,
    0,    0,    0,  554,  555,  556,  557,  558,  559,  560,
  561,  566,    0,    0,    0, 1401,  746,  744,    0,  745,
    0,  747,    0,    0,    0,    0,  554,  555,  556,  557,
  558,  559,  560,  561,    0,    0,    0,  569,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,    0,
    0,    0,    0,    0,    0,    0,    0,  566,  748,    0,
    0, 1081,  746,  744,    0,  745,    0,  747,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  569,  554,  555,  556,  557,  558,  559,
  560,  561,    0,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,    0,    0,    0,  554,  555,  556,  557,
  558,  559,  560,  561,  748,    0,    0,    0,  554,  555,
  556,  557,  558,  559,  560,  561,    0,    0,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,    0,
    0,    0,    0,    0,  554,  555,  556,  557,  558,  559,
  560,  561,    0,    0,    0,    0,    0,    0,  554,  555,
  556,  557,  558,  559,  560,  561,    0,  554,  555,  556,
  557,  558,  559,  560,  561,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  554,  555,  556,  557,
  558,  559,  560,  561,    0,    0,    0,    0,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,    0,    0,    0,  554,  555,  556,  557,  558,  559,
  560,  561,  566,    0,    0,    0, 1083,  746,  744,    0,
  745,    0,  747,    0,    0,    0,    0,  554,  555,  556,
  557,  558,  559,  560,  561,    0,    0,    0,  569,    0,
    0,  566,    0,    0,    0, 1085,  746,  744,    0,  745,
  566,  747,    0,    0,    0,  746,  744, 1087,  745,    0,
  747,    0,    0,    0,    0,    0,    0,  569,    0,  748,
    0,    0,    0,    0,    0,    0,  569,    0,    0,    0,
    0,  570,  571,  572,  573,  574,  575,  576,  577,    0,
  554,  555,  556,  557,  558,  559,  560,  561,  748,    0,
    0,    0,    0,    0,    0,    0,    0,  748,    0,    0,
    0,  566,    0,    0,    0, 1089,  746,  744,    0,  745,
    0,  747,    0,    0,    0,    0,    0,    0,    0,  554,
  555,  556,  557,  558,  559,  560,  561,  569,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,  566,
    0,    0,    0, 1091,  746,  744,    0,  745,  748,  747,
  566,    0,    0,    0, 1093,  746,  744,    0,  745,    0,
  747,    0,    0,    0,    0,  569,    0,  566,    0,    0,
    0, 1095,  746,  744,    0,  745,  569,  747,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
    0,    0,    0,  569,    0,    0,  748,    0,    0,    0,
  566,    0,    0,    0, 1097,  746,  744,  748,  745,    0,
  747,    0,    0,    0,  554,  555,  556,  557,  558,  559,
  560,  561,    0,  566,  748,    0,  569, 1099,  746,  744,
    0,  745,  566,  747,    0,    0,    0,  746,  744, 1402,
  745,    0,  747,    0,    0,    0,  566,    0,    0,  569,
 1104,  746,  744,    0,  745,  566,  747,  748,  569, 1106,
  746,  744,    0,  745,    0,  747,    0,    0,  566,    0,
    0,    0,  569,  746,  744, 1403,  745,    0,  747,    0,
  748,  569,  566,    0,    0,    0, 1113,  746,  744,  748,
  745,    0,  747,    0,  569,    0,  566,    0,    0,    0,
 1115,  746,  744,  748,  745,  566,  747,    0,  569, 1117,
  746,  744,  748,  745,    0,  747,    0,    0,    0,    0,
    0,    0,  569,    0,    0,  748,    0,    0,  566,    0,
    0,  569,    0,  746,  744, 1119,  745,    0,  747,  748,
    0,    0,    0,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,  748,  569,    0,    0,    0,  566,    0,
    0,    0,  748,  746,  744, 1121,  745,  566,  747,    0,
    0,    0,  746,  744, 1123,  745,    0,  747,    0,    0,
    0,    0,    0,    0,  569,  748,    0,    0,    0,    0,
  566,    0,    0,  569,    0,  746,  744, 1125,  745,    0,
  747,  554,  555,  556,  557,  558,  559,  560,  561,    0,
    0,    0,    0,  566,    0,  748,  569, 1127,  746,  744,
    0,  745,  566,  747,  748,    0, 1129,  746,  744,    0,
  745,    0,  747,    0,    0,  566,    0,    0,    0,  569,
  746,  744, 1405,  745,    0,  747,  566,  748,  569,    0,
 1133,  746,  744,    0,  745,    0,  747,    0,  566,    0,
    0,  569, 1135,  746,  744,    0,  745,    0,  747,    0,
  748,    0,  569,    0,    0,    0,    0,    0,    0,  748,
    0,  566,    0,    0,  569, 1137,  746,  744,    0,  745,
  566,  747,  748,    0, 1139,  746,  744,    0,  745,    0,
  747,    0,    0,  748,  566,    0,    0,  569,    0,  746,
  744,    0,  745,  566,  747,  748,  569,    0,  746,  744,
 1409,  745,    0,  747,    0,    0,  566,    0,    0,    0,
  569,  746,  744,    0,  745,    0,  747,    0,  748,  569,
 1092,  580,  578,    0,  579,    0,  581,  748,  566,    0,
    0,    0,  569,  746,  744, 1416,  745,    0,  747,  566,
 1408,  748,  584,    0,  746,  744, 1429,  745,    0,  747,
  748,    0,    0,    0,  569,    0,    0,    0,    0,    0,
    0,    0, 1410,  748,    0,  569,    0,    0,    0,    0,
    0,    0,    0,  582,    0,    0,  554,  555,  556,  557,
  558,  559,  560,  561,    0,  748,    0,  566,    0,    0,
    0,    0,  746,  744, 1449,  745,  748,  747,    0,    0,
    0,    0,    0,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,  569,  554,  555,  556,  557,  558,  559,
  560,  561,    0,    0,    0,    0,  566,    0,    0,    0,
    0,  746,  744, 1452,  745,  566,  747,    0,    0,    0,
  746,  744, 1453,  745,  748,  747,    0,    0,    0,    0,
    0,    0,  569,    0,    0,    0,    0,    0,  566,    0,
    0,  569, 1486,  746,  744,    0,  745,    0,  747,    0,
    0,    0,    0,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,  748,  569,  566,    0,    0,    0, 1488,
  564,  562,  748,  563,    0,  565,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  569,    0,    0,    0,  748,    0,    0,    0,    0,
    0,    0,    0,  554,  555,  556,  557,  558,  559,  560,
  561,    0,    0,    0,  554,  555,  556,  557,  558,  559,
  560,  561,  567,    0,    0,    0,    0,    0,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,    0,
    0,    0,    0,    0,    0,    0,    0,  566,    0,    0,
    0, 1490,  564,  562,    0,  563,    0,  565,    0,    0,
    0,    0,    0,    0,  554,  555,  556,  557,  558,  559,
  560,  561,    0,  569,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  554,  555,  556,
  557,  558,  559,  560,  561,    0,  554,  555,  556,  557,
  558,  559,  560,  561,  567,    0,    0,    0,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,    0,    0,    0,    0,    0,  554,  555,  556,  557,
  558,  559,  560,  561,    0,    0,    0,    0,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,  554,  555,  556,  557,  558,  559,  560,  561,  566,
    0,    0,    0,    0,  746,  744, 1496,  745,    0,  747,
    0,    0,    0,    0,  554,  555,  556,  557,  558,  559,
  560,  561,    0,    0,    0,  569,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  554,  555,  556,
  557,  558,  559,  560,  561,    0,  554,  555,  556,  557,
  558,  559,  560,  561,    0,    0,  748,    0,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,    0,  554,  555,  556,  557,  558,  559,
  560,  561,    0,    0,    0,    0,    0,    0,  554,  555,
  556,  557,  558,  559,  560,  561,    0,  554,  555,  556,
  557,  558,  559,  560,  561,    0,    0,    0,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,    0,
  570,  571,  572,  573,  574,  575,  576,  577,    0,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,    0,    0,  554,  555,  556,  557,  558,  559,  560,
  561,  566,    0,    0,    0,    0,  746,  744, 1497,  745,
  566,  747,    0,    0, 1498,  746,  744,    0,  745,    0,
  747,    0,    0,    0,    0,    0,    0,  569,    0,    0,
    0,    0,    0,    0,    0,    0,  569,    0,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,  566,
    0,    0,    0, 1500,  746,  744,    0,  745,  748,  747,
    0,    0,    0,    0,    0,    0,    0,  748,    0,    0,
    0,    0,    0,    0,    0,  569,    0,    0,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,  554,
  555,  556,  557,  558,  559,  560,  561,  566,    0,    0,
    0, 1502,  746,  744,    0,  745,  748,  747,    0,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,  566,    0,  569,    0, 1504,  564,  562,    0,  563,
    0,  565,    0,    0,    0,    0,    0,    0,    0,  554,
  555,  556,  557,  558,  559,  560,  561,  569,    0,    0,
    0,  566,    0,    0,  748, 1506,  564,  562,    0,  563,
  566,  565,    0,    0,    0,  746,  744, 1521,  745,    0,
  747,    0,    0,    0,  566,    0,    0,  569,  567,  746,
  744, 1526,  745,  566,  747,    0,  569,    0,  746,  744,
 1528,  745,    0,  747,    0,    0,    0, 1094,  580,  578,
  569,  579,    0,  581,    0,    0,  566,    0,  567,  569,
    0,  746,  744, 1531,  745,    0,  747,  748,    0,  584,
    0,  554,  555,  556,  557,  558,  559,  560,  561,  566,
    0,  748,  569,    0,  746,  744,    0,  745,  566,  747,
  748,    0,    0,  746,  744, 1533,  745,    0,  747,    0,
  582,  566,    0,    0,    0,  569,  746,  744, 1538,  745,
    0,  747,  566,  748,  569,    0,    0,  746,  744, 1539,
  745,    0,  747,    0,  566,    0,    0,  569, 1550,  746,
  744,    0,  745,    0,  747, 1532,  748,    0,  569,  580,
  578, 1102,  579,    0,  581,  748,    0,  566,    0,    0,
  569, 1552,  746,  744,    0,  745,  566,  747,  748,    0,
  584,  746,  744,    0,  745,    0,  747,    0,    0,  748,
  566,    0,    0,  569,    0,  746,  744, 1555,  745,  566,
  747,  748,  569,    0,  746,  744, 1566,  745,    0,  747,
    0,  582,  566,    0,    0,    0,  569,  746,  744, 1572,
  745,    0,  747,    0,  748,  569,    0,    0,    0,    0,
    0,    0, 1554,  748,  566,    0,    0,    0,  569,  746,
  744, 1573,  745,    0,  747,  566,    0,  748,    0, 1578,
  746,  744,    0,  745,    0,  747,  748,    0,    0,    0,
  569,    0,    0,    0,    0,    0,    0,    0,  566,  748,
    0,  569, 1579,  746,  744,    0,  745,    0,  747,    0,
    0,    0,    0,  554,  555,  556,  557,  558,  559,  560,
  561,  748,    0,  566,  569,    0,    0,    0,  746,  744,
    0,  745,  748,  747,  566,    0,    0,    0,    0,  746,
  744, 1585,  745,    0,  747,    0,  566,    0,    0,  569,
    0,  746,  744, 1588,  745,  748,  747,  566,    0,    0,
  569,    0,  746,  744, 1590,  745,    0,  747,  566,    0,
    0,    0,  569,  746,  744, 1593,  745,    0,  747, 1584,
  748,    0,  566,  569,    0,    0,    0,  746,  744,    0,
  745,  748,  747,    0,  569,    0,  566,    0,    0,    0,
    0,  746,  744,  748,  745,  566,  747,    0,  569,    0,
  746,  744, 1609,  745,  748,  747,    0,    0,    0,    0,
    0,    0,  569,    0,    0,  748, 1096,  580,  578,    0,
  579,  569,  581,    0,    0,  566,    0,    0, 1595,  748,
  746,  744, 1613,  745,  566,  747,    0,    0,  584,  746,
  744, 1615,  745,  748,  747,    0,    0,    0,    0,    0,
    0,  569,  748,    0,    0,    0,    0,  566,    0,    0,
  569,    0,  746,  744,    0,  745,  566,  747,    0,  582,
    0,  564,  562,    0,  563,    0,  565,    0,    0,    0,
    0,    0,  748,  569,    0,    0,    0,    0,    0,    0,
    0,  748,  569,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,    0,  554,  555,  556,  557,  558,  559,
  560,  561,    0,    0,  748,    0,    0,    0,    0,    0,
    0,    0,    0,  567,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  554,  555,  556,  557,  558,  559,  560,
  561,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,    0,  554,  555,  556,  557,  558,  559,
  560,  561,    0,    0,    0,    0,    0,    0,  554,  555,
  556,  557,  558,  559,  560,  561,    0,  554,  555,  556,
  557,  558,  559,  560,  561,    0,    0,  570,  571,  572,
  573,  574,  575,  576,  577,    0,    0,    0,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  554,  555,  556,  557,  558,  559,  560,
  561,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,    0,    0,    0,    0,  554,  555,  556,  557,  558,
  559,  560,  561,    0,    0,    0,  554,  555,  556,  557,
  558,  559,  560,  561,    0,    0,    0,    0,  554,  555,
  556,  557,  558,  559,  560,  561,    0,    0,  570,  571,
  572,  573,  574,  575,  576,  577,    0,    0,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,    0,
    0,    0,    0,    0,  554,  555,  556,  557,  558,  559,
  560,  561,    0,  554,  555,  556,  557,  558,  559,  560,
  561,    0,    0,    0,    0,    0,  554,  555,  556,  557,
  558,  559,  560,  561,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  554,  555,
  556,  557,  558,  559,  560,  561,    0,    0,    0,  554,
  555,  556,  557,  558,  559,  560,  561,  161, 1604,    0,
    0,    0,  159,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  554,  555,  556,
  557,  558,  559,  560,  561,    0,    0,    0,  554,  555,
  556,  557,  558,  559,  560,  561,    0,    0,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,    0,
    0,    0,  554,  555,  556,  557,  558,  559,  560,  561,
    0,    0,    0,    0,    0,    0,  554,  555,  556,  557,
  558,  559,  560,  561,    0,    0,    0,    0,    0,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  570,  571,  572,  573,
  574,  575,  576,  577,    0,    0,    0,    0,    0,  554,
  555,  556,  557,  558,  559,  560,  561,    0,  554,  555,
  556,  557,  558,  559,  560,  561,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  554,  555,  556,  557,  558,  559,  560,  561,    0,
  554,  555,  556,  557,  558,  559,  560,  561,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    1,    2,    3,    4,    5,    6,    7,
    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
   38,   39,   40,   41,    0,   42,   43,   44,   45,   46,
   47,   48,   49,   50,   51,    0,    0,   52,   53,    0,
    0,    0,   54,   55,    0,    0,    0,    0,   56,    0,
    0,   57,   58,    0,    0,    0,   59,   60,   61,    0,
    0,   62,    0,    0,    0,   63,    0,   64,    0,    0,
    0,    0,   65,    0,   66,   67,    0,   68,   69,    0,
    0,   70,    0,   71,    0,   72,   73,    0,   74,    0,
    0,    0,    0,    0,   75,    0,    0,    0,    0,   76,
    0,    0,   77,    0,    0,    0,    0,   78,   79,    0,
    0,    0,   80,   81,   82,   83,    0,   84,   85,    0,
    0,   86,    0,    0,    0,    0,    0,    0,    0,   87,
    0,    0,    0,   88,    0,    0,    0,    0,    0,   89,
   90,    0,   91,    0,    0,    0,    0,   92,    0,    0,
    0,   93,   94,    0,   95,   96,   97,   98,    0,    0,
    0,  310,    0,    0,    0,    0,  308,   99,  100,    0,
    0,    0, 1098,  580,  578,    0,  579,    0,  581,    0,
    0,    0,  101,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  584,  102,    0,    0,    0,    0,
  103,  104,    0,    0,    0,    0,  105,  106,  107,  237,
  108,  109,  110,  111,    0,    0,    0,    0,    0,    0,
  112,  113,  114,  115,  116,  582,  117,    0,    0,    0,
  118,  119,    0,    0,    0,  120,    0,    0,  121,  122,
 1100,  580,  578,  123,  579,    0,  581,    0,    0,    0,
  124,    0,  125,  126,  127,  128,    0,    0,    0,  129,
  130,    0,  584,    0,  131,    0,  132,    0,    0,  133,
  134,  135,  136,  137,  138,    0,  139,  140, 1105,  580,
  578,    0,  579,    0,  581,    0,    0,    0,    0,    0,
    0,    0,    0,  582,    0,    0,    0,    0,    0,    0,
  584,    0,  141,  142,  143,  144,  145,  146,  147,  148,
  149,    0,    0,    0,  150,  151, 1107,  580,  578,    0,
  579,  238,  581,    0,    0,    0,    0,    0,    0,    0,
    0,  582,    0,    0,    0,    0,    0,    0,  584,    0,
    0,    0,    0,  239,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  240,  152,    0,    0,
    0,    0,  153,  154,  155,  156,  157,  158,    0,  582,
    0,    0,    0,    0,    0,    0,    0,  160,  262,  263,
  264,  265,  266,  267,  268,  269,   10,   11,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,   22,   23,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,    0,   42,
   43,   44,   45,   46,   47,   48,   49,    0,  241,  242,
  243,  244,    0,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  401,
    0,    0,    0,    0,  402,    0,    0,    0,    0,  403,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  310,    0, 1114,  580,
  578,  308,  579,    0,  581,    0,    0, 1116,  580,  578,
    0,  579,    0,  581,  404,    0,    0,    0,    0,    0,
  584,  331,    0,    0,    0,    0,    0,    0,  405,  584,
    0,    0,    0,    0,    0, 1118,  580,  578,    0,  579,
    0,  581,    0,    0,    0,    0,    0,    0,  406,    0,
    0,  582,  407,    0,    0,    0,  408,  584,  409,    0,
  582,    0,  410, 1128,  580,  578,    0,  579,    0,  581,
    0,    0, 1130,  580,  578,    0,  579,    0,  581,  231,
    0,    0,  232,    0,    0,  584,    0,    0,  582, 1134,
  580,  578,    0,  579,  584,  581,    0, 1136,  580,  578,
    0,  579,    0,  581,    0,    0,    0,    0,    0,    0,
    0,  584,    0,    0,    0,    0,  582,  305,    0,  584,
    0,    0,    0,    0,    0,  582,    0,    0,    0,    0,
    0,    0,    0,    0,  306, 1138,  580,  578,    0,  579,
    0,  581,  582, 1140,  580,  578,    0,  579,    0,  581,
  582,    0,    0,    0,    0,    0,  411,  584,    0,    0,
    0,    0,    0,    0,    0,  584,    0,    0,    0,    0,
    0,    0,  412,    0,    0,    0,    0,  137,  138,  413,
    0,    0,    0,    0,    0,    0,    0,    0,  582,    0,
    0,    0,    0,    0,    0,    0,  582,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  141,  142,  414,  144,
  145,  146,  147,  262,  263,  264,  265,  266,  267,  268,
  269,   10,   11,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,   22,   23,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,    0,   42,   43,   44,   45,   46,   47,
   48,   49,    0,    0,    0,    0,    0,    0,    0,  307,
  157,  158,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  309,  570,  571,  572,  573,  574,  575,  576,  577,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  486,
    0,    0,    0,    0,  487,    0,    0,    0,    0,  488,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  310,    0,    0,    0,    0,  308,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  489,
    0,    0,    0, 1487,  580,  578,  490,  579,    0,  581,
  570,  571,  572,  573,  574,  575,  576,  577,    0,    0,
 1489,  580,  578,    0,  579,  584,  581,    0,    0,    0,
  491,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  584,  492,    0,    0,    0,  493,  570,  571,
  572,  573,  574,  575,  576,  577,  582, 1491,  580,  578,
    0,  579,    0,  581,  231,    0,    0,  232,    0,    0,
    0,    0,    0,  582, 1499,  580,  578,    0,  579,  584,
  581,    0,    0,    0,    0,    0,  570,  571,  572,  573,
  574,  575,  576,  577,    0,    0,  584,    0,    0, 1501,
  580,  578,  305,  579,    0,  581,    0,    0,  494,    0,
  582,    0,    0,    0,    0,    0,    0,    0,    0,  306,
    0,  584, 1503,  580,  578,    0,  579,  582,  581,    0,
    0, 1505,  580,  578,    0,  579,    0,  581,    0,    0,
    0,    0,    0,    0,  584,    0,    0,    0,    0,    0,
    0,    0,  582,  584,    0,    0,    0,    0,    0,    0,
    0,    0,  137,  138,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  582,    0,    0,    0,    0,
    0,    0,    0,    0,  582,    0,    0,    0,    0,    0,
    0,  141,  142,  143,  144,  145,  146,  147,  262,  263,
  264,  265,  266,  267,  268,  269,   10,   11,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,   22,   23,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,    0,   42,
   43,   44,   45,   46,   47,   48,   49,    0,    0,    0,
    0,    0,    0,    0,  307,  157,  158,    0,  570,  571,
  572,  573,  574,  575,  576,  577,  309,  570,  571,  572,
  573,  574,  575,  576,  577,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  298,
    0,    0,    0,    0,  299,  570,  571,  572,  573,  574,
  575,  576,  577,    0,    0,    0,  310,    0,    0,    0,
    0,  308,    0,    0,    0,    0,    0,    0,  300,    0,
    0,    0,    0,  570,  571,  572,  573,  574,  575,  576,
  577,  301,  570,  571,  572,  573,  574,  575,  576,  577,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  570,
  571,  572,  573,  574,  575,  576,  577,  570,  571,  572,
  573,  574,  575,  576,  577,    0,  302,    0,  303, 1507,
  580,  578,  304,  579,    0,  581,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  231,
    0,  584,  232,    0,    0,  570,  571,  572,  573,  574,
  575,  576,  577,  570,  571,  572,  573,  574,  575,  576,
  577,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  582,    0,    0,    0,    0,  305,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  306,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  137,  138,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  141,  142,  143,  144,
  145,  146,  147,  262,  263,  264,  265,  266,  267,  268,
  269,   10,   11,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,   22,   23,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,    0,   42,   43,   44,   45,   46,   47,
   48,   49,    0,    0,    0,    0,    0,    0,    0,  307,
  157,  158,    0,    0,    0,    0,    0,    0,  417,    0,
    0,  309,  580,  578, 1109,  579,    0,  581,    0,    0,
    0,    0,    0,  570,  571,  572,  573,  574,  575,  576,
  577,    0,    0,  584,  418,    0,    0,    0,    0,  419,
  570,  571,  572,  573,  574,  575,  576,  577,    0,    0,
    0,  310,    0,    0,  580,  578,  308,  579,    0,  581,
    0,    0,    0,    0,  582,    0,    0,    0,    0,    0,
 1270,    0,    0,    0,    0,  584,  420,  570,  571,  572,
  573,  574,  575,  576,  577,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  570,  571,  572,  573,  574,  575,
  576,  577,    0,    0,    0,    0,  582,  580,  578, 1120,
  579,  421,  581,  422,    0,    0,    0,  423,    0,  570,
  571,  572,  573,  574,  575,  576,  577,    0,  584,    0,
    0,    0,    0,    0,  231,    0,    0,  232,    0,    0,
    0,    0,  570,  571,  572,  573,  574,  575,  576,  577,
    0,  570,  571,  572,  573,  574,  575,  576,  577,  582,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  305,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  306,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  310,    0,    0,    0,    0,  308,    0,    0,
    0,    0,  137,  138,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  141,  142,  143,  144,  145,  146,  147,  262,  263,
  264,  265,  266,  267,  268,  269,   10,   11,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,   22,   23,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,    0,   42,
   43,   44,   45,   46,   47,   48,   49,  580,  578, 1122,
  579,    0,  581,    0,  307,  157,  158,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  309,    0,  584,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1003, 1004,    0,    0,    0,    0, 1005,
  580,  578, 1124,  579,    0,  581,    0,    0,    0,  582,
    0,    0,    0,    0,    0,    0,    0,  580,  578, 1126,
  579,  584,  581,    0,    0,    0,    0,    0, 1006,  570,
  571,  572,  573,  574,  575,  576,  577,    0,  584,    0,
    0,  331,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  582,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  582,
    0,    0,    0,    0,    0,    0, 1007,    0, 1008,  262,
  263,  264,  265,  266,  267,  268,  269,   10,   11,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,   22,
   23,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,    0,
   42,   43,   44,   45,   46,   47,   48,   49,    0,    0,
  339,    0,    0,    0,    0,    0,    0,  305,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  340,    0,    0,  306,    0,    0, 1009, 1010,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1320,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  310,    0,    0,
  580,  578,  308,  579,    0,  581,    0,  137,  138,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  584,  331,    0,    0, 1321,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  141,  142,  143,  144,
  145,  146,  147,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  582,    0,    0,    0,    0, 1322,  341, 1323,
    0,  570,  571,  572,  573,  574,  575,  576,  577,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  231,    0,    0,  232,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  307,
  157,  158,    0,  570,  571,  572,  573,  574,  575,  576,
  577,  309,    0,    0,    0,    0,    0,    0,  305,    0,
    0,    0,    0,  580,  578, 1132,  579,    0,  581,    0,
    0,    0,    0,    0,    0,  306,    0,    0, 1324,    0,
    0,    0,    0,    0,  584,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  570,  571,  572,  573,
  574,  575,  576,  577,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  582,    0,    0,  137,  138,
    0,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  141,  142,  143,
  144,  145,  146,  147,  262,  263,  264,  265,  266,  267,
  268,  269,   10,   11,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,   22,   23,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,    0,   42,   43,   44,   45,   46,
   47,   48,   49,    0,    0,    0,    0,    0,    0,    0,
  307,  157,  158,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  309,    0,    0,  458,  459,  237,    0,    0,
    0,    0,    0,    0,    0,    0,  460,    0,    0,    0,
    0,    0,    0,    0,    0, 1327,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  310,    0,    0,    0,    0,  308,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  331,    0,    0,
 1328,    0,    0,    0,    0,    0,    0,    0,  461,    0,
    0,    0,    0,    0,    0,    0,  570,  571,  572,  573,
  574,  575,  576,  577,    0,    0,    0,    0,    0,    0,
    0,    0, 1329,    0, 1330,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  238,
    0,  310,    0,    0,    0,  231,  308,    0,  232,  570,
  571,  572,  573,  574,  575,  576,  577,    0,    0,    0,
    0,  239,    0,    0,    0,    0,  570,  571,  572,  573,
  574,  575,  576,  577,  240,    0,    0,    0,    0,    0,
    0,    0,    0,  305,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  310,    0,    0,    0,
  306,  308,    0, 1331,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  137,  138,    0,  241,  242,  243,  244,
    0,  245,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,    0,    0,    0,
    0,    0,  141,  142,  143,  144,  145,  146,  147,  262,
  263,  264,  265,  266,  267,  268,  269,   10,   11,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,   22,
   23,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,    0,
   42,   43,   44,   45,   46,   47,   48,   49,    0,    0,
    0,    0,    0,    0,    0,  307,  157,  158,    0,  570,
  571,  572,  573,  574,  575,  576,  577,  309,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  262,  263,
  264,  265,  266,  267,  268,  269,   10,   11,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,   22,   23,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,    0,   42,
   43,   44,   45,   46,   47,   48,   49,    0,    0,    0,
    0,    0,  331,  262,  263,  264,  265,  266,  267,  268,
  269,   10,   11,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,   22,   23,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,    0,   42,   43,   44,   45,   46,   47,
   48,   49,  570,  571,  572,  573,  574,  575,  576,  577,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  331,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  305,    0,
    0,  339,    0,    0,    0,  455,  455,    0,    0,    0,
    0,    0,    0,    0,    0,  306,    0,    0,    0,    0,
    0,    0,  340,    0,    0,    0,    0,    0,  455,    0,
    0,    0,    0,    0,  455,    0,  331,    0,    0,    0,
  455,    0,  455,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  137,  138,
    0,  455,    0,    0,  517,  518,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  305,    0,    0,
  310,    0,  455,    0,  455,  308,    0,  141,  142,  143,
  144,  145,  146,  147,  306,    0,  455,  519,  520,    0,
    0,    0,    0,    0,    0,  455,    0,    0,  455,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  341,
    0,    0,    0,    0,    0,    0,    0,    0,  455,  310,
    0,    0,  305,    0,  308,    0,    0,  137,  138,    0,
    0,    0,    0,  527,  528,    0,    0,    0,    0,  306,
  307,  157,  158,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  309,  455,  455,    0,  141,  142,  143,  144,
  145,  146,  147,    0,    0,    0,  529,  530,    0,    0,
    0,    0,    0, 1369,    0,  455,    0,    0,    0,    0,
    0,    0,  137,  138,  455,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  141,  142,  143,  144,  145,  146,  147,  455,  307,
  157,  158,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  309,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  307,  157,  158,    0, 1348,    0,
    0,    0,    0,    0,    0,    0,  309,  262,  263,  264,
  265,  266,  267,  268,  269,   10,   11,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,   22,   23,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,    0,   42,   43,
   44,   45,   46,   47,   48,   49,  262,  263,  264,  265,
  266,  267,  268,  269,   10,   11,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,   22,   23,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,    0,   42,   43,   44,
   45,   46,   47,   48,   49,    0,    0,    0,    0,    0,
    0,    0,    0, 1054,    0, 1055,    0,    0,  454,  454,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1056,
  331,  454,    0,    0, 1057,    0,    0,  454,    0,    0,
    0,    0,    0,  454,    0,  454,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  454,    0,    0,    0,    0, 1058,
    0, 1059,    0,    0,    0,    0,    0,    0,    0,  331,
    0,    0,    0, 1060,    0,  454,    0,  454,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  454,
 1061,    0,    0, 1062,    0,    0,    0,    0,  454,    0,
    0,  454,    0, 1063,    0,    0,    0, 1064,    0,    0,
    0,    0,    0,  161,    0,    0,  305,    0,  159,    0,
    0,  454,    0,    0,  231,    0,    0,  232, 1065,    0,
    0,    0,    0,  306,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1066, 1067,    0,
    0,    0,    0,    0,    0,    0,  454,  454,    0,    0,
    0,    0,    0,  161,    0,  305,    0, 1371,  159,    0,
    0,    0,    0,    0,    0,    0,  137,  138,  454,    0,
    0, 1068,  306, 1069,    0,    0,    0,  454,    0,    0,
    0,    0,    0,    0,    0,    0, 1070, 1071,    0,    0,
 1072,    0,    0,    0,    0,  141,  142,  143,  144,  145,
  146,  147,    0, 1073,    0,    0,    0, 1074,    0,    0,
    0,  454,    0,    0,    0,  137,  138,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  141,  142,  143,  144,  145,  146,
  147,    0,    0,    0,    0,    0,    0,    0,  307,  157,
  158,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  309,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1075,    0,  307,  157,  158,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  309,
    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
   12,   13,   14,   15,   16,   17,  543,   19,   20,   21,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
    0,   42,   43,   44,   45,   46,   47,   48,   49,    0,
    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
   12,   13,   14,   15,   16,   17,  543,   19,   20,   21,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
    0,   42,   43,   44,   45,   46,   47,   48,   49,    0,
    0,    0, 1031,    0, 1032, 1033,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  544, 1034,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1035,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1036,
    0,    0,    0,    0,    0, 1037,    0,    0,    0,    0,
    0,    0,    0,  544,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1038,  305,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  545,    0, 1039,    0,
    0,    0,    0,    0,    0,    0, 1040,    0,    0, 1041,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  231,
 1042, 1043,  232, 1044,    0, 1045,    0,    0,    0,  305,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  137,
  138,    0,    0,    0,    0,    0,  647,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  141,  142,
  143,  144,  145,  146,  147,    0,    0, 1046,    0,    0,
    0,    0,    0,    0, 1047,    0,    0,    0,    0,  137,
  138,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1048,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  141,  142,
  143,  144,  145,  146,  147,    0,    0,    0,    0,    0,
    0,  546,  157,  158,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  160,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  546,  157,  158,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  160,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1049,
};
short yycheck[] = {                                      52,
    0,  108,   46,  459,  385,  374,  462,   60,  324,  324,
  512,  390,  812,  406,  336,  337,  546,  344,   10,  475,
   10,  344,  342,   46,  131,  324,  331,  324,   81,  332,
  324,   10,  376,  360,   46,  410,  324,  360,   61,   61,
  348,  385,  542,  348,  544,  575,  596,   37,  423,   61,
   10,   41,   42,   43,   44,   45,   40,   47,  419,   63,
  322,    0,   41,   63,   43,   44,   45,  448,   58,   91,
  451,  343,  377,   63,   74,   79,  348,   37,   82,   58,
   84,   41,   42,   43,   44,   45,  348,   47,   92,   93,
  471, 1044,   92,   93,   98,  455,   10,  419,   58,  419,
  100,  639,  309,   63,   94,   10,  139,  111,   40,   40,
  503,  383, 1065,  416,  374,  148,  448,   40,  493,  451,
  425,  125,  427,   10,  503,  125,  486,   41,  128,  490,
   44,  451,  525,  133,   94,  135,   41,  639,  465,   44,
  515,  342,  465,  448,   58,  448,  451,  338,  451,  153,
  154,  155,  460,   58,   41,  427,  537,   44,  420,  159,
  160,  161,  390,  425,  399,  427,  170,  536,  490,  431,
  490,   58,  348,  554,  178,  343,  448,  360,  390,  451,
  348,  181,  182,  183,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  996,  513,  513,  199,
  200,  201,  202,  203,  204,  205,  206,  207,  208,  209,
  210,  211,  212,  535,  513,  383,  513,  221,  419,  513,
  159,  160,  161,  773,  228,  513,  529,  530,  589,  590,
  591,  592,  537,  424,  338,  543,  443,  544,  500,  446,
  390,   40,  181,  182,  183,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  425,   46,  427,
  199,  200,  201,  202,  203,  204,  205,  206,  207,  208,
  209,  210,  211,  212,  390,  503,  536,  537,  513,   40,
   10,  456,  465,   40,  460,  506,  390,  462,   10,  490,
   10,  503,   41,   40,  283,  284,   10,   46,   40,   40,
  348,   46,   40,   91,  348,  540,   10,   37,  308,  309,
  310,   41,   42,   43,   44,   45,  537,   47,   10,   41,
  424,   41,   44,  639,   44,  516,  379,   41,   58,  382,
   44,  639,  639,   63,  525,  348,   58,   41,   58,  362,
   44,   41,   42,   43,   58,   45,   91,   47,  323,   41,
  362,   40,   44,  503,   58,   63,   40,  344,   10,   40,
  528,  348,  503,   63,   94,   40,   58,  639,  372,  298,
  299,  300,  301,  302,  303,  304,  305,  381,   40,  383,
  424,  425,  357,  427,   40,   37,   94,  503,  392,   41,
   42,   43,   44,   45,   94,   47,  383,  401,  421,  503,
  448,   37,   40,  451,  448,  428,   58,  451,  549,  421,
   40,   63,  460,  413,  414, 1215,  428,   40,  639,   10,
   40,  525,  390,  391,  428,   40,   40,   63,   40,   10,
  421,  344,  445,  360,  425,  348,  427,   40,   40,   40,
  427,  582,   94,   40,  467,  445,   37,  460,   10,  639,
   41,   42,   43,   44,   45,  467,   47,   10,   94,   46,
   41,   42,   43,   44,   45,  465,   47,   58,  348,  469,
  383,  475,   63,  348,   61,   37,  476,   58,  484,   41,
   42,   43,   44,   45,  484,   47,   63,   63,   41,   42,
   43,   44,   45,  537,   47,  543,   58,  377,  605,  503,
  491,   63,   40,   94,   91,   58,   40,   61,  512, 1059,
  554,   40,   40,   94,  427,  348,  344,   94,   94,  506,
  639,  448,  639,   40,  451,   46,  639,  527,  528,  529,
  530,  470,   94,  344,  534,  503,  504,   91,  465,  478,
   61,  541,  542,  283,  284,  425,  537,  427,  344,  425,
  425,  427,  427,  356,  554,  555,  556,  557,  558,  559,
  560,  561,  562,  563,  564,  565,  566,  567,  448,  569,
   91,  451,  448,  448,  503,  451,  451,   40,  578,  579,
  580,  581,  582,  554,  639,  639,  638,  327,  588,  589,
  544,   37,  427,  506,  344,  503,   42,   43,   44,   45,
  600,   47,  541,   40,  604,  344,  606,  639,  525,   42,
   43,   40,   45,  617,   47,  619,  620,   63,   10,   10,
   10,   10,   10,  562,  563,  564,  565,   10,  567,   40,
   63,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,  582,   10,  584,   40,   10,   94,  588,
 1200,  641,  642,  643,  644,  645,  646,  647,  648,   10,
   10,   94,  641,  642,  643,  644,  645,  646,  647,  648,
  631,  632,  633,  634,  639,   41,  639,   43,   44,   45,
  639,  641,  642,  643,  644,  645,  646,  647,  648,   46,
  639,   44,   58,  506,  639,  639,  639,  697,  698,  699,
  700,  701,  702,  703,  704,  705,  706,  707,  708,  709,
  710,  711,  344,  713,  714,  715,  716,  717,  718,  719,
  720,  721,  722,  723,  724,  725,  726,  641,  642,  639,
  639,   40,   10,   40,   40,   40,  641,  642,  343,  344,
  740,   40,   10,  348,  744,  745,  746,  747,  748,  749,
  750, 1207,   40,   40,  641,  642,   40,   40,   40,   37,
   40,   40,  762,   41,   42,   43,   44,   45,   40,   47,
   40,   40,  639,    0,   42,   43,  776,   45,  383,   47,
   58,   40,   40,   40,   37,   63,   10,  639,   37,   42,
   43,   46,   45,   42,   47,   63,   40,   40,   47,  738,
  739,  639,   40,   40,   40,   40,   40,   40,  812,  414,
   63,   40,  417,   37,   63,   40,   94,   41,   42,   43,
   44,   45,  427,   47,   40,   37,   94,   40,   46,  829,
   42,   43,   46,   45,   58,   47,   44,  837,  534,   63,
   10,   94,   42,  843,   91,   94,   91,   47,   46,  506,
  639,   63,   10,  298,  299,  300,  301,  302,  303,  304,
  305,  466,  639,   63,  639,  506,  503,   37,  348,  639,
   94,   41,   42,   43,   44,   45,  639,   47,  504,   37,
  639,  639,   94,   41,   42,   43,   44,   45,   58,   47,
  506,  504,  499,   63,   94,  506,  896,  503,  506,  499,
   58,  901,  639,  639,  639,   63,  639,  639,  639,  534,
  639,  641,  642,  643,  644,  645,  646,  647,  648,  641,
  642,  641,  642,  923,   94,   46,  639,  641,  642,  639,
  639,  931,  159,  160,  161,  534,   94,  641,  642,  344,
  940,  641,  642,  643,  644,  645,  646,  647,  648,  641,
 1003,  639,  639,  639,  181,  182,  183,  184,  185,  186,
  187,  188,  189,  190,  191,  192,   10,  194,  195,  639,
  639,  639,  199,  200,  201,  202,  203,  204,  205,  206,
  207,  208,  209,  210,  211,  212,   10,  503,  992,  641,
  642,  643,  644,  645,  646,  647,  648,   41,  344,  639,
   44,  940,   37,  942,  344, 1005,  639,   42,  639, 1009,
  639,  639,   47,   37,   58,  639,  506,   41,   42,   43,
   44,   45,  639,   47,  344,  537,  344, 1031,   63,  639,
 1034,  503, 1032, 1033,   58,  639, 1040, 1041,   40,   63,
 1040, 1041, 1042, 1043,  639,  639,  639,  639, 1052,  639,
  641,  642,  643,  644,  645,  646,  647,  648,  503,   94,
  641,  642,  643,  644,  645,  646,  647,  648,  639,  308,
   94, 1071, 1072, 1077,  639,  639,   10,   46,  639,  641,
  642,  643,  644,  645,  646,  647,  648, 1087,  641,  642,
  643,  644,  645,  646,  647,  648,   10,  639,  639,  639,
  421, 1101, 1102,  639,  639,   46,  639,   41,   42,   43,
   44,   45,  639,   47,  639,  639,  639,  639,   63, 1119,
 1120, 1121,  344, 1123,   58, 1125,  639,   41,   63,   63,
   44, 1131, 1132,   37,  639,  639,  639,   44,   42,   43,
   10,   45,  503,   47,   58,  503,   41,   44,  503, 1088,
  639,  298,  299,  300,  301,  302,  303,  304,  305,   63,
   94,  639, 1101, 1102,  639,  639,  639,   37,  407,  639,
  409,   41,   42,   43,   44,   45,  503,   47,  417,  343,
  419,  503,  639, 1122,  348, 1124,  346, 1126,   58,  639,
   94,  639, 1131, 1132,   44,  641,  642,  643,  644,  645,
  646,  647,  648, 1207,  639,  639,   44,  528, 1208,  639,
   44,  639, 1212,  639,  639,  454,  639,  639,  639,  383,
  639,  639,  382,  639,   94,  546,  547, 1227,  344,  393,
  390, 1231,  639,  390,   44,  344, 1236, 1237, 1238,  503,
  503, 1241,  344, 1243, 1244,  344, 1246,   44,   61,   44,
 1250,  490,  344,   46,  575,  576,  577,  578,  579,  580,
  581,  425,   61,  427, 1264, 1265,  639,  639,  639, 1269,
  639, 1210,   44,  344,  506,  641,  642,  643,  644,  645,
  646,  647,  648,  639,  448,  344,   44,  451,  448,   44,
  639,  451,  639,   44, 1294,  639,  639,  639,  639,  538,
  639,  639,  639,  639,  639, 1244,  639,  506,  639,  639,
  639,  639,   44,  639,  541,  639,  639, 1321,  344,  506,
  639,  344,  639,  639, 1328,  639,  639,  639,  639,  639,
   44, 1270,   41,   46,   44,  562,  563,  564,  565,  639,
  567, 1341,  502,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,  582,  503,  584,  639,  534,
   44,  588,   10,  641,  642,  643,  644,  645,  646,  647,
  648,  534,  639,  641,  642,  643,  644,  645,  646,  647,
  648,  503,  385,  639,   61,  639,   46,  639,  639,   37,
   61,  639,   44,   41,   42,   43,   44,   45,  639,   47,
  639,  344, 1402,   41,   41, 1405,  390, 1407,  639, 1409,
   58,  639,   44,  639,   44,   41, 1416,  641,  642,  643,
  644,  645,  646,  647,  648,   44,  344,  390,  639, 1429,
  642,  643,  644,  645,  646,  647,  648,  639,  639,   46,
   41,  344,  639,  421,  639,   93,   94,  639,  639,  639,
  639,  639, 1452, 1453,  639,  639,  639, 1457,  639,  639,
  639, 1461,  639,  639,   41,  639,  639, 1406,  639,   41,
  639,  641,  642,  643,  644,  645,  646,  647,  648,   41,
  376,   10,   46,  641,  642,  643,  644,  645,  646,  647,
  648,  639,   44,  639,  639,  639, 1496, 1497,  394,  503,
   46,   61,  344,   41,  400,  401,  639,   44,  503,  503,
  639,   10,   41,   42,   43,   44,   45,   61,   47, 1458,
  639, 1521,  639, 1523,   44, 1525, 1526,   41, 1528,   58,
   41, 1531,  376, 1533,   63,  639,   44,   41,   37, 1539,
  436,  437,   41,   42,   43,   44,   45,    0,   47,  639,
  394,   10,   10, 1553,   10, 1555,  400,  401,   10,   58,
   10,   10,   10,   91,   10,   94, 1566,   10,  546,  547,
 1570,   10, 1572, 1573,   10,   10,   10,   10,   10,   10,
  476,   10,  478,   10, 1523,   10,   10,   10, 1588,   10,
 1590,   10,  436,  437,   93,   94, 1596,  575,  576,  577,
  578,  579,  580,  581, 1604,   10,   10,   10,   10, 1609,
   10,   10,   10, 1613,   10, 1615,   10,  641,  642,  643,
  644,  645,  646,  647,  648,   10,   10,   10,   10,   10,
   10,  454,  476,  281,  478,  283,  284,   37,  534,   10,
   10,   41,   42,   43,   44,   45,   10,   47,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   58,  283,
   10,   10,   10,   42,   43,  313,   45,   10,   47,  317,
   10,  319,   10,   10,   10,   10,   10,   10, 1524,   41,
   42,   43,   44,   45,   63,   47, 1061,  392,  336,  546,
  547,  315,  316,   85,   94,  343,   58,   85, 1052, 1077,
  348,   63,   -1,   -1,   -1,  329,  354,  641,  642,  643,
  644,  645,  646,  647,  648,   94,   -1,   -1,  575,  576,
  577,  578,  579,  580,  581,   -1,   -1,   -1,   10,   -1,
   -1,   -1,   94,   -1,   -1,  383,   -1,  385,   -1,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,  397,
   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,  407,
   42,   43,   -1,   45,   -1,   47,  414,   -1,   -1,  417,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,  427,
   -1,   63,  281,  431,  283,  284,   -1,  435,   -1,   -1,
  438,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,
  448,  449,  450,  451,  452,   -1,  454,   -1,   -1,   -1,
   -1,   -1,   94,   -1,  313,   -1,   -1,   -1,  317,   -1,
  319,   37,   -1,  471,  472,   41,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,
   -1,   -1,   58,   -1,  343,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,  354,   -1,  505,  506,  507,
   -1, 1088,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,
   -1,   -1,  520,  521, 1101, 1102,  524,   93,   -1,  503,
  504,  529,   -1,   -1,  383,   -1,  385,   10,   -1,  537,
   -1,   -1,   -1,  541,   -1, 1122,   -1, 1124,  397, 1126,
   -1,   -1,   -1,   -1, 1131, 1132,   -1,   -1,  407,   -1,
   -1,   -1,   -1,   -1,   37,  414,   -1,   -1,  417,   42,
   43,   -1,   45,   -1,   47,  549,  550,   -1,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,  435,   -1,   -1,  438,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,  448,
  449,  450,  451,  452,   -1,  454,   -1,   -1,  582,  583,
   -1,   -1,   -1,  587,  588,   -1,   -1,   -1,   -1,   -1,
   -1,   94,  471,  472,   -1,   37,   -1,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,  639,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   63,   -1,   -1,   10,   -1,  505,  506,  507,   -1,
   -1,   -1,   -1,   -1,  513,   -1,   -1, 1244,   -1,   -1,
   -1,  520,  521,   -1,   -1,  524,   -1,   -1,   -1,   -1,
  529,   37,   94,   -1,   -1,   -1,   42,   43,  537,   45,
   -1,   47,  541, 1270,   -1,   -1,   10,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  281,   -1,  283,  284,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   10,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   58,   -1,   -1,  313,   -1,   -1,
   -1,  317,   -1,  319,   -1,   -1,   -1,   41,   -1,   43,
   44,   45,  641,  642,  643,  644,  645,  646,  647,  648,
  336,   -1,   -1,   -1,   58,   -1,   -1,  343,   -1,   93,
   -1,   10,  348,   -1,   -1,   -1,   -1,   -1,  354,   10,
  639,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,
   -1,   -1,   41,   42,   43,   44,   45,  383,   47,  385,
   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,   58,
   -1,  397,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,
   -1,  407,   63,   -1,   -1,   -1,   -1,   -1,  414,   -1,
   -1,  417,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,  435,
   -1,   -1,  438,   94,   -1,   -1,   10,   -1,   -1,   -1,
   -1,   -1,  448,  449,  450,  451,  452,   -1,  454,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   37,   -1,  471,  472,   41,   42,   43,
   44,   45,   -1,   47,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,  505,
  506,  507,   -1,   -1,   -1,   -1, 1523,  513,   -1,   -1,
   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,  524,   93,
   -1,   -1,   -1,  529,   -1,   10,   -1,  281,   -1,  283,
  284,  537,   -1,   -1,   -1,  541,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   37,   -1,   -1,   -1,   -1,   42,   43,  313,
   45,   -1,   47,  317,   -1,  319,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   63,   -1,
   -1,   -1,  336,   -1,   -1,   -1,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,
  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  383,
   -1,  385,   -1,  639,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,  397,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,  407,   -1,   -1,   -1,   -1,   -1,   -1,
  414,   58,   -1,  417,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,  435,   -1,   -1,  438,   -1,   -1,   -1,   10,   -1,
   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,   -1,
  454,   -1,   -1,   -1,   -1,   -1,   -1,  281,   -1,  283,
  284,   -1,   -1,   -1,   -1,   37,   -1,  471,  472,   41,
   42,   43,   44,   45,   -1,   47,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   58,   -1,   -1,  313,
   -1,   -1,   -1,  317,   -1,  319,   -1,   -1,   -1,   -1,
   -1,  505,  506,  507,   -1,   -1,   -1,   -1,   -1,  513,
   -1,   -1,  336,   -1,   -1,   -1,  520,  521,   -1,  343,
  524,   93,   -1,   10,  348,  529,   -1,   -1,   -1,   -1,
  354,   10,   -1,  537,   -1,   -1,   -1,  541,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   37,   -1,   10,   -1,   41,   42,   43,   44,   45,  383,
   47,  385,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   58,   -1,  397,   -1,   -1,   -1,   -1,   -1,   58,
   -1,   -1,   -1,  407,   42,   43,   -1,   45,   -1,   47,
  414,   -1,   -1,  417,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,  427,   -1,   63,   -1,  431,   -1,   -1,
   -1,  435,   -1,   -1,  438,   94,   -1,   -1,   10,   -1,
   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,   -1,
  454,   -1,   -1,   -1,   -1,  639,   94,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,  471,  472,   41,
   -1,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,  505,  506,  507,   -1,   -1,   -1,   -1,   -1,  513,
   -1,   -1,   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,
  524,   93,   -1,   -1,   -1,  529,   -1,   10,   -1,  281,
   -1,  283,  284,  537,   -1,   -1,   -1,  541,   -1,   10,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   42,
   43,  313,   45,   -1,   47,  317,   37,  319,   -1,   -1,
   41,   42,   43,   44,   45,   -1,   47,   -1,   42,   43,
   63,   45,   -1,   47,  336,   -1,   -1,   58,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,   63,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,
   94,  383,   -1,  385,   -1,  639,   10,  641,  642,  643,
  644,  645,  646,  647,  648,  397,   41,   42,   43,   44,
   45,   37,   47,   -1,   -1,  407,   42,   43,   10,   45,
   -1,   47,  414,   58,   -1,  417,   -1,   41,   42,   43,
   44,   45,   -1,   47,   -1,  427,   -1,   63,   -1,  431,
   -1,   -1,   -1,  435,   58,   -1,  438,   -1,   -1,   41,
   10,   43,   44,   45,   -1,   -1,  448,  449,  450,  451,
  452,   -1,  454,   -1,   -1,   -1,   58,   -1,   94,  281,
   -1,  283,  284,   -1,   -1,   10,   -1,   -1,   -1,  471,
  472,   41,   -1,   43,   44,   45,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   58,   -1,
   -1,  313,   -1,   -1,   -1,  317,   41,  319,   43,   44,
   45,   -1,   -1,  505,  506,  507,   -1,   -1,   -1,   10,
   -1,  513,   -1,   58,  336,   -1,   -1,   -1,  520,  521,
   -1,  343,  524,   93,   -1,   10,  348,  529,   -1,   -1,
   -1,   -1,  354,   -1,   -1,  537,   -1,   -1,   -1,  541,
   41,   42,   43,   44,   45,   10,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   58,   43,   44,
   45,  383,   -1,  385,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   58,   -1,  397,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,  407,   10,   -1,   -1,   -1,
   -1,   -1,  414,   58,   -1,  417,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,  435,   -1,   -1,  438,   41,   42,   43,
   44,   45,   10,   47,   -1,   -1,  448,  449,  450,  451,
  452,   10,  454,   -1,   58,   -1,   -1,  639,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   10,   -1,  471,
  472,   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,
   58,   42,   43,   44,   45,   -1,   47,   -1,   41,   58,
   43,   44,   45,  505,  506,  507,   -1,   -1,   -1,   10,
   -1,  513,   63,   -1,   -1,   58,   -1,   -1,  520,  521,
   -1,   -1,  524,   -1,   -1,   -1,   -1,  529,   -1,   10,
   -1,  281,   -1,  283,  284,  537,   -1,   -1,   -1,  541,
   -1,   -1,   -1,   94,  641,  642,  643,  644,  645,  646,
  647,  648,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   42,   43,  313,   45,   -1,   47,  317,   10,  319,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   10,   63,   -1,   -1,   -1,  336,   -1,   -1,   -1,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,
   42,   43,   -1,   45,  354,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   94,   43,   44,   45,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   -1,   -1,   -1,  383,   -1,  385,   -1,  639,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,  397,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,  407,   -1,   -1,
   -1,   -1,   -1,   -1,  414,   -1,   37,  417,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,  435,   -1,   -1,  438,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,  448,  449,
  450,  451,  452,   -1,  454,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  471,  472,   94,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,  642,  643,
  644,  645,  646,  647,  648,  505,  506,  507,   -1,   -1,
   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,
  520,  521,   -1,   -1,  524,   -1,   -1,   -1,   -1,  529,
  281,   -1,  283,  284,   -1,   -1,   -1,  537,   37,   -1,
   -1,  541,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  332,   -1,
   -1,   -1,  313,   -1,   63,  339,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,  336,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   94,   -1,  348,   -1,   -1,
   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,  395,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,  639,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   46,
   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,  432,  433,
  434,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   10,   -1,  427,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  435,   -1,   -1,  438,   -1,   -1,
   -1,   -1,   -1,   -1,  468,   -1,   -1,  448,  449,  450,
  451,  452,   -1,  454,   -1,   41,   -1,   -1,   44,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   41,
   42,   43,   58,   45,   -1,   47,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,  510,   -1,   -1,   -1,
   -1,   63,   -1,  517,  518,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,  506,   -1,   93,   -1,   -1,
   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  554,   -1,   -1,   -1,  558,   -1,  537,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
  641,  642,  643,  644,  645,  646,  647,  648,  641,  642,
  643,  644,  645,  646,  647,  648,   10,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  283,   41,  639,   -1,
   44,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   58,   -1,  281,   -1,  283,  284,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,  325,   -1,
   94,   -1,   -1,   -1,   -1,  332,   -1,   -1,  313,   93,
   -1,   -1,   -1,   -1,   -1,  281,   -1,  283,  284,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,  336,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,  348,   -1,   -1,   -1,  313,   -1,  354,
   -1,  317,  379,  319,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  336,  398,   -1,   -1,   -1,   10,   -1,  343,   -1,   -1,
   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,  354,  416,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,  407,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  383,   -1,  385,
   -1,  448,  427,   58,  451,   -1,   -1,   -1,   -1,   -1,
  435,  397,   -1,  438,   41,   42,   43,   -1,   45,   -1,
   47,  407,   -1,  448,  449,  450,  451,  452,  414,  454,
   -1,  417,   -1,   -1,   -1,   -1,   63,   -1,   93,   -1,
   -1,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,  435,
   -1,   -1,  438,   -1,   -1,   -1,   -1,  504,   -1,   -1,
   -1,   -1,  448,  449,  450,  451,  452,   94,  454,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,  281,   -1,  283,
  284,  506,   -1,   -1,   -1,  471,  472,   -1,  513,   -1,
  537,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  313,
   -1,   -1,  537,  317,   -1,  319,   -1,   -1,   -1,  505,
  506,  507,   -1,   37,   -1,   -1,   -1,  513,   42,   43,
   44,   45,  336,   47,  520,  521,   -1,   10,  524,  343,
   -1,   -1,   -1,  529,  348,   -1,   -1,   -1,   -1,   63,
  354,  537,   -1,   -1,   -1,  541,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  383,
   94,  385,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  407,   -1,   -1,   -1,   -1,   -1,   -1,
  414,   -1,   -1,  417,  639,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,  427,   -1,   -1,  281,  431,  283,  284,
   -1,  435,   -1,   -1,  438,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,   -1,
  454,   -1,   -1,  639,   -1,  641,  642,   -1,  313,   -1,
   -1,   -1,  317,   -1,  319,   -1,   -1,  471,  472,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,  336,   -1,   -1,  348,  349,   -1,   -1,  343,   -1,
   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,   10,  354,
   -1,  505,  506,  507,   -1,   -1,   -1,  371,   -1,  513,
   -1,   -1,   -1,  377,   -1,   -1,  520,  521,   -1,  383,
  524,  385,   -1,   -1,   -1,  529,   -1,   -1,  383,   41,
  385,   -1,   44,  537,   -1,   -1,   -1,  541,   -1,   -1,
  404,   -1,  397,   -1,   -1,   -1,   58,   -1,   -1,   -1,
   -1,   -1,  407,   -1,   -1,   -1,   -1,   -1,   -1,  414,
   -1,  425,  417,  427,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  427,   -1,   -1,  439,  431,   -1,   -1,   -1,
  435,   93,   -1,  438,  448,   -1,   -1,  451,   -1,   -1,
   -1,   -1,   -1,  448,  449,  450,  451,  452,   -1,  454,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  471,  281,   -1,
  283,  284,   -1,   -1,   -1,   -1,  471,  472,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,  641,  642,  643,
  644,  645,  646,  647,  648,  639,   -1,  641,  642,   -1,
  313,   -1,  506,  507,  317,   -1,  319,   -1,   -1,   -1,
  505,  506,  507,   -1,   -1,   -1,   -1,   -1,  513,   -1,
   -1,   -1,   -1,  336,  528,  520,  521,   -1,   -1,  524,
  343,   -1,   10,  537,  529,  348,   -1,   -1,   -1,   -1,
   -1,  354,  537,   -1,   -1,   -1,  541,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,  571,   -1,   37,
  383,   10,  385,   -1,   42,   43,   44,   45,   -1,   47,
   58,   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  407,   63,   -1,   -1,   -1,   -1,
   -1,  414,   41,   -1,  417,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  427,   93,   -1,   -1,  431,   58,
   -1,   -1,  435,   -1,   -1,  438,   94,   -1,   -1,  281,
   -1,  283,  284,   -1,   -1,  448,  449,  450,  451,  452,
   -1,  454,   -1,   -1,  639,   -1,  641,  642,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,  471,  472,
   -1,  313,   -1,   -1,   -1,  317,   -1,  319,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,  336,   -1,   -1,   -1,   -1,   -1,
   -1,  343,  505,  506,  507,   -1,  348,   -1,   -1,   -1,
  513,   -1,  354,   -1,   -1,   -1,   -1,  520,  521,   -1,
   -1,  524,   -1,   -1,   -1,   -1,  529,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  537,   -1,   -1,   -1,  541,   -1,
   -1,  383,   -1,  385,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  407,   -1,   -1,   -1,   -1,
   -1,   -1,  414,   -1,   -1,  417,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,  435,   10,   -1,  438,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  448,  449,  450,  451,
  452,   -1,  454,  281,   -1,  283,  284,   -1,   -1,   -1,
   -1,   -1,   10,   -1,   -1,   41,   -1,   -1,   44,  471,
  472,   -1,   -1,   -1,   -1,   -1,  639,   -1,  641,  642,
   -1,   -1,   58,   -1,   -1,  313,   -1,   -1,   -1,  317,
   -1,  319,  281,   -1,  283,  284,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  505,  506,  507,   -1,   -1,  336,   -1,
   -1,  513,   -1,   -1,   -1,  343,   -1,   93,  520,  521,
  348,   -1,  524,   -1,  313,   -1,  354,  529,  317,   -1,
  319,   -1,   -1,   -1,   -1,  537,   -1,   -1,   -1,  541,
   37,   -1,   -1,   -1,   41,   42,   43,  336,   45,   -1,
   47,   -1,   -1,   -1,  343,  383,   -1,  385,   -1,  348,
   -1,   -1,   -1,   -1,   -1,  354,   63,   -1,   -1,  397,
   -1,   -1,   37,   -1,   -1,   -1,   41,   42,   43,  407,
   45,   -1,   47,   10,   -1,   -1,  414,   -1,   -1,  417,
   -1,   -1,   -1,   -1,  383,   -1,  385,   94,   63,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,  435,  397,   -1,
  438,   -1,   -1,   -1,   41,   -1,   -1,   44,  407,   -1,
  448,  449,  450,  451,  452,  414,  454,   -1,  417,   94,
   -1,   58,   -1,   -1,   -1,   -1,   -1,  639,  427,  641,
  642,   -1,  431,  471,  472,   -1,  435,   -1,   -1,  438,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,   -1,  454,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  505,  506,  507,
   -1,   -1,  471,  472,   -1,  513,   -1,   -1,   -1,   -1,
   -1,   -1,  520,  521,   -1,   -1,  524,   -1,   -1,   -1,
   10,  529,   -1,   -1,   -1,  281,   -1,  283,  284,  537,
   -1,   -1,   -1,  541,   -1,   -1,  505,  506,  507,   -1,
   -1,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,
   -1,  520,  521,   -1,   -1,  524,   -1,  313,   -1,   -1,
  529,  317,   -1,  319,   -1,   -1,   10,   -1,  537,   -1,
   -1,   -1,  541,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  336,   -1,   -1,   -1,   -1,   -1,   -1,  343,   -1,  317,
   -1,  319,  348,   -1,   -1,   37,   -1,   -1,  354,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  343,   10,   -1,   -1,   -1,
  348,   63,   -1,   -1,   -1,   -1,   -1,  383,   -1,  385,
   -1,  639,   -1,  641,  642,   -1,   -1,   -1,   -1,   -1,
   -1,  397,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,  407,   94,   -1,   -1,  383,   -1,  385,  414,   -1,
   -1,  417,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  397,
  639,  427,  641,  642,  281,  431,  283,  284,   -1,  435,
   -1,   -1,  438,   -1,   -1,   -1,  414,   -1,   -1,  417,
   -1,   -1,  448,  449,  450,  451,  452,   -1,  454,  427,
   -1,   -1,   -1,  431,   -1,   -1,  313,   -1,   -1,   -1,
  317,   -1,  319,   -1,   -1,  471,  472,   -1,   -1,   -1,
  448,   -1,   -1,  451,  452,   -1,   -1,   37,   -1,  336,
   -1,   -1,   42,   43,   44,   45,  343,   47,   -1,   -1,
   -1,  348,   -1,  471,  472,   10,   -1,  354,   -1,  505,
  506,  507,   -1,   63,   -1,   -1,   -1,  513,   -1,   -1,
   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,  524,   -1,
   -1,   -1,   -1,  529,   -1,   -1,  383,  505,  385,  507,
   -1,  537,   -1,   -1,   94,  541,   -1,   -1,   -1,   -1,
  397,   -1,  520,  521,   10,   -1,  524,   -1,   -1,   -1,
  407,   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,  537,
  417,   -1,   -1,  541,   -1,   -1,   -1,   -1,   -1,   -1,
  427,   -1,   -1,   -1,  431,   -1,   -1,  317,  435,  319,
   -1,  438,   -1,   -1,   -1,   -1,   -1,  281,   -1,  283,
  284,  448,  449,  450,  451,  452,   -1,  454,   -1,   -1,
   -1,   37,   -1,  343,   10,   41,   42,   43,  348,   45,
   -1,   47,   -1,   -1,  471,  472,   -1,   -1,   37,  313,
   -1,   -1,   -1,   42,   43,   44,   45,   63,   47,   -1,
   -1,   -1,   -1,  639,   -1,  641,   -1,  281,   -1,  283,
  284,   -1,  336,  383,   63,  385,   -1,   -1,  505,  506,
  507,   -1,   -1,   -1,  348,   -1,  513,  397,   94,   -1,
  354,  639,   -1,  520,  521,   -1,   -1,  524,   -1,  313,
   -1,   -1,  529,   -1,  414,   94,   -1,  417,   -1,   -1,
  537,   -1,   -1,   -1,  541,   -1,   -1,  427,   -1,   -1,
   -1,  431,  336,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,  448,   -1,
  354,  451,  452,  407,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  471,  472,  427,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  435,   -1,   -1,  438,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  448,  449,  450,  451,  452,   -1,
  454,   -1,   -1,  407,   -1,  505,  281,  507,  283,  284,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  520,  521,  639,  427,  524,   -1,   -1,   -1,   -1,   -1,
   -1,  435,   -1,   -1,  438,   -1,   -1,  537,  313,   -1,
   -1,  541,   -1,   -1,  448,  449,  450,  451,  452,   -1,
  454,   -1,  506,   -1,   -1,  281,   -1,  283,  284,  513,
   -1,  336,   37,   -1,   -1,   -1,   41,   42,   43,   -1,
   45,   -1,   47,  348,   -1,   -1,   -1,   -1,   -1,  354,
   -1,   -1,   -1,  537,   -1,   37,   -1,  313,   63,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   37,   -1,
   -1,   -1,  506,   42,   43,   44,   45,   -1,   47,  513,
  336,   63,   -1,   -1,   -1,  281,   -1,  283,  284,   94,
   -1,   -1,  348,   -1,   63,   -1,   -1,   -1,  354,   -1,
   37,   -1,  407,  537,   41,   42,   43,   -1,   45,  639,
   47,   -1,   94,   37,   -1,   -1,   -1,  313,   42,   43,
   44,   45,  427,   47,   -1,   94,   63,   -1,   -1,   -1,
  435,   -1,   -1,  438,   -1,   -1,   -1,   -1,   -1,   63,
  336,   -1,   -1,  448,  449,  450,  451,  452,   -1,  454,
   -1,  407,  348,   -1,   -1,  639,   -1,   94,  354,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   94,  427,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  435,
   37,   -1,  438,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,  448,  449,  450,  451,  452,   -1,  454,   -1,
   -1,  506,   -1,   -1,   -1,  639,   63,   -1,  513,   37,
   -1,  407,   -1,   41,   42,   43,   -1,   45,   37,   47,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,  427,  537,   -1,   -1,   63,   -1,   94,   -1,  435,
   -1,   -1,  438,   -1,   63,   -1,   -1,   -1,   -1,   -1,
  506,   -1,  448,  449,  450,  451,  452,  513,  454,   37,
   -1,   -1,   -1,   41,   42,   43,   94,   45,   -1,   47,
   -1,   -1,   -1,   -1,   37,   94,   -1,   -1,   41,   42,
   43,  537,   45,   -1,   47,   63,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   37,
   63,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
  506,   -1,   -1,   -1,   37,   -1,   94,  513,   41,   42,
   43,   -1,   45,   -1,   47,   63,   41,   42,   43,   -1,
   45,   94,   47,   -1,  639,   -1,   -1,   37,   -1,   -1,
   63,  537,   42,   43,   44,   45,   -1,   47,   63,   37,
   -1,   -1,   -1,   41,   42,   43,   94,   45,   -1,   47,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   37,   -1,   -1,   63,   41,   42,   43,   94,
   45,   -1,   47,  639,   -1,   37,   -1,   -1,   -1,   41,
   42,   43,   -1,   45,   94,   47,   -1,   37,   63,   -1,
   -1,   -1,   42,   43,   44,   45,   94,   47,   -1,   -1,
   -1,   63,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   63,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   37,   -1,   94,  639,   -1,   42,   43,   44,   45,   -1,
   47,   37,   -1,   -1,   94,   -1,   42,   43,   44,   45,
   -1,   47,   37,   -1,   -1,   -1,   63,   42,   43,   44,
   45,   -1,   47,   -1,   37,   -1,   -1,   63,   41,   42,
   43,   -1,   45,   -1,   47,   37,   -1,   -1,   63,   41,
   42,   43,   -1,   45,   -1,   47,   37,   94,   -1,   -1,
   63,   42,   43,   44,   45,   -1,   47,   -1,   94,   -1,
   37,   63,   -1,   -1,   41,   42,   43,   -1,   45,   94,
   47,   -1,   63,   -1,   37,   -1,   -1,   -1,   41,   42,
   43,   94,   45,   37,   47,   -1,   63,   41,   42,   43,
   -1,   45,   94,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   63,   -1,   37,   94,   -1,   -1,   41,   42,   43,   63,
   45,   -1,   47,   -1,   -1,   37,   -1,   94,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   37,   63,   -1,
   -1,   94,   42,   43,   44,   45,   -1,   47,   37,   -1,
   94,   63,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   37,   -1,   -1,   63,   -1,   42,   43,   44,   45,   94,
   47,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   37,   -1,   -1,   63,   -1,   42,   43,
   44,   45,   -1,   47,   94,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   94,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   94,   41,   42,   43,   -1,   45,   37,   47,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   63,  641,  642,  643,  644,  645,  646,
  647,  648,   63,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   37,   -1,   -1,   -1,   -1,
   42,   43,   44,   45,   94,   47,   37,   -1,   -1,   -1,
   -1,   42,   43,   94,   45,   -1,   47,   37,   -1,   -1,
   -1,   63,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   58,   -1,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   93,   94,   -1,   37,   -1,   -1,   -1,   -1,
   42,   43,   -1,   45,   94,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   63,  641,  642,  643,  644,  645,  646,  647,  648,
   37,   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   94,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   63,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   94,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   63,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   94,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   37,   -1,   -1,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   63,   -1,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   37,   47,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   63,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   37,
   -1,   -1,   -1,   41,   42,   43,   -1,   45,   94,   47,
   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   63,   -1,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   63,   47,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   63,   -1,   -1,   94,   -1,   -1,   -1,
   37,   -1,   -1,   -1,   41,   42,   43,   94,   45,   -1,
   47,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   37,   94,   -1,   63,   41,   42,   43,
   -1,   45,   37,   47,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   37,   -1,   -1,   63,
   41,   42,   43,   -1,   45,   37,   47,   94,   63,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   37,   -1,
   -1,   -1,   63,   42,   43,   44,   45,   -1,   47,   -1,
   94,   63,   37,   -1,   -1,   -1,   41,   42,   43,   94,
   45,   -1,   47,   -1,   63,   -1,   37,   -1,   -1,   -1,
   41,   42,   43,   94,   45,   37,   47,   -1,   63,   41,
   42,   43,   94,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   94,   -1,   -1,   37,   -1,
   -1,   63,   -1,   42,   43,   44,   45,   -1,   47,   94,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   94,   63,   -1,   -1,   -1,   37,   -1,
   -1,   -1,   94,   42,   43,   44,   45,   37,   47,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   94,   -1,   -1,   -1,   -1,
   37,   -1,   -1,   63,   -1,   42,   43,   44,   45,   -1,
   47,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   37,   -1,   94,   63,   41,   42,   43,
   -1,   45,   37,   47,   94,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   37,   -1,   -1,   -1,   63,
   42,   43,   44,   45,   -1,   47,   37,   94,   63,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   37,   -1,
   -1,   63,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   94,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   37,   -1,   -1,   63,   41,   42,   43,   -1,   45,
   37,   47,   94,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   94,   37,   -1,   -1,   63,   -1,   42,
   43,   -1,   45,   37,   47,   94,   63,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   37,   -1,   -1,   -1,
   63,   42,   43,   -1,   45,   -1,   47,   -1,   94,   63,
   41,   42,   43,   -1,   45,   -1,   47,   94,   37,   -1,
   -1,   -1,   63,   42,   43,   44,   45,   -1,   47,   37,
   93,   94,   63,   -1,   42,   43,   44,   45,   -1,   47,
   94,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   94,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   94,   -1,   37,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   94,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   63,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,
   -1,   42,   43,   44,   45,   37,   47,   -1,   -1,   -1,
   42,   43,   44,   45,   94,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   37,   -1,
   -1,   63,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   94,   63,   37,   -1,   -1,   -1,   41,
   42,   43,   94,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   94,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   37,
   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   94,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   37,   -1,   -1,   -1,   -1,   42,   43,   44,   45,
   37,   47,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   37,
   -1,   -1,   -1,   41,   42,   43,   -1,   45,   94,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   94,   47,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   37,   -1,   63,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   63,   -1,   -1,
   -1,   37,   -1,   -1,   94,   41,   42,   43,   -1,   45,
   37,   47,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   37,   -1,   -1,   63,   94,   42,
   43,   44,   45,   37,   47,   -1,   63,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   41,   42,   43,
   63,   45,   -1,   47,   -1,   -1,   37,   -1,   94,   63,
   -1,   42,   43,   44,   45,   -1,   47,   94,   -1,   63,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   37,
   -1,   94,   63,   -1,   42,   43,   -1,   45,   37,   47,
   94,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   94,   37,   -1,   -1,   -1,   63,   42,   43,   44,   45,
   -1,   47,   37,   94,   63,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   37,   -1,   -1,   63,   41,   42,
   43,   -1,   45,   -1,   47,   93,   94,   -1,   63,   42,
   43,   44,   45,   -1,   47,   94,   -1,   37,   -1,   -1,
   63,   41,   42,   43,   -1,   45,   37,   47,   94,   -1,
   63,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   94,
   37,   -1,   -1,   63,   -1,   42,   43,   44,   45,   37,
   47,   94,   63,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   94,   37,   -1,   -1,   -1,   63,   42,   43,   44,
   45,   -1,   47,   -1,   94,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   94,   37,   -1,   -1,   -1,   63,   42,
   43,   44,   45,   -1,   47,   37,   -1,   94,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   94,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   94,
   -1,   63,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   94,   -1,   37,   63,   -1,   -1,   -1,   42,   43,
   -1,   45,   94,   47,   37,   -1,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   37,   -1,   -1,   63,
   -1,   42,   43,   44,   45,   94,   47,   37,   -1,   -1,
   63,   -1,   42,   43,   44,   45,   -1,   47,   37,   -1,
   -1,   -1,   63,   42,   43,   44,   45,   -1,   47,   93,
   94,   -1,   37,   63,   -1,   -1,   -1,   42,   43,   -1,
   45,   94,   47,   -1,   63,   -1,   37,   -1,   -1,   -1,
   -1,   42,   43,   94,   45,   37,   47,   -1,   63,   -1,
   42,   43,   44,   45,   94,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   94,   41,   42,   43,   -1,
   45,   63,   47,   -1,   -1,   37,   -1,   -1,   93,   94,
   42,   43,   44,   45,   37,   47,   -1,   -1,   63,   42,
   43,   44,   45,   94,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   94,   -1,   -1,   -1,   -1,   37,   -1,   -1,
   63,   -1,   42,   43,   -1,   45,   37,   47,   -1,   94,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   94,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   63,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   40,  529,   -1,
   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,   -1,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,   -1,   -1,  310,  311,   -1,
   -1,   -1,  315,  316,   -1,   -1,   -1,   -1,  321,   -1,
   -1,  324,  325,   -1,   -1,   -1,  329,  330,  331,   -1,
   -1,  334,   -1,   -1,   -1,  338,   -1,  340,   -1,   -1,
   -1,   -1,  345,   -1,  347,  348,   -1,  350,  351,   -1,
   -1,  354,   -1,  356,   -1,  358,  359,   -1,  361,   -1,
   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,   -1,  372,
   -1,   -1,  375,   -1,   -1,   -1,   -1,  380,  381,   -1,
   -1,   -1,  385,  386,  387,  388,   -1,  390,  391,   -1,
   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,
   -1,   -1,   -1,  406,   -1,   -1,   -1,   -1,   -1,  412,
  413,   -1,  415,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,  424,  425,   -1,  427,  428,  429,  430,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,  440,  441,   -1,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,  455,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   63,  468,   -1,   -1,   -1,   -1,
  473,  474,   -1,   -1,   -1,   -1,  479,  480,  481,  335,
  483,  484,  485,  486,   -1,   -1,   -1,   -1,   -1,   -1,
  493,  494,  495,  496,  497,   94,  499,   -1,   -1,   -1,
  503,  504,   -1,   -1,   -1,  508,   -1,   -1,  511,  512,
   41,   42,   43,  516,   45,   -1,   47,   -1,   -1,   -1,
  523,   -1,  525,  526,  527,  528,   -1,   -1,   -1,  532,
  533,   -1,   63,   -1,  537,   -1,  539,   -1,   -1,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   63,   -1,  575,  576,  577,  578,  579,  580,  581,  582,
  583,   -1,   -1,   -1,  587,  588,   41,   42,   43,   -1,
   45,  447,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  482,  630,   -1,   -1,
   -1,   -1,  635,  636,  637,  638,  639,  640,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  650,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,  554,  555,
  556,  557,   -1,  559,  560,  561,  562,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,
   -1,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   41,   42,
   43,   45,   45,   -1,   47,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,  383,   -1,   -1,   -1,   -1,   -1,
   63,  390,   -1,   -1,   -1,   -1,   -1,   -1,  397,   63,
   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,  417,   -1,
   -1,   94,  421,   -1,   -1,   -1,  425,   63,  427,   -1,
   94,   -1,  431,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,  448,
   -1,   -1,  451,   -1,   -1,   63,   -1,   -1,   94,   41,
   42,   43,   -1,   45,   63,   47,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   94,  486,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  503,   41,   42,   43,   -1,   45,
   -1,   47,   94,   41,   42,   43,   -1,   45,   -1,   47,
   94,   -1,   -1,   -1,   -1,   -1,  525,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,  541,   -1,   -1,   -1,   -1,  546,  547,  548,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  575,  576,  577,  578,
  579,  580,  581,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,
  639,  640,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  650,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,  353,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  383,
   -1,   -1,   -1,   41,   42,   43,  390,   45,   -1,   47,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   41,   42,   43,   -1,   45,   63,   47,   -1,   -1,   -1,
  414,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   63,  427,   -1,   -1,   -1,  431,  641,  642,
  643,  644,  645,  646,  647,  648,   94,   41,   42,   43,
   -1,   45,   -1,   47,  448,   -1,   -1,  451,   -1,   -1,
   -1,   -1,   -1,   94,   41,   42,   43,   -1,   45,   63,
   47,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   63,   -1,   -1,   41,
   42,   43,  486,   45,   -1,   47,   -1,   -1,  492,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  503,
   -1,   63,   41,   42,   43,   -1,   45,   94,   47,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  546,  547,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   -1,  575,  576,  577,  578,  579,  580,  581,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  638,  639,  640,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,  650,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,  353,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,  377,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,  390,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  425,   -1,  427,   41,
   42,   43,  431,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
   -1,   63,  451,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,  486,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  503,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  546,  547,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  575,  576,  577,  578,
  579,  580,  581,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,
  639,  640,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,
   -1,  650,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   63,  348,   -1,   -1,   -1,   -1,  353,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   40,   -1,   -1,   42,   43,   45,   45,   -1,   47,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   58,   -1,   -1,   -1,   -1,   63,  390,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   94,   42,   43,   44,
   45,  425,   47,  427,   -1,   -1,   -1,  431,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   63,   -1,
   -1,   -1,   -1,   -1,  448,   -1,   -1,  451,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  486,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  503,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,
   -1,   -1,  546,  547,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  575,  576,  577,  578,  579,  580,  581,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,   42,   43,   44,
   45,   -1,   47,   -1,  638,  639,  640,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  650,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  342,  343,   -1,   -1,   -1,   -1,  348,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   42,   43,   44,
   45,   63,   47,   -1,   -1,   -1,   -1,   -1,  377,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   63,   -1,
   -1,  390,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,  425,   -1,  427,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,   -1,
  298,  299,  300,  301,  302,  303,  304,  305,   -1,   -1,
  352,   -1,   -1,   -1,   -1,   -1,   -1,  486,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  373,   -1,   -1,  503,   -1,   -1,  506,  507,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  348,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   42,   43,   45,   45,   -1,   47,   -1,  546,  547,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   63,  390,   -1,   -1,  393,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  575,  576,  577,  578,
  579,  580,  581,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,  425,  470,  427,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  448,   -1,   -1,  451,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,
  639,  640,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,  650,   -1,   -1,   -1,   -1,   -1,   -1,  486,   -1,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,  503,   -1,   -1,  506,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,  546,  547,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  575,  576,  577,
  578,  579,  580,  581,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,   -1,  298,  299,  300,  301,  302,
  303,  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  638,  639,  640,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  650,   -1,   -1,  333,  334,  335,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,
  393,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  425,   -1,  427,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  447,
   -1,   40,   -1,   -1,   -1,  448,   45,   -1,  451,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,  469,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  482,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  486,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,
  503,   45,   -1,  506,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  546,  547,   -1,  554,  555,  556,  557,
   -1,  559,  560,  561,  562,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,   -1,   -1,   -1,
   -1,   -1,  575,  576,  577,  578,  579,  580,  581,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,   -1,
  298,  299,  300,  301,  302,  303,  304,  305,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  638,  639,  640,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,  650,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,
   -1,   -1,  390,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  390,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  486,   -1,
   -1,  352,   -1,   -1,   -1,  348,  349,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  503,   -1,   -1,   -1,   -1,
   -1,   -1,  373,   -1,   -1,   -1,   -1,   -1,  371,   -1,
   -1,   -1,   -1,   -1,  377,   -1,  390,   -1,   -1,   -1,
  383,   -1,  385,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  546,  547,
   -1,  404,   -1,   -1,  552,  553,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  486,   -1,   -1,
   40,   -1,  425,   -1,  427,   45,   -1,  575,  576,  577,
  578,  579,  580,  581,  503,   -1,  439,  585,  586,   -1,
   -1,   -1,   -1,   -1,   -1,  448,   -1,   -1,  451,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  471,   40,
   -1,   -1,  486,   -1,   45,   -1,   -1,  546,  547,   -1,
   -1,   -1,   -1,  552,  553,   -1,   -1,   -1,   -1,  503,
  638,  639,  640,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  650,  506,  507,   -1,  575,  576,  577,  578,
  579,  580,  581,   -1,   -1,   -1,  585,  586,   -1,   -1,
   -1,   -1,   -1,  537,   -1,  528,   -1,   -1,   -1,   -1,
   -1,   -1,  546,  547,  537,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  575,  576,  577,  578,  579,  580,  581,  571,  638,
  639,  640,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  650,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
  611,  612,  613,  614,  615,  616,  617,  618,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  638,  639,  640,   -1,  639,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  650,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,   -1,  298,  299,
  300,  301,  302,  303,  304,  305,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  317,   -1,  319,   -1,   -1,  348,  349,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  343,
  390,  371,   -1,   -1,  348,   -1,   -1,  377,   -1,   -1,
   -1,   -1,   -1,  383,   -1,  385,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,  383,
   -1,  385,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  390,
   -1,   -1,   -1,  397,   -1,  425,   -1,  427,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  439,
  414,   -1,   -1,  417,   -1,   -1,   -1,   -1,  448,   -1,
   -1,  451,   -1,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,  486,   -1,   45,   -1,
   -1,  471,   -1,   -1,  448,   -1,   -1,  451,  452,   -1,
   -1,   -1,   -1,  503,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  471,  472,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  506,  507,   -1,   -1,
   -1,   -1,   -1,   40,   -1,  486,   -1,  537,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  546,  547,  528,   -1,
   -1,  505,  503,  507,   -1,   -1,   -1,  537,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,
  524,   -1,   -1,   -1,   -1,  575,  576,  577,  578,  579,
  580,  581,   -1,  537,   -1,   -1,   -1,  541,   -1,   -1,
   -1,  571,   -1,   -1,   -1,  546,  547,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  575,  576,  577,  578,  579,  580,
  581,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,  639,
  640,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  650,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  639,   -1,  638,  639,  640,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  650,
  257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
   -1,  298,  299,  300,  301,  302,  303,  304,  305,   -1,
  257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
   -1,  298,  299,  300,  301,  302,  303,  304,  305,   -1,
   -1,   -1,  281,   -1,  283,  284,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  390,  313,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,  486,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  503,   -1,  427,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  435,   -1,   -1,  438,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,   -1,  454,   -1,   -1,   -1,  486,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  546,
  547,   -1,   -1,   -1,   -1,   -1,  503,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  575,  576,
  577,  578,  579,  580,  581,   -1,   -1,  506,   -1,   -1,
   -1,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,  546,
  547,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  537,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  575,  576,
  577,  578,  579,  580,  581,   -1,   -1,   -1,   -1,   -1,
   -1,  638,  639,  640,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  650,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  638,  639,  640,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  650,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  639,
};
#define YYFINAL 162
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 650
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,
0,0,0,0,0,"':'",0,0,"'='",0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ABS","ACOS","ASIN","ATAN","ATAN2","CEIL","COS",
"DEG","DX","DY","ERF","ERFC","EXP","FLOOR","HYPOT","INDEX","INT","INVN","INVT",
"IRAND","JDAY","JDAY0","LGAMMA","LN","LOG","LOGISTIC","MAXP","MINP","MOD",
"NORM","NORMP","PI","RAD","RAND","RNORM","SETNO","SIN","SQR","SQRT","TAN",
"INUM","VX1","VX2","VY1","VY2","WX1","WX2","WY1","WY2","DELAYP","DOUBLEBUFFER",
"DOWN","ABSOLUTE","ABORT","ACTIVATE","ACTIVE","ALT","ALTERNATE","ALTXAXIS",
"ALTYAXIS","ANGLE","ANNOTATE","APPEND","AREA","ARRANGE","ARROW","ASCENDING",
"AUTO","AUTOSCALE","AUTOTICKS","AVG","AXIS","AXES","BACKBUFFER","BACKGROUND",
"BAR","BATCH","BLOCK","BIN","BOTH","BOTTOM","BOX","BOXPLOT","CD","CELLS",
"CENTER","CHAR","CHRSTR","CLEAR","CLICK","CMAP","COLOR","COMMENT","COPY",
"CYCLE","DECIMAL","DEF","DEFAULT","DELETE","DEVICE","DESCENDING","DFT",
"DIFFERENCE","DISK","DRAW2","DROP","DXDX","DXP","DYDY","DYP","ECHO","EDIT",
"ELSE","END","ERRORBAR","EXIT","EXPONENTIAL","FALSEP","FFT","FILEP","FILL",
"FIND","FIXEDPOINT","FLUSH","FOCUS","FOLLOWS","FONTP","FOREGROUND","FORMAT",
"FRONTBUFFER","FRAMEP","GETP","GRAPH","GRAPHNO","GRAPHS","GRAPHTYPE","GRID",
"HARDCOPY","HBAR","HBOXPLOT","HGAP","HIDDEN","HORIZONTAL","HPGLL","HPGLP",
"HISTO","IF","IGNORE","IHL","IMAGE","IN","INIT","INOUT","INTEGRATE","INTERP",
"INVDFT","INVFFT","JUST","KILL","LABEL","LAYOUT","LEAVE","LEFT","LEGEND",
"LENGTH","LEVEL","LEVELS","LINE","LINESTYLE","LINETO","LINEWIDTH","LINK","LOAD",
"LOCATOR","LOCTYPE","LOGX","LOGY","LOGXY","MAJOR","MIFL","MIFP","MINOR",
"MISSINGP","MOVE","MOVE2","MOVETO","NEGATE","NO","NONE","NORMAL","NXY","OFF",
"OFFSETX","OFFSETY","ON","OP","ORIENT","OUT","PAGE","PARA","PARALLEL",
"PARAMETERS","PARAMS","PATTERN","PERIMETER","PERP","PERPENDICULAR","PIE","PIPE",
"PLACE","POINT","POLAR","POLY","POWER","PREC","PREPEND","PRINT","PS","PSCOLORP",
"PSMONOP","PSCOLORL","PSMONOL","PUSH","POP","PUTP","RAWSPICE","READ","REDRAW",
"REGRESS","REGNUM","REGIONS","RENDER","REVERSE","RIGHT","RISER","ROT","RUNAVG",
"RUNMED","RUNSTD","RUNMIN","RUNMAX","SAMPLE","SAVEALL","SCALE","SCIENTIFIC",
"SET","SETNUM","SETS","SIGN","SIZE","SKIP","SLEEP","SLICE","SMITH","SORT",
"SOURCE","SPEC","SPECIFIED","SPECTRUM","STACK","STACKEDBAR","STACKEDHBAR",
"STACKEDLINE","STAGGER","START","STARTTYPE","STATUS","STOP","STRING","SUBTITLE",
"SWAPBUFFER","SYMBOL","TICKP","TICKLABEL","TICKMARKS","TIME","TITLE","TO","TOP",
"TRUEP","TYPE","UP","VELOCITY","VERTICAL","VGAP","VIEW","WITH","WORLD","WRITE",
"X","X0","X1","XAXES","XAXIS","XCOR","XMAX","XMIN","XY","XYARC","XYBOX",
"XYBOXPLOT","XYFIXED","XYHILO","XYRT","XYSEG","XYSTRING","XYDX","XYDY","XYDXDX",
"XYDYDY","XYDXDY","XYX2Y2","XYXX","XYYY","XYZ","XYZW","XYUV","TSV","Y","Y0",
"Y1","Y2","Y3","Y4","Y5","YAXES","YAXIS","YES","YMAX","YMIN","ZEROXAXIS",
"ZEROYAXIS","ABOVE","BELOW","POLYI","POLYO","GENERAL","DDMMYY","YYMMDD",
"MMDDYY","MMYY","MMDD","MONTHDAY","DAYMONTH","MONTHS","MONTHSY","MONTHL",
"DAYOFWEEKS","DAYOFWEEKL","DAYOFYEAR","HMS","MMDDHMS","MMDDYYHMS","YYMMDDHMS",
"DEGREESLON","DEGREESMMLON","DEGREESMMSSLON","MMSSLON","DEGREESLAT",
"DEGREESMMLAT","DEGREESMMSSLAT","MMSSLAT","DOT","STAR","PLUS","CROSS","CIRCLE",
"SQUARE","DIAMOND","TRIANGLE1","TRIANGLE2","TRIANGLE3","TRIANGLE4","SPLINE",
"LANDSCAPE","PORTRAIT","FREE","FIXED","STATUSBAR","LOCATORBAR","TOOLBAR","VAR",
"NUMBER","FITPARM","OR","AND","GT","LT","LE","GE","EQ","NE","UMINUS","NOT",
};
char *yyrule[] = {
"$accept : list",
"list :",
"list : asgn '\\n'",
"list : vasgn '\\n'",
"list : rasgn '\\n'",
"list : expr '\\n'",
"list : vexpr '\\n'",
"list : parmset '\\n'",
"list : regionset '\\n'",
"list : setaxis '\\n'",
"list : setvelocity '\\n'",
"list : set_setprop '\\n'",
"list : setprint '\\n'",
"list : error '\\n'",
"setprint : PRINT printer CHRSTR",
"setprint : PRINT TO printer CHRSTR",
"setprint : PRINT TO printer",
"setprint : DEVICE NUMBER",
"setprint : HARDCOPY DEVICE NUMBER",
"setprint : HARDCOPY",
"setprint : PS LINEWIDTH NUMBER",
"printer : PSMONOP",
"printer : PSMONOL",
"printer : MIFP",
"printer : MIFL",
"printer : HPGLP",
"printer : HPGLL",
"printer : HARDCOPY",
"printer : FILEP",
"regionset : REGNUM onoff",
"regionset : REGNUM TYPE regiontype",
"regionset : REGNUM COLOR NUMBER",
"regionset : REGNUM LINESTYLE NUMBER",
"regionset : REGNUM LINEWIDTH NUMBER",
"regionset : REGNUM LINE expr ',' expr ',' expr ',' expr",
"regionset : REGNUM XY expr ',' expr",
"regionset : LINK REGNUM TO GRAPHNO",
"parmset : REDRAW",
"parmset : AUTO REDRAW onoff",
"parmset : CD CHRSTR",
"parmset : ECHO CHRSTR",
"parmset : STATUS",
"parmset : BACKGROUND COLOR NUMBER",
"parmset : CMAP NUMBER ',' NUMBER ',' NUMBER ',' NUMBER",
"parmset : EXIT",
"parmset : PAGE LAYOUT pagelayout",
"parmset : STATUSBAR onoff",
"parmset : TOOLBAR onoff",
"parmset : LOCATORBAR onoff",
"parmset : DRAW2 expr ',' expr",
"parmset : MOVE2 expr ',' expr",
"parmset : SYMBOL expr ',' expr ',' NUMBER",
"parmset : COLOR NUMBER",
"parmset : LINEWIDTH NUMBER",
"parmset : LINESTYLE NUMBER",
"parmset : WRITE STRING expr ',' expr ',' CHRSTR",
"parmset : PAGE direction",
"parmset : PAGE NUMBER",
"parmset : PAGE INOUT NUMBER",
"parmset : LINK PAGE onoff",
"parmset : DOUBLEBUFFER torf",
"parmset : FRONTBUFFER torf",
"parmset : BACKBUFFER torf",
"parmset : SWAPBUFFER",
"parmset : SLEEP NUMBER",
"parmset : DELAYP NUMBER",
"parmset : ABORT torf",
"parmset : GETP CHRSTR",
"parmset : PUTP CHRSTR",
"parmset : WITH GRAPHNO",
"parmset : WITH SETNUM",
"parmset : SETNUM LINK sourcetype CHRSTR",
"parmset : GRAPHNO '.' SETNUM LINK sourcetype CHRSTR",
"parmset : SETNUM LINK onoff",
"parmset : GRAPHNO '.' SETNUM LINK onoff",
"parmset : ACTIVATE SETNUM NUMBER",
"parmset : ACTIVATE GRAPHNO '.' SETNUM NUMBER",
"parmset : SETNUM LENGTH NUMBER",
"parmset : GRAPHNO '.' SETNUM LENGTH NUMBER",
"parmset : SETNUM POINT expr ',' expr",
"parmset : GRAPHNO '.' SETNUM POINT expr ',' expr",
"parmset : SETNUM DROP NUMBER ',' NUMBER",
"parmset : GRAPHNO '.' SETNUM DROP NUMBER ',' NUMBER",
"parmset : SORT SETNUM sorton sortdir",
"parmset : COPY SETNUM TO SETNUM",
"parmset : COPY GRAPHNO '.' SETNUM TO GRAPHNO '.' SETNUM",
"parmset : MOVE SETNUM TO SETNUM",
"parmset : MOVE GRAPHNO '.' SETNUM TO GRAPHNO '.' SETNUM",
"parmset : KILL SETNUM",
"parmset : KILL SETS",
"parmset : KILL SETNUM SAVEALL",
"parmset : KILL SETS SAVEALL",
"parmset : KILL GRAPHNO",
"parmset : KILL GRAPHS",
"parmset : FLUSH",
"parmset : ARRANGE NUMBER ',' NUMBER",
"parmset : LOAD VAR NUMBER ',' expr ',' expr",
"parmset : REGRESS '(' SETNUM ',' NUMBER ')'",
"parmset : runtype '(' SETNUM ',' NUMBER ')'",
"parmset : ffttype '(' SETNUM ',' NUMBER ')'",
"parmset : SPLINE '(' SETNUM ',' expr ',' expr ',' NUMBER ')'",
"parmset : HISTO '(' SETNUM ',' expr ',' expr ',' NUMBER ')'",
"parmset : DIFFERENCE '(' SETNUM ',' NUMBER ')'",
"parmset : INT '(' SETNUM ')'",
"parmset : AUTOSCALE",
"parmset : AUTOSCALE XAXES",
"parmset : AUTOSCALE YAXES",
"parmset : AUTOSCALE SETNUM",
"parmset : LOCATOR onoff",
"parmset : FOCUS GRAPHNO",
"parmset : FOCUS onoff",
"parmset : FOCUS SET",
"parmset : FOCUS FOLLOWS",
"parmset : FOCUS CLICK",
"parmset : SOURCE sourcetype",
"parmset : TYPE xytype",
"parmset : FORMAT formatchoice",
"parmset : READ CHRSTR",
"parmset : READ BATCH CHRSTR",
"parmset : READ BLOCK CHRSTR",
"parmset : READ BLOCK sourcetype CHRSTR",
"parmset : BLOCK xytype CHRSTR",
"parmset : READ xytype CHRSTR",
"parmset : READ xytype sourcetype CHRSTR",
"parmset : READ IMAGE CHRSTR",
"parmset : WRITE IMAGE CHRSTR",
"parmset : IMAGE XY NUMBER ',' NUMBER",
"parmset : WRITE SETNUM",
"parmset : WRITE SETNUM FORMAT CHRSTR",
"parmset : WRITE SETNUM FILEP CHRSTR",
"parmset : WRITE SETNUM FILEP CHRSTR FORMAT CHRSTR",
"parmset : SAVEALL CHRSTR",
"parmset : PUSH",
"parmset : POP",
"parmset : CYCLE",
"parmset : STACK NUMBER",
"parmset : STACK WORLD expr ',' expr ',' expr ',' expr TICKP expr ',' expr ',' expr ',' expr",
"parmset : CLEAR STACK",
"parmset : CLEAR BOX",
"parmset : WITH BOX",
"parmset : WITH BOX NUMBER",
"parmset : BOX onoff",
"parmset : BOX GRAPHNO",
"parmset : BOX expr ',' expr ',' expr ',' expr",
"parmset : BOX LOCTYPE worldview",
"parmset : BOX LINESTYLE NUMBER",
"parmset : BOX LINEWIDTH NUMBER",
"parmset : BOX COLOR NUMBER",
"parmset : BOX FILL filltype",
"parmset : BOX FILL COLOR NUMBER",
"parmset : BOX FILL PATTERN NUMBER",
"parmset : BOX DEF",
"parmset : WITH LINE",
"parmset : WITH LINE NUMBER",
"parmset : CLEAR LINE",
"parmset : LINE onoff",
"parmset : LINE GRAPHNO",
"parmset : LINE expr ',' expr ',' expr ',' expr",
"parmset : LINE LOCTYPE worldview",
"parmset : LINE LINEWIDTH NUMBER",
"parmset : LINE LINESTYLE NUMBER",
"parmset : LINE COLOR NUMBER",
"parmset : LINE ARROW NUMBER",
"parmset : LINE ARROW SIZE NUMBER",
"parmset : LINE ARROW TYPE NUMBER",
"parmset : LINE DEF",
"parmset : CLEAR STRING",
"parmset : WITH STRING",
"parmset : WITH STRING NUMBER",
"parmset : STRING onoff",
"parmset : STRING GRAPHNO",
"parmset : STRING expr ',' expr",
"parmset : STRING LOCTYPE worldview",
"parmset : STRING LINEWIDTH NUMBER",
"parmset : STRING COLOR NUMBER",
"parmset : STRING ROT NUMBER",
"parmset : STRING FONTP NUMBER",
"parmset : STRING JUST NUMBER",
"parmset : STRING CHAR SIZE NUMBER",
"parmset : STRING DEF CHRSTR",
"parmset : TIME STRING onoff",
"parmset : TIME STRING FONTP NUMBER",
"parmset : TIME STRING CHAR SIZE NUMBER",
"parmset : TIME STRING COLOR NUMBER",
"parmset : TIME STRING LINEWIDTH NUMBER",
"parmset : TIME STRING NUMBER ',' NUMBER",
"parmset : DEFAULT LINESTYLE NUMBER",
"parmset : DEFAULT LINEWIDTH NUMBER",
"parmset : DEFAULT COLOR NUMBER",
"parmset : DEFAULT CHAR SIZE NUMBER",
"parmset : DEFAULT FONTP NUMBER",
"parmset : DEFAULT FONTP SOURCE NUMBER",
"parmset : DEFAULT SYMBOL SIZE NUMBER",
"parmset : WORLD expr ',' expr ',' expr ',' expr",
"parmset : WORLD XMIN expr",
"parmset : WORLD XMAX expr",
"parmset : WORLD YMIN expr",
"parmset : WORLD YMAX expr",
"parmset : POLAR WORLD expr ',' expr",
"parmset : VIEW expr ',' expr ',' expr ',' expr",
"parmset : VIEW XMIN NUMBER",
"parmset : VIEW XMAX NUMBER",
"parmset : VIEW YMIN NUMBER",
"parmset : VIEW YMAX NUMBER",
"parmset : TITLE CHRSTR",
"parmset : TITLE FONTP NUMBER",
"parmset : TITLE SIZE NUMBER",
"parmset : TITLE COLOR NUMBER",
"parmset : TITLE LINEWIDTH NUMBER",
"parmset : SUBTITLE CHRSTR",
"parmset : SUBTITLE FONTP NUMBER",
"parmset : SUBTITLE SIZE NUMBER",
"parmset : SUBTITLE COLOR NUMBER",
"parmset : SUBTITLE LINEWIDTH NUMBER",
"parmset : GRAPHS MAXP SETS NUMBER",
"parmset : LEGEND onoff",
"parmset : LEGEND LOCTYPE worldview",
"parmset : LEGEND LAYOUT NUMBER",
"parmset : LEGEND VGAP NUMBER",
"parmset : LEGEND HGAP NUMBER",
"parmset : LEGEND LENGTH NUMBER",
"parmset : LEGEND BOX onoff",
"parmset : LEGEND BOX FILL onoff",
"parmset : LEGEND BOX FILL WITH colpat",
"parmset : LEGEND BOX FILL colpat NUMBER",
"parmset : LEGEND BOX COLOR NUMBER",
"parmset : LEGEND BOX LINESTYLE NUMBER",
"parmset : LEGEND BOX LINEWIDTH NUMBER",
"parmset : LEGEND expr ',' expr",
"parmset : LEGEND X1 expr",
"parmset : LEGEND Y1 expr",
"parmset : LEGEND CHAR SIZE NUMBER",
"parmset : LEGEND FONTP NUMBER",
"parmset : LEGEND LINESTYLE NUMBER",
"parmset : LEGEND LINEWIDTH NUMBER",
"parmset : LEGEND COLOR NUMBER",
"parmset : LEGEND STRING NUMBER CHRSTR",
"parmset : FRAMEP onoff",
"parmset : FRAMEP TYPE NUMBER",
"parmset : FRAMEP LINESTYLE NUMBER",
"parmset : FRAMEP LINEWIDTH NUMBER",
"parmset : FRAMEP COLOR NUMBER",
"parmset : FRAMEP FILL onoff",
"parmset : FRAMEP BACKGROUND COLOR NUMBER",
"parmset : GRAPHNO onoff",
"parmset : GRAPHNO LABEL onoff",
"parmset : GRAPHNO AUTOSCALE TYPE AUTO",
"parmset : GRAPHNO AUTOSCALE TYPE SPEC",
"parmset : GRAPHNO AUTOSCALE torf",
"parmset : GRAPHNO HIDDEN torf",
"parmset : GRAPHNO TYPE graphtype",
"parmset : GRAPHNO BAR SIZE NUMBER",
"parmset : GRAPHNO STACKEDBAR SIZE NUMBER",
"parmset : GRAPHNO FIXEDPOINT onoff",
"parmset : GRAPHNO FIXEDPOINT FORMAT formatchoice formatchoice",
"parmset : GRAPHNO FIXEDPOINT PREC NUMBER ',' NUMBER",
"parmset : GRAPHNO FIXEDPOINT XY expr ',' expr",
"parmset : GRAPHNO FIXEDPOINT TYPE NUMBER",
"parmset : GRAPHNO MAXP SETS NUMBER",
"setvelocity : VELOCITY SCALE NUMBER",
"setvelocity : VELOCITY LEGEND onoff",
"setvelocity : VELOCITY LINEWIDTH NUMBER",
"setvelocity : VELOCITY LINESTYLE NUMBER",
"setvelocity : VELOCITY COLOR NUMBER",
"setvelocity : VELOCITY LOCTYPE worldview",
"setvelocity : VELOCITY ARROW TYPE NUMBER",
"xytype : XY",
"xytype : XYARC",
"xytype : XYBOX",
"xytype : XYBOXPLOT",
"xytype : XYHILO",
"xytype : XYRT",
"xytype : XYSEG",
"xytype : XYSTRING",
"xytype : XYDX",
"xytype : XYDY",
"xytype : XYDXDX",
"xytype : XYDYDY",
"xytype : XYDXDY",
"xytype : XYX2Y2",
"xytype : XYXX",
"xytype : XYYY",
"xytype : XYZ",
"xytype : XYZW",
"xytype : XYUV",
"xytype : TSV",
"xytype : NXY",
"xytype : BIN",
"xytype : POLY",
"xytype : RAWSPICE",
"graphtype : XY",
"graphtype : LOGX",
"graphtype : LOGY",
"graphtype : LOGXY",
"graphtype : BAR",
"graphtype : HBAR",
"graphtype : STACKEDBAR",
"graphtype : STACKEDHBAR",
"graphtype : POLAR",
"graphtype : XYFIXED",
"graphtype : BOXPLOT",
"graphtype : HBOXPLOT",
"graphtype : SMITH",
"pagelayout : FREE",
"pagelayout : LANDSCAPE",
"pagelayout : PORTRAIT",
"pagelayout : FIXED",
"regiontype : ABOVE",
"regiontype : BELOW",
"regiontype : LEFT",
"regiontype : RIGHT",
"regiontype : POLYI",
"regiontype : POLYO",
"set_setprop : selectsets setprop",
"setprop : onoff",
"setprop : IGNORE",
"setprop : TYPE xytype",
"setprop : MISSINGP expr",
"setprop : PREC NUMBER",
"setprop : FORMAT formatchoice",
"setprop : SYMBOL expr",
"setprop : SYMBOL FILL NUMBER",
"setprop : SYMBOL CENTER torf",
"setprop : SYMBOL SIZE expr",
"setprop : SYMBOL CHAR NUMBER",
"setprop : SYMBOL SKIP NUMBER",
"setprop : SYMBOL COLOR expr",
"setprop : SYMBOL LINEWIDTH NUMBER",
"setprop : SYMBOL LINESTYLE NUMBER",
"setprop : prop NUMBER",
"setprop : FILL NUMBER",
"setprop : FILL WITH colpat",
"setprop : FILL colpat NUMBER",
"setprop : SKIP NUMBER",
"setprop : ERRORBAR LENGTH NUMBER",
"setprop : ERRORBAR TYPE opchoice",
"setprop : ERRORBAR LINEWIDTH NUMBER",
"setprop : ERRORBAR LINESTYLE NUMBER",
"setprop : ERRORBAR RISER onoff",
"setprop : ERRORBAR RISER LINEWIDTH NUMBER",
"setprop : ERRORBAR RISER LINESTYLE NUMBER",
"setprop : XYZ expr ',' expr",
"setprop : COMMENT CHRSTR",
"setaxis : axis",
"setaxis : axis axisfeature",
"setaxis : allaxes",
"setaxis : GRAPHS axis",
"setaxis : GRAPHS axis axisfeature",
"setaxis : GRAPHS allaxes",
"axis : XAXIS",
"axis : YAXIS",
"axis : ALTXAXIS",
"axis : ALTYAXIS",
"axis : ZEROXAXIS",
"axis : ZEROYAXIS",
"allaxes : AXES axesprops",
"allaxes : XAXES axesprops",
"allaxes : YAXES axesprops",
"axesprops : onoff",
"axesprops : COLOR NUMBER",
"axesprops : LINEWIDTH NUMBER",
"axesprops : LINESTYLE NUMBER",
"axesprops : FONTP NUMBER",
"axesprops : CHAR SIZE NUMBER",
"axesprops : GRID onoff",
"axisfeature : TICKP tickdesc",
"axisfeature : TICKLABEL ticklabeldesc",
"axisfeature : LABEL axislabeldesc",
"axisfeature : BAR axisbardesc",
"axisfeature : onoff",
"tickdesc : tickattr",
"tickdesc : tickdesc tickattr",
"tickattr : onoff",
"tickattr : MAJOR onoff",
"tickattr : MINOR onoff",
"tickattr : MAJOR expr",
"tickattr : MINOR expr",
"tickattr : OFFSETX expr",
"tickattr : OFFSETY expr",
"tickattr : ALT onoff",
"tickattr : MINP expr",
"tickattr : MAXP expr",
"tickattr : DEFAULT NUMBER",
"tickattr : inoutchoice",
"tickattr : LOG onoff",
"tickattr : SIZE NUMBER",
"tickattr : MAJOR SIZE NUMBER",
"tickattr : MINOR SIZE NUMBER",
"tickattr : COLOR NUMBER",
"tickattr : LINEWIDTH NUMBER",
"tickattr : MAJOR COLOR NUMBER",
"tickattr : MINOR COLOR NUMBER",
"tickattr : MAJOR LINEWIDTH NUMBER",
"tickattr : MINOR LINEWIDTH NUMBER",
"tickattr : MAJOR LINESTYLE NUMBER",
"tickattr : MINOR LINESTYLE NUMBER",
"tickattr : MAJOR GRID onoff",
"tickattr : MINOR GRID onoff",
"tickattr : OP opchoice",
"tickattr : TYPE AUTO",
"tickattr : TYPE SPEC",
"tickattr : SPEC NUMBER",
"tickattr : NUMBER ',' expr",
"ticklabeldesc : ticklabelattr",
"ticklabeldesc : ticklabeldesc ticklabelattr",
"ticklabelattr : onoff",
"ticklabelattr : TYPE AUTO",
"ticklabelattr : TYPE SPEC",
"ticklabelattr : PREC NUMBER",
"ticklabelattr : FORMAT formatchoice",
"ticklabelattr : FORMAT NUMBER",
"ticklabelattr : APPEND CHRSTR",
"ticklabelattr : PREPEND CHRSTR",
"ticklabelattr : LAYOUT HORIZONTAL",
"ticklabelattr : LAYOUT VERTICAL",
"ticklabelattr : LAYOUT SPEC",
"ticklabelattr : LOCTYPE ON",
"ticklabelattr : LOCTYPE CENTER",
"ticklabelattr : LOCTYPE LEFT",
"ticklabelattr : LOCTYPE RIGHT",
"ticklabelattr : ANGLE NUMBER",
"ticklabelattr : JUST justchoice",
"ticklabelattr : SKIP NUMBER",
"ticklabelattr : STAGGER NUMBER",
"ticklabelattr : OP opchoice",
"ticklabelattr : SIGN signchoice",
"ticklabelattr : START expr",
"ticklabelattr : STOP expr",
"ticklabelattr : START TYPE SPEC",
"ticklabelattr : START TYPE AUTO",
"ticklabelattr : STOP TYPE SPEC",
"ticklabelattr : STOP TYPE AUTO",
"ticklabelattr : VGAP NUMBER",
"ticklabelattr : HGAP NUMBER",
"ticklabelattr : CHAR SIZE NUMBER",
"ticklabelattr : FONTP NUMBER",
"ticklabelattr : COLOR NUMBER",
"ticklabelattr : LINEWIDTH NUMBER",
"ticklabelattr : NUMBER ',' CHRSTR",
"axislabeldesc : CHRSTR",
"axislabeldesc : LAYOUT PERP",
"axislabeldesc : LAYOUT PARA",
"axislabeldesc : PLACE AUTO",
"axislabeldesc : PLACE SPEC",
"axislabeldesc : PLACE NUMBER ',' NUMBER",
"axislabeldesc : JUST justchoice",
"axislabeldesc : CHAR SIZE NUMBER",
"axislabeldesc : FONTP NUMBER",
"axislabeldesc : COLOR NUMBER",
"axislabeldesc : LINEWIDTH NUMBER",
"axisbardesc : onoff",
"axisbardesc : COLOR NUMBER",
"axisbardesc : LINESTYLE NUMBER",
"axisbardesc : LINEWIDTH NUMBER",
"selectsets : GRAPHNO '.' SETNUM",
"selectsets : SETNUM",
"selectsets : SETS",
"selectsets : GRAPHNO SETS",
"selectsets : GRAPHS SETS",
"selectsets : GRAPHS SETNUM",
"prop : LINESTYLE",
"prop : LINEWIDTH",
"prop : FONTP",
"prop : COLOR",
"prop : SIZE",
"onoff : ON",
"onoff : OFF",
"colpat : COLOR",
"colpat : PATTERN",
"runtype : RUNAVG",
"runtype : RUNSTD",
"runtype : RUNMED",
"runtype : RUNMAX",
"runtype : RUNMIN",
"ffttype : DFT",
"ffttype : FFT",
"ffttype : INVDFT",
"ffttype : INVFFT",
"sourcetype : DISK",
"sourcetype : PIPE",
"filltype : PATTERN",
"filltype : COLOR",
"filltype : NONE",
"opchoice : TOP",
"opchoice : BOTTOM",
"opchoice : LEFT",
"opchoice : RIGHT",
"opchoice : BOTH",
"justchoice : RIGHT",
"justchoice : LEFT",
"justchoice : CENTER",
"extremetype : MINP",
"extremetype : MAXP",
"torf : TRUEP",
"torf : FALSEP",
"inoutchoice : IN",
"inoutchoice : OUT",
"inoutchoice : BOTH",
"formatchoice : DECIMAL",
"formatchoice : EXPONENTIAL",
"formatchoice : POWER",
"formatchoice : GENERAL",
"formatchoice : DDMMYY",
"formatchoice : MMDDYY",
"formatchoice : YYMMDD",
"formatchoice : MMYY",
"formatchoice : MMDD",
"formatchoice : MONTHDAY",
"formatchoice : DAYMONTH",
"formatchoice : MONTHS",
"formatchoice : MONTHSY",
"formatchoice : MONTHL",
"formatchoice : DAYOFWEEKS",
"formatchoice : DAYOFWEEKL",
"formatchoice : DAYOFYEAR",
"formatchoice : HMS",
"formatchoice : MMDDHMS",
"formatchoice : MMDDYYHMS",
"formatchoice : YYMMDDHMS",
"formatchoice : DEGREESLON",
"formatchoice : DEGREESMMLON",
"formatchoice : DEGREESMMSSLON",
"formatchoice : MMSSLON",
"formatchoice : DEGREESLAT",
"formatchoice : DEGREESMMLAT",
"formatchoice : DEGREESMMSSLAT",
"formatchoice : MMSSLAT",
"signchoice : NORMAL",
"signchoice : ABSOLUTE",
"signchoice : NEGATE",
"direction : UP",
"direction : DOWN",
"direction : RIGHT",
"direction : LEFT",
"direction : IN",
"direction : OUT",
"worldview : WORLD",
"worldview : VIEW",
"sortdir : ASCENDING",
"sortdir : DESCENDING",
"sorton : X",
"sorton : Y",
"vector : X",
"vector : Y",
"vector : X0",
"vector : Y0",
"vector : Y1",
"vector : Y2",
"vector : Y3",
"vector : Y4",
"vector : Y5",
"asgn : VAR '[' expr ']' '=' expr",
"asgn : vector '[' expr ']' '=' expr",
"asgn : SETNUM '.' vector '[' expr ']' '=' expr",
"asgn : SETNUM '.' SYMBOL '=' expr",
"asgn : GRAPHNO '.' SETNUM '.' vector '[' expr ']' '=' expr",
"rasgn : REGNUM '.' vector '=' expr",
"vasgn : VAR '=' vexpr",
"vasgn : vector '=' vexpr",
"vasgn : SETNUM '=' SETNUM",
"vasgn : GRAPHNO '.' SETNUM '=' SETNUM",
"vasgn : SETNUM '=' GRAPHNO '.' SETNUM",
"vasgn : GRAPHNO '.' SETNUM '=' GRAPHNO '.' SETNUM",
"vasgn : SETNUM '.' vector '=' vexpr",
"vasgn : GRAPHNO '.' SETNUM '.' vector '=' vexpr",
"vasgn : VAR '=' expr",
"vasgn : vector '=' expr",
"vasgn : SETNUM '.' vector '=' expr",
"vasgn : GRAPHNO '.' SETNUM '.' vector '=' expr",
"vexpr : VAR",
"vexpr : vector",
"vexpr : SETNUM '.' vector",
"vexpr : GRAPHNO '.' SETNUM '.' vector",
"vexpr : expr",
"vexpr : expr '+' expr",
"vexpr : vexpr '+' vexpr",
"vexpr : expr '+' vexpr",
"vexpr : vexpr '+' expr",
"vexpr : expr '-' expr",
"vexpr : vexpr '-' vexpr",
"vexpr : expr '-' vexpr",
"vexpr : vexpr '-' expr",
"vexpr : expr '*' expr",
"vexpr : vexpr '*' vexpr",
"vexpr : expr '*' vexpr",
"vexpr : vexpr '*' expr",
"vexpr : expr '/' expr",
"vexpr : vexpr '/' vexpr",
"vexpr : expr '/' vexpr",
"vexpr : vexpr '/' expr",
"vexpr : expr '^' expr",
"vexpr : expr '^' vexpr",
"vexpr : vexpr '^' expr",
"vexpr : vexpr '^' vexpr",
"vexpr : ABS '(' expr ')'",
"vexpr : ABS '(' vexpr ')'",
"vexpr : ACOS '(' vexpr ')'",
"vexpr : ASIN '(' vexpr ')'",
"vexpr : ATAN '(' vexpr ')'",
"vexpr : ATAN2 '(' vexpr ',' vexpr ')'",
"vexpr : CEIL '(' vexpr ')'",
"vexpr : COS '(' vexpr ')'",
"vexpr : DEG",
"vexpr : ERF '(' vexpr ')'",
"vexpr : ERFC '(' vexpr ')'",
"vexpr : EXP '(' vexpr ')'",
"vexpr : FLOOR '(' vexpr ')'",
"vexpr : HYPOT '(' vexpr ',' vexpr ')'",
"vexpr : HYPOT '(' expr ',' vexpr ')'",
"vexpr : HYPOT '(' vexpr ',' expr ')'",
"vexpr : HYPOT '(' expr ',' expr ')'",
"vexpr : INDEX",
"vexpr : SETNO",
"vexpr : INT '(' vexpr ')'",
"vexpr : INVN '(' vexpr ')'",
"vexpr : INVT '(' expr ',' NUMBER ')'",
"vexpr : INVT '(' vexpr ',' NUMBER ')'",
"vexpr : IRAND '(' NUMBER ')'",
"vexpr : LGAMMA '(' vexpr ')'",
"vexpr : LN '(' vexpr ')'",
"vexpr : LOG '(' vexpr ')'",
"vexpr : LOGISTIC '(' vexpr ',' expr ',' expr ')'",
"vexpr : MAXP '(' vexpr ',' vexpr ')'",
"vexpr : MINP '(' vexpr ',' vexpr ')'",
"vexpr : MOD '(' vexpr ',' vexpr ')'",
"vexpr : NORM '(' vexpr ')'",
"vexpr : NORMP '(' vexpr ')'",
"vexpr : PI",
"vexpr : RAD",
"vexpr : RAND",
"vexpr : RNORM '(' vexpr ',' vexpr ')'",
"vexpr : RNORM '(' expr ',' vexpr ')'",
"vexpr : RNORM '(' vexpr ',' expr ')'",
"vexpr : RNORM '(' expr ',' expr ')'",
"vexpr : SIN '(' vexpr ')'",
"vexpr : SQR '(' vexpr ')'",
"vexpr : SQRT '(' vexpr ')'",
"vexpr : TAN '(' vexpr ')'",
"vexpr : vexpr '?' vexpr ':' vexpr",
"vexpr : vexpr GT vexpr",
"vexpr : vexpr LT vexpr",
"vexpr : vexpr LE vexpr",
"vexpr : vexpr GE vexpr",
"vexpr : vexpr EQ vexpr",
"vexpr : vexpr NE vexpr",
"vexpr : vexpr AND vexpr",
"vexpr : vexpr OR vexpr",
"vexpr : NOT vexpr",
"vexpr : '(' vexpr ')'",
"vexpr : '-' vexpr",
"expr : NUMBER",
"expr : FITPARM",
"expr : VAR '[' expr ']'",
"expr : REGNUM '.' vector",
"expr : vector '[' expr ']'",
"expr : SETNUM '.' vector '[' expr ']'",
"expr : GRAPHNO '.' SETNUM '.' vector '[' expr ']'",
"expr : SETNUM '.' vector '.' extremetype",
"expr : GRAPHNO '.' SETNUM '.' vector '.' extremetype",
"expr : SETNUM '.' LENGTH",
"expr : SETNUM '.' vector '.' AVG",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr '%' expr",
"expr : expr '^' expr",
"expr : ABS '(' expr ')'",
"expr : ACOS '(' expr ')'",
"expr : ASIN '(' expr ')'",
"expr : ATAN '(' expr ')'",
"expr : ATAN2 '(' expr ',' expr ')'",
"expr : CEIL '(' expr ')'",
"expr : COS '(' expr ')'",
"expr : DEG",
"expr : ERF '(' expr ')'",
"expr : ERFC '(' expr ')'",
"expr : EXP '(' expr ')'",
"expr : FLOOR '(' expr ')'",
"expr : HYPOT '(' expr ',' expr ')'",
"expr : GRAPHNO '.' VX1",
"expr : GRAPHNO '.' VX2",
"expr : GRAPHNO '.' VY1",
"expr : GRAPHNO '.' VY2",
"expr : GRAPHNO '.' WX1",
"expr : GRAPHNO '.' WX2",
"expr : GRAPHNO '.' WY1",
"expr : GRAPHNO '.' WY2",
"expr : VX1",
"expr : VX2",
"expr : VY1",
"expr : VY2",
"expr : WX1",
"expr : WX2",
"expr : WY1",
"expr : WY2",
"expr : DX",
"expr : DY",
"expr : INDEX",
"expr : SETNO",
"expr : INT '(' expr ')'",
"expr : INVN '(' expr ')'",
"expr : INVT '(' expr ',' NUMBER ')'",
"expr : IRAND '(' NUMBER ')'",
"expr : JDAY '(' NUMBER ',' NUMBER ',' NUMBER ')'",
"expr : JDAY0 '(' NUMBER ',' NUMBER ',' NUMBER ',' NUMBER ',' NUMBER ',' NUMBER ')'",
"expr : LGAMMA '(' expr ')'",
"expr : LN '(' expr ')'",
"expr : LOG '(' expr ')'",
"expr : LOGISTIC '(' expr ',' expr ',' expr ')'",
"expr : MAXP '(' expr ',' expr ')'",
"expr : MINP '(' expr ',' expr ')'",
"expr : MOD '(' expr ',' expr ')'",
"expr : NORM '(' expr ')'",
"expr : NORMP '(' expr ')'",
"expr : PI",
"expr : RAD",
"expr : RAND",
"expr : RNORM '(' expr ',' expr ')'",
"expr : SIN '(' expr ')'",
"expr : SQR '(' expr ')'",
"expr : SQRT '(' expr ')'",
"expr : TAN '(' expr ')'",
"expr : expr '?' expr ':' expr",
"expr : expr GT expr",
"expr : expr LT expr",
"expr : expr LE expr",
"expr : expr GE expr",
"expr : expr EQ expr",
"expr : expr NE expr",
"expr : expr AND expr",
"expr : expr OR expr",
"expr : NOT expr",
"expr : '(' expr ')'",
"expr : '-' expr",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 3566 "pars.yacc"

void fixupstr(char *val)
{
    int vl = strlen(val);
    lowtoupper(val);
    val[vl + 1] = 0;
    val[vl] = '\n';
}

void scanner(char *s, double *x, double *y, int len, double *a, double *b, double *c, double *d, int lenscr, int i, int setno, int *errpos)
{
    interr = 0;
    whichgraph = cg;
    whichset = setno;
    if (s[0] == '#') {
	return;
    }
    pos = 0;
    aa = a;
    bb = b;
    cc = c;
    dd = d;
    xx = x;
    yy = y;
    lxy = len;
    ls = lenscr;
    setindex = i + 1;
    curset = setsetno = setno;
    strcpy(f_string, s);
    fcnt = 0;
    log_results(s);
    yyparse();
    *errpos = interr;
    for (i = 0; i < fcnt; i++) {
	cfree(freelist[i]);
	freelist[i] = NULL;
    }
}

void runbatch(char *bfile)
{
    double x, y, a, b, c, d;
    int i, setno, errpos, lcnt = 1;
    char stext[256];
    FILE *fp;
    if (strcmp("stdin", bfile)) {
	fp = fopen(bfile, "r");
    }
    else {
	fp = stdin;
    }
    if (fp == NULL) {
        fprintf(stderr, "Error opening batch file \"%s\"\n", bfile);
        exit(1);
    }
    while(fgets(stext, 255, fp) != NULL) {
        if (stext[0] == '#') {
            continue;
        }
	if (strlen(stext) == 0) {
	    continue;
	}
        lowtoupper(stext);
/* TODO check on 0, 0 here for index and setno */
        scanner(stext, &x, &y, 1, ax, bx, cx, dx, 1, 0, 0, &errpos);
        stext[0] = 0;
        if (gotparams && paramfile[0]) {
            if (!getparms(cg, paramfile)) {
            }
            gotparams = 0;
        } else if (gotread && readfile[0]) {
            if (getdata(cg, readfile, readsrc, readtype)) {
                drawgraph();
            }
            gotread = 0;
        }
    }
    if (fp != stdin) {
	fclose(fp);
    }
}

symtab_entry key[] = {
	"A", VAR,
	"A0", FITPARM,
	"A1", FITPARM,
	"A2", FITPARM,
	"A3", FITPARM,
	"A4", FITPARM,
	"A5", FITPARM,
	"A6", FITPARM,
	"A7", FITPARM,
	"A8", FITPARM,
	"A9", FITPARM,
	"ABORT", ABORT,
	"ABOVE", ABOVE,
	"ABS", ABS,
	"ABSOLUTE", ABSOLUTE,
	"ACOS", ACOS,
	"ACTIVATE", ACTIVATE,
	"ACTIVE", ACTIVE,
	"ALT", ALT,
	"ALTERNATE", ALTERNATE,
	"ALTXAXIS", ALTXAXIS,
	"ALTYAXIS", ALTYAXIS,
	"AND", AND,
	"ANGLE", ANGLE,
	"ANNOTATE", ANNOTATE,
	"APPEND", APPEND,
	"AREA", AREA,
	"ARRANGE", ARRANGE,
	"ARROW", ARROW,
	"ASCENDING", ASCENDING,
	"ASIN", ASIN,
	"ATAN", ATAN,
	"ATAN2", ATAN2,
	"AUTO", AUTO,
	"AUTOSCALE", AUTOSCALE,
	"AUTOTICKS", AUTOTICKS,
	"AVG", AVG,
	"AXES", AXES,
	"AXIS", AXIS,
	"B", VAR,
	"BACKBUFFER", BACKBUFFER,
	"BACKGROUND", BACKGROUND,
	"BAR", BAR,
	"BATCH", BATCH,
	"BELOW", BELOW,
	"BIN", BIN,
	"BLOCK", BLOCK,
	"BOTH", BOTH,
	"BOTTOM", BOTTOM,
	"BOX", BOX,
	"BOXPLOT", BOXPLOT,
	"C", VAR,
	"CD", CD,
	"CEIL", CEIL,
	"CELLS", CELLS,
	"CENTER", CENTER,
	"CHAR", CHAR,
	"CHRSTR", CHRSTR,
	"CLEAR", CLEAR,
	"CLICK", CLICK,
	"CMAP", CMAP,
	"CO", COLOR,
	"COLOR", COLOR,
	"COMMENT", COMMENT,
	"COPY", COPY,
	"COS", COS,
	"CYCLE", CYCLE,
	"D", VAR,
	"DAYMONTH", DAYMONTH,
	"DAYOFWEEKL", DAYOFWEEKL,
	"DAYOFWEEKS", DAYOFWEEKS,
	"DAYOFYEAR", DAYOFYEAR,
	"DDMMYY", DDMMYY,
	"DECIMAL", DECIMAL,
	"DEF", DEF,
	"DEFAULT", DEFAULT,
	"DEG", DEG,
	"DEGREESLAT", DEGREESLAT,
	"DEGREESLON", DEGREESLON,
	"DEGREESMMLAT", DEGREESMMLAT,
	"DEGREESMMLON", DEGREESMMLON,
	"DEGREESMMSSLAT", DEGREESMMSSLAT,
	"DEGREESMMSSLON", DEGREESMMSSLON,
	"DELAY", DELAYP,
	"DELETE", DELETE,
	"DESCENDING", DESCENDING,
	"DEVICE", DEVICE,
	"DFT", DFT,
	"DIFF", DIFFERENCE,
	"DIFFERENCE", DIFFERENCE,
	"DISK", DISK,
	"DOUBLEBUFFER", DOUBLEBUFFER,
	"DOWN", DOWN,
	"DRAW2", DRAW2,
	"DROP", DROP,
	"DX", DX,
	"DXDX", DXDX,
	"DY", DY,
	"DYDY", DYDY,
	"ECHO", ECHO,
	"EDIT", EDIT,
	"ELSE", ELSE,
	"END", END,
	"EQ", EQ,
	"ER", ERRORBAR,
	"ERF", ERF,
	"ERFC", ERFC,
	"ERRORBAR", ERRORBAR,
	"EXIT", EXIT,
	"EXP", EXP,
	"EXPONENTIAL", EXPONENTIAL,
	"FALSE", FALSEP,
	"FFT", FFT,
	"FILE", FILEP,
	"FILL", FILL,
	"FIND", FIND,
	"FIXED", FIXED,
	"FIXEDPOINT", FIXEDPOINT,
	"FLOOR", FLOOR,
	"FLUSH", FLUSH,
	"FOCUS", FOCUS,
	"FOLLOWS", FOLLOWS,
	"FONT", FONTP,
	"FOREGROUND", FOREGROUND,
	"FORMAT", FORMAT,
	"FRAME", FRAMEP,
	"FREE", FREE,
	"FRONTBUFFER", FRONTBUFFER,
	"GE", GE,
	"GENERAL", GENERAL,
	"GETP", GETP,
	"GRAPH", GRAPH,
	"GRAPHS", GRAPHS,
	"GRAPHTYPE", GRAPHTYPE,
	"GRID", GRID,
	"GT", GT,
	"HARDCOPY", HARDCOPY,
	"HBAR", HBAR,
	"HBOXPLOT", HBOXPLOT,
	"HGAP", HGAP,
	"HIDDEN", HIDDEN,
	"HISTO", HISTO,
	"HMS", HMS,
	"HORIZONTAL", HORIZONTAL,
	"HPGLL", HPGLL,
	"HPGLP", HPGLP,
	"HYPOT", HYPOT,
	"IF", IF,
	"IGNORE", IGNORE,
	"IHL", IHL,
	"IMAGE", IMAGE,
	"IN", IN,
	"INDEX", INDEX,
	"INIT", INIT,
	"INOUT", INOUT,
	"INT", INT,
	"INTEGRATE", INT,
	"INTERP", INTERP,
	"INUM", INUM,
	"INVDFT", INVDFT,
	"INVFFT", INVFFT,
	"INVN", INVN,
	"INVT", INVT,
	"IRAND", IRAND,
	"JDAY", JDAY,
	"JDAY0", JDAY0,
	"JUST", JUST,
	"KILL", KILL,
	"LABEL", LABEL,
	"LANDSCAPE", LANDSCAPE,
	"LAYOUT", LAYOUT,
	"LE", LE,
	"LEAVE", LEAVE,
	"LEFT", LEFT,
	"LEGEND", LEGEND,
	"LENGTH", LENGTH,
	"LEVEL", LEVEL,
	"LEVELS", LEVELS,
	"LGAMMA", LGAMMA,
	"LINE", LINE,
	"LINESTYLE", LINESTYLE,
	"LINETO", LINETO,
	"LINEWIDTH", LINEWIDTH,
	"LINK", LINK,
	"LN", LN,
	"LOAD", LOAD,
	"LOCATOR", LOCATOR,
	"LOCATORBAR", LOCATORBAR,
	"LOCTYPE", LOCTYPE,
	"LOG", LOG,
	"LOGISTIC", LOGISTIC,
	"LOGX", LOGX,
	"LOGXY", LOGXY,
	"LOGY", LOGY,
	"LS", LINESTYLE,
	"LT", LT,
	"LW", LINEWIDTH,
	"MAJOR", MAJOR,
	"MAX", MAXP,
	"MIFL", MIFL,
	"MIFP", MIFP,
	"MIN", MINP,
	"MINOR", MINOR,
	"MISSING", MISSINGP,
	"MMDD", MMDD,
	"MMDDHMS", MMDDHMS,
	"MMDDYY", MMDDYY,
	"MMDDYYHMS", MMDDYYHMS,
	"MMSSLAT", MMSSLAT,
	"MMSSLON", MMSSLON,
	"MMYY", MMYY,
	"MOD", MOD,
	"MONTHDAY", MONTHDAY,
	"MONTHL", MONTHL,
	"MONTHS", MONTHS,
	"MONTHSY", MONTHSY,
	"MOVE", MOVE,
	"MOVE2", MOVE2,
	"MOVETO", MOVETO,
	"NE", NE,
	"NEGATE", NEGATE,
	"NO", NO,
	"NONE", NONE,
	"NORM", NORM,
	"NORMAL", NORMAL,
	"NORMP", NORMP,
	"NOT", NOT,
	"NUMBER", NUMBER,
	"NXY", NXY,
	"OFF", OFF,
	"OFFSETX", OFFSETX,
	"OFFSETY", OFFSETY,
	"ON", ON,
	"OP", OP,
	"OR", OR,
	"ORIENT", ORIENT,
	"OUT", OUT,
	"PAGE", PAGE,
	"PARA", PARA,
	"PARALLEL", PARALLEL,
	"PARAMETERS", PARAMETERS,
	"PARAMS", PARAMS,
	"PATTERN", PATTERN,
	"PERIMETER", PERIMETER,
	"PERP", PERP,
	"PERPENDICULAR", PERPENDICULAR,
	"PI", PI,
	"PIE", PIE,
	"PIPE", PIPE,
	"PLACE", PLACE,
	"POINT", POINT,
	"POLAR", POLAR,
	"POLY", POLY,
	"POLYI", POLYI,
	"POLYO", POLYO,
	"POP", POP,
	"PORTRAIT", PORTRAIT,
	"POWER", POWER,
	"PREC", PREC,
	"PREPEND", PREPEND,
	"PRINT", PRINT,
	"PS", PS,
	"PSCOLORL", PSCOLORL,
	"PSCOLORP", PSCOLORP,
	"PSMONOL", PSMONOL,
	"PSMONOP", PSMONOP,
	"PUSH", PUSH,
	"PUTP", PUTP,
	"RAD", RAD,
	"RAND", RAND,
	"RAWSPICE", RAWSPICE,
	"READ", READ,
	"REDRAW", REDRAW,
	"REGRESS", REGRESS,
	"RENDER", RENDER,
	"REVERSE", REVERSE,
	"RIGHT", RIGHT,
	"RISER", RISER,
	"RNORM", RNORM,
	"ROT", ROT,
	"RUNAVG", RUNAVG,
	"RUNMAX", RUNMAX,
	"RUNMED", RUNMED,
	"RUNMIN", RUNMIN,
	"RUNSTD", RUNSTD,
	"SAMPLE", SAMPLE,
	"SAVEALL", SAVEALL,
	"SCALE", SCALE,
	"SCIENTIFIC", SCIENTIFIC,
	"SET", SET,
	"SETNO", SETNO,
	"SETS", SETS,
	"SIGN", SIGN,
	"SIN", SIN,
	"SIZE", SIZE,
	"SKIP", SKIP,
	"SLEEP", SLEEP,
	"SLICE", SLICE,
	"SORT", SORT,
	"SOURCE", SOURCE,
	"SPEC", SPEC,
	"SPECIFIED", SPECIFIED,
	"SPECTRUM", SPECTRUM,
	"SPLINE", SPLINE,
	"SQR", SQR,
	"SQRT", SQRT,
	"STACK", STACK,
	"STACKEDBAR", STACKEDBAR,
	"STACKEDHBAR", STACKEDHBAR,
	"STACKEDLINE", STACKEDLINE,
	"STAGGER", STAGGER,
	"START", START,
	"STARTTYPE", STARTTYPE,
	"STATUS", STATUS,
	"STATUSBAR", STATUSBAR,
	"STOP", STOP,
	"STRING", STRING,
	"SUBTITLE", SUBTITLE,
	"SWAPBUFFER", SWAPBUFFER,
	"SYMBOL", SYMBOL,
	"TAN", TAN,
	"TICK", TICKP,
	"TICKLABEL", TICKLABEL,
	"TICKMARKS", TICKMARKS,
	"TIME", TIME,
	"TITLE", TITLE,
	"TO", TO,
	"TOOLBAR", TOOLBAR,
	"TOP", TOP,
	"TRUE", TRUEP,
	"TSV", TSV,
	"TYPE", TYPE,
	"UP", UP,
	"VAR", VAR,
	"VELOCITY", VELOCITY,
	"VERTICAL", VERTICAL,
	"VGAP", VGAP,
	"VIEW", VIEW,
	"VX1", VX1,
	"VX2", VX2,
	"VY1", VY1,
	"VY2", VY2,
	"WITH", WITH,
	"WORLD", WORLD,
	"WRITE", WRITE,
	"WX1", WX1,
	"WX2", WX2,
	"WY1", WY1,
	"WY2", WY2,
	"X", X,
	"X0", X0,
	"X1", X1,
	"XAXES", XAXES,
	"XAXIS", XAXIS,
	"XCOR", XCOR,
	"XMAX", XMAX,
	"XMIN", XMIN,
	"XY", XY,
	"XYARC", XYARC,
	"XYBOX", XYBOX,
	"XYBOXPLOT", XYBOXPLOT,
	"XYDX", XYDX,
	"XYDXDX", XYDXDX,
	"XYDXDY", XYDXDY,
	"XYDY", XYDY,
	"XYDYDY", XYDYDY,
	"XYFIXED", XYFIXED,
	"XYHILO", XYHILO,
	"XYRT", XYRT,
	"XYSEG", XYSEG,
	"XYSTRING", XYSTRING,
	"XYUV", XYUV,
	"XYX2Y2", XYX2Y2,
	"XYXX", XYXX,
	"XYYY", XYYY,
	"XYZ", XYZ,
	"XYZW", XYZW,
	"Y", Y,
	"Y0", Y0,
	"Y1", Y1,
	"Y2", Y2,
	"Y3", Y3,
	"Y4", Y4,
	"Y5", Y5,
	"YAXES", YAXES,
	"YAXIS", YAXIS,
	"YES", YES,
	"YMAX", YMAX,
	"YMIN", YMIN,
	"YYMMDD", YYMMDD,
	"YYMMDDHMS", YYMMDDHMS,
	"ZEROXAXIS", ZEROXAXIS,
	"ZEROYAXIS", ZEROYAXIS,
};

int maxparms = sizeof(key) / sizeof(symtab_entry);
int maxfunc = sizeof(key) / sizeof(symtab_entry);

int findf(symtab_entry *key, char *s, int tlen)
{

    int low, high, mid;

    low = 0;
    high = tlen - 1;
    while (low <= high) {
	mid = (low + high) / 2;
	if (strcmp(s, key[mid].s) < 0) {
	    high = mid - 1;
	} else {
	    if (strcmp(s, key[mid].s) > 0) {
		low = mid + 1;
	    } else {
		return (mid);
	    }
	}
    }
    return (-1);
}

int getcharstr(void)
{
    if (pos >= strlen(f_string))
	 return EOF;
    return (f_string[pos++]);
}

void ungetchstr(void)
{
    if (pos > 0)
	pos--;
}

int yylex(void)
{
    int c, i;
    int found;
    static char s[256];
    char sbuf[256];
    char *str;

    while ((c = getcharstr()) == ' ' || c == '\t');
    if (c == EOF) {
	return (0);
    }
    if (c == '"') {
	i = 0;
	while ((c = getcharstr()) != '"' && c != EOF) {
	    if (c == '\\') {
		int ctmp;
		ctmp = getcharstr();
		if (ctmp != '"') {
		    ungetchstr();
		}
		else {
		    c = ctmp;
		}
	    }
	    s[i] = c;
	    i++;
	}
	if (c == EOF) {
	    yyerror("Nonterminating string");
	    return 0;
	}
	s[i] = '\0';
	str = (char *) malloc(strlen(s) + 1);
	strcpy(str, s);
	yylval.str = str;
	return CHRSTR;
    }
    if (c == '.' || isdigit(c)) {
	char stmp[80];
	double d;
	int i, gotdot = 0;

	i = 0;
	while (c == '.' || isdigit(c)) {
	    if (c == '.') {
		if (gotdot) {
		    yyerror("Reading number, too many dots");
	    	    return 0;
		} else {
		    gotdot = 1;
		}
	    }
	    stmp[i++] = c;
	    c = getcharstr();
	}
	if (c == 'E' || c == 'e') {
	    stmp[i++] = c;
	    c = getcharstr();
	    if (c == '+' || c == '-') {
		stmp[i++] = c;
		c = getcharstr();
	    }
	    while (isdigit(c)) {
		stmp[i++] = c;
		c = getcharstr();
	    }
	}
	if (gotdot && i == 1) {
	    ungetchstr();
	    return '.';
	}
	stmp[i] = '\0';
	ungetchstr();
	sscanf(stmp, "%lf", &d);
	yylval.val = d;
	return NUMBER;
    }
/* graphs, sets, regions resp. */
    if (c == 'G' || c == 'S' || c == 'R') {
	char stmp[80];
	double d;
	int i = 0, ctmp = c, gn, sn, rn;
	c = getcharstr();
	while (isdigit(c)) {
	    stmp[i++] = c;
	    c = getcharstr();
	}
	if (i == 0) {
	    c = ctmp;
	    ungetchstr();
	} else {
	    ungetchstr();
	    if (ctmp == 'G') {
	        stmp[i] = '\0';
		gn = atoi(stmp);
		if (gn >= 0 && gn < maxgraph) {
		    yylval.ival = gn;
		    whichgraph = gn;
		    return GRAPHNO;
		}
	    } else if (ctmp == 'S') {
	        stmp[i] = '\0';
		sn = atoi(stmp);
		if (sn >= 0 && sn < g[cg].maxplot) {
		    lxy = getsetlength(cg, sn);
		    yylval.ival = sn;
		    whichset = sn;
		    return SETNUM;
		}
	    } else if (ctmp == 'R') {
	        stmp[i] = '\0';
		rn = atoi(stmp);
		if (rn >= 0 && rn < MAXREGION) {
		    yylval.ival = rn;
		    return REGNUM;
		}
	    }
	}
    }
    if (isalpha(c)) {
	char *p = sbuf;
	int gno = -1, setno = -1, xy = -1, elno = -1;

	do {
	    *p++ = c;
	} while ((c = getcharstr()) != EOF && isalnum(c));
	ungetchstr();
	*p = '\0';
        if (debuglevel == 2) {
	    printf("->%s<-\n", sbuf);
	}
	if ((found = findf(key, sbuf, maxfunc)) >= 0) {
	    if (key[found].type == VAR) {
		switch (sbuf[0]) {
		case 'A':
		    yylval.ptr = aa;
		    return VAR;
		case 'B':
		    yylval.ptr = bb;
		    return VAR;
		case 'C':
		    yylval.ptr = cc;
		    return VAR;
		case 'D':
		    yylval.ptr = dd;
		    return VAR;
		}
	    }
	    else if (key[found].type == FITPARM) {
		int index = sbuf[1] - '0';
		yylval.val = nonl_parms[index];
		return FITPARM;
	    }
	    else { /* set up special cases */
		switch (key[found].type) {
		case XAXIS:
		    naxis = 0;
		    break;
		case YAXIS:
		    naxis = 1;
		    break;
		case ZEROXAXIS:
		    naxis = 2;
		    break;
		case ZEROYAXIS:
		    naxis = 3;
		    break;
		case ALTXAXIS:
		    naxis = 4;
		    break;
		case ALTYAXIS:
		    naxis = 5;
		    break;
		case AXES:
		    naxis = 6;
		    break;
		case XAXES:
		    naxis = 7;
		    break;
		case YAXES:
		    naxis = 8;
		    break;
		case GRAPHS:
		    yylval.ival = -1;
		    whichgraph = -1;
		    return GRAPHS;
		    break;
		case SETS:
		    yylval.ival = -1;
		    whichset = -1;
		    return SETS;
		    break;
		default:
		    break;
		}
	    }
	    yylval.func = key[found].type;
	    return key[found].type;
	} else {
	    strcat(sbuf, ": No such function or variable");
	    yyerror(sbuf);
	    return 0;
	}
    }
    switch (c) {
    case '>':
	return follow('=', GE, GT);
    case '<':
	return follow('=', LE, LT);
    case '=':
	return follow('=', EQ, '=');
    case '!':
	return follow('=', NE, NOT);
    case '|':
	return follow('|', OR, '|');
    case '&':
	return follow('&', AND, '&');
    case '\n':
	return '\n';
    default:
	return c;
    }
}

int follow(int expect, int ifyes, int ifno)
{
    int c = getcharstr();

    if (c == expect) {
	return ifyes;
    }
    ungetchstr();
    return ifno;
}

void yyerror(char *s)
{
    int i;
    char buf[256];
    sprintf(buf, "%s: %s", s, f_string);
    i = strlen(buf);
    buf[i - 1] = 0;
    errwin(buf);
    interr = 1;
}

#define C1 0.1978977093962766
#define C2 0.1352915131768107

double rnorm(double mean, double sdev)
{
    double u = drand48();

    return mean + sdev * (pow(u, C2) - pow(1.0 - u, C2)) / C1;
}

double fx(double x)
{
    return 1.0 / sqrt(2.0 * M_PI) * exp(-x * x * 0.5);
}

double normp(double b, double *s)
{
    double sum, dx, a = -8.0, fx(double x);
    int i, n = 48;

    sum = fx(a) + fx(b);
    dx = (b - a) / n;
    for (i = 1; i <= ((n - 1) / 2); i++)
	sum = sum + 4.0 * fx(a + (2.0 * i - 1.0) * dx) + 2.0 * fx(a + 2.0 * i * dx);
    sum = sum + 4.0 * fx(b - dx);
    *s = fx(b);
    return sum * dx / 3.0;
}

double invnorm(double p)
{
    double s, x, z, temp, normp(double b, double *s);

    if (p > 0.5)
	x = 1.0 - p;
    else
	x = p;
    s = sqrt(-2.0 * log(x));
    x = ((-7.49101 * s - 448.047) * s - 1266.846);
    x = x / (((s + 109.8371) * s + 748.189) * s + 498.003) + s;
    if (p < 0.5)
	x = -x;
    z = p - normp(x, &s);
    z = z / s;
    s = x * x;
    return (((((((((720.0 * s + 2556.0) * s + 1740.0) * s + 127.0) * z / 7.0 +
		 ((120.0 * s + 326.0) * s + 127.0) * x) * z / 6.0 + (24 * s + 46.0) * s + 7.0) * z / 40.0 +
	       (0.75 * s + 0.875) * x) * z + s + 0.5) * z / 3.0 + x * 0.5) * z + 1.0) * z + x + 0.832e-24 * x;
}

double invt(double p, int n)
{
    double sign, temp, a, b, c, d, x, y;

    sign = 1.0;
    if (p < 0.5) {
	p = 1.0 - p;
	sign = -1.0;
    }
    p = (1 - p) * 2;
    if (n == 2) {
	temp = sqrt(2.0 / (p * (2.0 - p)) - 2.0);
	temp = sign * temp;
	return temp;
    } else if (n == 1) {
	p = p * M_PI / 2.0;
	return sign * cos(p) / sin(p);
    } else {
	a = 1.0 / (n - 0.5);
	b = 48.0 / (a * a);
	c = ((20700 * a / b - 98.0) * a - 16.0) * a + 96.36;
	d = ((94.5 / (b + c) - 3.0) / b + 1.0) * sqrt(a * M_PI / 2.0) * n;
	x = d * p;
	y = exp((2.0 / n) * log(x));
	if (y > (0.05 + a)) {
	    x = invnorm(p * 0.5);
	    y = x * x;
	    if (n < 5)
		c = c + 0.3 * (n - 4.5) * (x + 0.6);
	    c = (((0.05 * d * x - 5.0) * x - 7.0) * x - 2.0) * x + b + c;
	    y = (((((0.4 * y + 6.3) * y + 36.0) * y + 94.5) / c - y - 3.0) / b + 1.0) * x;
	    y = a * y * y;
	    if (y > 0.002)
		y = exp(y) - 1.0;
	    else
		y = 0.5 * y * y + y;
	} else
	    y = ((1.0 / (((n + 0.6) / (n * y) - 0.089 * d - 0.822) * (n + 2.0) * 3.0) + 0.5 / (n + 4.0)) * y - 1.0) * (n + 1.0) / (n + 2.0) + 1.0 / y;
	return sign * sqrt(n * y);
    }
}

/*
 * return a pointer to the array given by v
 */
double *getvptr(int gno, int setno, int v)
{
    switch (v) {
    case X:
    case X0:
	return g[gno].p[setno].ex[0];
	break;
    case Y:
    case Y0:
	return g[gno].p[setno].ex[1];
	break;
    case Y1:
	return g[gno].p[setno].ex[2];
	break;
    case Y2:
	return g[gno].p[setno].ex[3];
	break;
    case Y3:
	return g[gno].p[setno].ex[4];
	break;
    case Y4:
	return g[gno].p[setno].ex[5];
	break;
    case Y5:
	return g[gno].p[setno].ex[6];
	break;
    }
    return NULL;
}
#line 5457 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 518 "pars.yacc"
{
	    result = yyvsp[-1].val;
	}
break;
case 6:
#line 521 "pars.yacc"
{
	    result = *yyvsp[-1].ptr;
	}
break;
case 13:
#line 530 "pars.yacc"
{
	    return 1;
	}
break;
case 14:
#line 536 "pars.yacc"
{
	    if (yyvsp[-1].pset == FILEP) {
		set_printer(FILEP, yyvsp[0].pset);
	    }
	    else {
		set_printer(yyvsp[-1].pset, yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 15:
#line 545 "pars.yacc"
{
	    if (yyvsp[-1].pset == FILEP) {
		set_printer(FILEP, yyvsp[0].pset);
	    }
	    else {
		set_printer(yyvsp[-1].pset, yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 16:
#line 554 "pars.yacc"
{
	    if (yyvsp[0].pset == FILEP) {
		set_printer(FILEP, NULL);
	    }
	    else {
		set_printer(yyvsp[0].pset, NULL);
	    }
	}
break;
case 17:
#line 562 "pars.yacc"
{
	    tdevice = (int) yyvsp[0].val;
	}
break;
case 18:
#line 565 "pars.yacc"
{
	    hdevice = (int) yyvsp[0].val;
	}
break;
case 19:
#line 568 "pars.yacc"
{
	    do_hardcopy();
	}
break;
case 20:
#line 572 "pars.yacc"
{ 
	    extern int pslwfactor; /* fudge factor for linewidths in the PS driver */
	    pslwfactor = yyvsp[0].val; 
	}
break;
case 21:
#line 579 "pars.yacc"
{ yyval.pset = GR_PS_P; }
break;
case 22:
#line 580 "pars.yacc"
{ yyval.pset = GR_PS_L; }
break;
case 23:
#line 581 "pars.yacc"
{ yyval.pset = GR_MIF_P; }
break;
case 24:
#line 582 "pars.yacc"
{ yyval.pset = GR_MIF_L; }
break;
case 25:
#line 583 "pars.yacc"
{ yyval.pset = GR_HPGL_P; }
break;
case 26:
#line 584 "pars.yacc"
{ yyval.pset = GR_HPGL_L; }
break;
case 27:
#line 585 "pars.yacc"
{ yyval.pset = hdevice; }
break;
case 28:
#line 586 "pars.yacc"
{ yyval.pset = FILEP; }
break;
case 29:
#line 590 "pars.yacc"
{
	    rg[yyvsp[-1].pset].active = yyvsp[0].pset;
	}
break;
case 30:
#line 593 "pars.yacc"
{
	    rg[yyvsp[-2].pset].type = yyvsp[0].pset;
	}
break;
case 31:
#line 596 "pars.yacc"
{
	    rg[yyvsp[-2].pset].color = checkon(COLOR, rg[yyvsp[-2].pset].color, (int) yyvsp[0].val);
	}
break;
case 32:
#line 599 "pars.yacc"
{
	    rg[yyvsp[-2].pset].lines = checkon(LINESTYLE, rg[yyvsp[-2].pset].lines, (int) yyvsp[0].val);
	}
break;
case 33:
#line 602 "pars.yacc"
{
	    rg[yyvsp[-2].pset].linew = checkon(LINEWIDTH, rg[yyvsp[-2].pset].linew, (int) yyvsp[0].val);
	}
break;
case 34:
#line 606 "pars.yacc"
{
	    rg[yyvsp[-8].pset].x1 = yyvsp[-6].val;
	    rg[yyvsp[-8].pset].y1 = yyvsp[-4].val;
	    rg[yyvsp[-8].pset].x2 = yyvsp[-2].val;
	    rg[yyvsp[-8].pset].y2 = yyvsp[0].val;
	}
break;
case 35:
#line 613 "pars.yacc"
{
	    if (rg[yyvsp[-4].pset].x == NULL || rg[yyvsp[-4].pset].n == 0) {
		rg[yyvsp[-4].pset].n = 0;
		rg[yyvsp[-4].pset].x = (double *) calloc(1, sizeof(double));
		rg[yyvsp[-4].pset].y = (double *) calloc(1, sizeof(double));
	    } else {
		rg[yyvsp[-4].pset].x = (double *) realloc(rg[yyvsp[-4].pset].x, (rg[yyvsp[-4].pset].n + 1) * sizeof(double));
		rg[yyvsp[-4].pset].y = (double *) realloc(rg[yyvsp[-4].pset].y, (rg[yyvsp[-4].pset].n + 1) * sizeof(double));
	    }
	    rg[yyvsp[-4].pset].x[rg[yyvsp[-4].pset].n] = yyvsp[-2].val;
	    rg[yyvsp[-4].pset].y[rg[yyvsp[-4].pset].n] = yyvsp[0].val;
	    rg[yyvsp[-4].pset].n++;
	}
break;
case 36:
#line 626 "pars.yacc"
{
	    rg[yyvsp[-2].pset].linkto[yyvsp[0].pset] = TRUE;
	}
break;
case 37:
#line 632 "pars.yacc"
{
	    drawgraph();
	}
break;
case 38:
#line 635 "pars.yacc"
{
	    auto_redraw = (yyvsp[0].pset == ON);
	}
break;
case 39:
#line 638 "pars.yacc"
{
	    char buf[MAXPATHLEN];
	    strcpy(buf, (char *) yyvsp[0].pset);
	    expand_tilde(buf); 
	    if (chdir(buf) >= 0) {
		strcpy(workingdir, buf);
	    	if (inwin) {
		    set_title(workingdir);
	        }
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 40:
#line 650 "pars.yacc"
{
	    if (inwin) {
		set_left_footer(yyvsp[0].pset);
	    }
	    else {
		printf("%s\n", yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 41:
#line 659 "pars.yacc"
{
	    update_stuff_status();
	}
break;
case 42:
#line 662 "pars.yacc"
{
	    setbgcolor((int) yyvsp[0].val);
	}
break;
case 43:
#line 665 "pars.yacc"
{
	    xlibsetcmap((int) yyvsp[-6].val, (int) yyvsp[-4].val, (int) yyvsp[-2].val, (int) yyvsp[0].val);
	}
break;
case 44:
#line 668 "pars.yacc"
{
	    exit(0);
	}
break;
case 45:
#line 672 "pars.yacc"
{
            set_pagelayout(yyvsp[0].pset);
        }
break;
case 46:
#line 676 "pars.yacc"
{
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
        }
break;
case 47:
#line 680 "pars.yacc"
{
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
        }
break;
case 48:
#line 684 "pars.yacc"
{
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
        }
break;
case 49:
#line 688 "pars.yacc"
{
	    if (inwin) {
		my_draw2((double) yyvsp[-2].val, (double) yyvsp[0].val);
		flush_pending();
	    }
	}
break;
case 50:
#line 694 "pars.yacc"
{
	    if (inwin) {
		my_move2((double) yyvsp[-2].val, (double) yyvsp[0].val);
	    }
	}
break;
case 51:
#line 699 "pars.yacc"
{
	    if (inwin) {
		double x = (double) yyvsp[-4].val;
		double y = (double) yyvsp[-2].val;
		drawpolysym(&x, &y, 1, (int) yyvsp[0].val, 0, 0, 1.0);
		flush_pending();
	    }
	}
break;
case 52:
#line 707 "pars.yacc"
{
	    if (inwin) {
		setcolor((int) yyvsp[0].val);
	    }
	}
break;
case 53:
#line 712 "pars.yacc"
{
	    if (inwin) {
		setlinewidth((int) yyvsp[0].val);
	    }
	}
break;
case 54:
#line 717 "pars.yacc"
{
	    if (inwin) {
		setlinestyle((int) yyvsp[0].val);
	    }
	}
break;
case 55:
#line 722 "pars.yacc"
{
	}
break;
case 56:
#line 726 "pars.yacc"
{
	    switch (yyvsp[0].pset) {
	    case UP:
		gwindup_proc();
		break;
	    case DOWN:
		gwinddown_proc();
		break;
	    case RIGHT:
		gwindright_proc();
		break;
	    case LEFT:
		gwindleft_proc();
		break;
	    case IN:
		gwindshrink_proc();
		break;
	    case OUT:
		gwindexpand_proc();
		break;
	    }
	}
break;
case 57:
#line 748 "pars.yacc"
{
	    scroll_proc((int) yyvsp[0].val);
	}
break;
case 58:
#line 751 "pars.yacc"
{
	    scrollinout_proc((int) yyvsp[0].val);
	}
break;
case 59:
#line 754 "pars.yacc"
{
	    scrolling_islinked = yyvsp[0].pset == ON;
	}
break;
case 60:
#line 757 "pars.yacc"
{
	    my_doublebuffer(yyvsp[0].pset == TRUEP);
	}
break;
case 61:
#line 760 "pars.yacc"
{
	    my_frontbuffer(yyvsp[0].pset == TRUEP);
	}
break;
case 62:
#line 763 "pars.yacc"
{
	    my_backbuffer(yyvsp[0].pset == TRUEP);
	}
break;
case 63:
#line 766 "pars.yacc"
{
	    my_swapbuffer();
	}
break;
case 64:
#line 769 "pars.yacc"
{
	    sleep((int) yyvsp[0].val);
	}
break;
case 65:
#line 772 "pars.yacc"
{	/* TODO add delay function */
	}
break;
case 66:
#line 774 "pars.yacc"
{		/* TODO add abort flag and function */
	}
break;
case 67:
#line 777 "pars.yacc"
{
	    gotparams = TRUE;
	    strcpy(paramfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 68:
#line 783 "pars.yacc"
{
	    if (!fexists((char *) yyvsp[0].pset)) {
		FILE *pp = fopen((char *) yyvsp[0].pset, "w");
		if (pp != NULL) {
		    putparms(cg, pp, 0);
		    fclose(pp);
		} else {
		    errwin("Unable to write parameter file");
		}
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 69:
#line 795 "pars.yacc"
{
	    cg = (int) yyvsp[0].pset;
	    g[cg].parmsread = TRUE;
	    change_gno = cg;
	}
break;
case 70:
#line 800 "pars.yacc"
{
	    curset = (int) yyvsp[0].pset;
	}
break;
case 71:
#line 805 "pars.yacc"
{
	    set_hotlink(cg, yyvsp[-3].pset, 1, (char *) yyvsp[0].pset, yyvsp[-1].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 72:
#line 809 "pars.yacc"
{
	    set_hotlink(yyvsp[-5].pset, yyvsp[-3].pset, 1, (char *) yyvsp[0].pset, yyvsp[-1].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 73:
#line 813 "pars.yacc"
{
	    set_hotlink(cg, yyvsp[-2].pset, yyvsp[0].pset == ON, NULL, 0);
	}
break;
case 74:
#line 816 "pars.yacc"
{
	    set_hotlink(yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset == ON, NULL, 0);
	}
break;
case 75:
#line 819 "pars.yacc"
{
	    do_activateset(cg, yyvsp[-1].pset, (int) yyvsp[0].val);
	}
break;
case 76:
#line 822 "pars.yacc"
{
	    do_activateset(yyvsp[-3].pset, yyvsp[-1].pset, (int) yyvsp[0].val);
	}
break;
case 77:
#line 825 "pars.yacc"
{
	    setlength(cg, yyvsp[-2].pset, (int) yyvsp[0].val);
	    updatesetminmax(cg, yyvsp[-2].pset);
	    update_set_status(cg, yyvsp[-2].pset);
	}
break;
case 78:
#line 830 "pars.yacc"
{
	    setlength(yyvsp[-4].pset, yyvsp[-2].pset, (int) yyvsp[0].val);
	    updatesetminmax(yyvsp[-4].pset, yyvsp[-2].pset);
	    update_set_status(yyvsp[-4].pset, yyvsp[-2].pset);
	}
break;
case 79:
#line 835 "pars.yacc"
{
	    add_point(cg, yyvsp[-4].pset, yyvsp[-2].val, yyvsp[0].val, 0.0, 0.0, XY);
	}
break;
case 80:
#line 838 "pars.yacc"
{
	    add_point(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].val, yyvsp[0].val, 0.0, 0.0, XY);
	}
break;
case 81:
#line 842 "pars.yacc"
{
	    int start = (int) yyvsp[-2].val - 1;
	    int stop = (int) yyvsp[0].val - 1;
	    int dist = stop - start + 1;
	    if (dist > 0 && start >= 0) {
	        droppoints(cg, yyvsp[-4].pset, start, stop, dist);
	    }
	}
break;
case 82:
#line 850 "pars.yacc"
{
	    int start = (int) yyvsp[-2].val - 1;
	    int stop = (int) yyvsp[0].val - 1;
	    int dist = stop - start + 1;
	    if (dist > 0 && start >= 0) {
	        droppoints(yyvsp[-6].pset, yyvsp[-4].pset, start, stop, dist);
	    }
	}
break;
case 83:
#line 858 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[-2].pset)) {
	        sortset(cg, yyvsp[-2].pset, yyvsp[-1].pset, yyvsp[0].pset == ASCENDING ? 0 : 1);
	    } else {
		errwin("Set not active!");
	    }
	}
break;
case 84:
#line 865 "pars.yacc"
{
	    do_copyset(cg, yyvsp[-2].pset, cg, yyvsp[0].pset);
	}
break;
case 85:
#line 868 "pars.yacc"
{
	    do_copyset(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	}
break;
case 86:
#line 871 "pars.yacc"
{
	    do_moveset(cg, yyvsp[-2].pset, cg, yyvsp[0].pset);
	}
break;
case 87:
#line 874 "pars.yacc"
{
	    do_moveset(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	}
break;
case 88:
#line 878 "pars.yacc"
{
	    killset(cg, yyvsp[0].pset);
	}
break;
case 89:
#line 882 "pars.yacc"
{
	    int i;
	    for (i = 0; i < g[cg].maxplot; i++) {
		killset(cg, i);
	    }
	}
break;
case 90:
#line 888 "pars.yacc"
{ softkillset(cg, yyvsp[-1].pset); }
break;
case 91:
#line 890 "pars.yacc"
{
	    int i;
	    for (i = 0; i < g[cg].maxplot; i++) {
		softkillset(cg, i);
	    }
	}
break;
case 92:
#line 896 "pars.yacc"
{ kill_graph(yyvsp[0].pset); }
break;
case 93:
#line 897 "pars.yacc"
{ kill_graph(maxgraph); }
break;
case 94:
#line 898 "pars.yacc"
{ wipeout(0); }
break;
case 95:
#line 899 "pars.yacc"
{ arrange_graphs((int) yyvsp[-2].val, (int) yyvsp[0].val); }
break;
case 96:
#line 901 "pars.yacc"
{
	    int i, ilen = (int) yyvsp[-4].val;
	    if (ilen < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (ilen > maxarr) {
		maxarr = ilen;
		init_scratch_arrays(ilen);
	    }
	    for (i = 0; i < ilen; i++) {
		yyvsp[-5].ptr[i] = yyvsp[-2].val + yyvsp[0].val * i;
	    }
	}
break;
case 97:
#line 915 "pars.yacc"
{
	    int setno = yyvsp[-3].pset, ideg = (int) yyvsp[-1].val;
	    do_regress(setno, ideg, 0, -1, 0);
	}
break;
case 98:
#line 920 "pars.yacc"
{
	    do_running_command(yyvsp[-5].pset, yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 99:
#line 924 "pars.yacc"
{
	    do_fourier_command(yyvsp[-5].pset, yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 100:
#line 928 "pars.yacc"
{
	    do_spline(yyvsp[-7].pset, yyvsp[-5].val, yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 101:
#line 932 "pars.yacc"
{
	    do_histo_command(yyvsp[-7].pset, -1, -1, yyvsp[-5].val, yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 102:
#line 936 "pars.yacc"
{
	    do_differ(yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 103:
#line 940 "pars.yacc"
{
	    do_int(yyvsp[-1].pset, 0);
	}
break;
case 104:
#line 944 "pars.yacc"
{
	    if (activeset(cg)) {
		defaultgraph(cg);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
		update_world(cg);
		drawgraph();
	    } else {
		errwin("No active sets!");
	    }
	}
break;
case 105:
#line 958 "pars.yacc"
{
	    if (activeset(cg)) {
		defaultx(cg, -1);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		update_world(cg);
		drawgraph();
	    } else {
		errwin("No active sets!");
	    }
	}
break;
case 106:
#line 970 "pars.yacc"
{
	    if (activeset(cg)) {
		defaulty(cg, -1);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
		update_world(cg);
		drawgraph();
	    } else {
		errwin("No active sets!");
	    }
	}
break;
case 107:
#line 982 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
		defaultsetgraph(cg, yyvsp[0].pset);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
		update_world(cg);
		drawgraph();
	    } else {
		errwin("Set not active");
	    }
	}
break;
case 108:
#line 996 "pars.yacc"
{
	    extern int go_locateflag;
	    go_locateflag = (yyvsp[0].pset == ON);
	}
break;
case 109:
#line 1001 "pars.yacc"
{
	    draw_focus(cg);
	    cg = (int) yyvsp[0].pset;
	    defineworld(g[cg].w.xg1, g[cg].w.yg1, g[cg].w.xg2, g[cg].w.yg2, 
			islogx(cg), islogy(cg));
	    viewport(g[cg].v.xv1, g[cg].v.yv1, g[cg].v.xv2, g[cg].v.yv2);
	    draw_focus(cg);
	    update_all(cg);
	}
break;
case 110:
#line 1010 "pars.yacc"
{
	    draw_focus_flag = yyvsp[0].pset;
	}
break;
case 111:
#line 1013 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 112:
#line 1016 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 113:
#line 1019 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 114:
#line 1022 "pars.yacc"
{
	    cursource = yyvsp[0].pset;
	}
break;
case 115:
#line 1025 "pars.yacc"
{
	    curtype = yyvsp[0].pset;
	    change_type = curtype;
	}
break;
case 116:
#line 1030 "pars.yacc"
{
	    readxformat = yyvsp[0].pset;
	}
break;
case 117:
#line 1034 "pars.yacc"
{
	    gotread = TRUE;
	    readtype = curtype;
	    readsrc = cursource;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 118:
#line 1042 "pars.yacc"
{
	    gotbatch = TRUE;
	    strcpy(batchfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 119:
#line 1048 "pars.yacc"
{
	    getdata(cg, (char *) yyvsp[0].pset, DISK, BLOCK);
	    free((char *) yyvsp[0].pset);
	}
break;
case 120:
#line 1053 "pars.yacc"
{
	    getdata(cg, (char *) yyvsp[0].pset, yyvsp[-1].pset, BLOCK);
	    free((char *) yyvsp[0].pset);
	}
break;
case 121:
#line 1058 "pars.yacc"
{
	    create_set_fromblock(cg, yyvsp[-1].pset, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 122:
#line 1063 "pars.yacc"
{
	    gotread = TRUE;
	    readtype = yyvsp[-1].pset;
	    readsrc = cursource;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 123:
#line 1071 "pars.yacc"
{
	    gotread = TRUE;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    readtype = yyvsp[-2].pset;
	    readsrc = yyvsp[-1].pset;
	    free((char *) yyvsp[0].pset);
	}
break;
case 124:
#line 1079 "pars.yacc"
{
	    read_image((char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 125:
#line 1084 "pars.yacc"
{
	    write_image((char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 126:
#line 1089 "pars.yacc"
{
	    imagex = (int) yyvsp[-2].val;
	    imagey = (int) yyvsp[0].val;
	}
break;
case 127:
#line 1094 "pars.yacc"
{
	    outputset(cg, yyvsp[0].pset, (char *) NULL, (char *) NULL);
	}
break;
case 128:
#line 1098 "pars.yacc"
{
	    outputset(cg, yyvsp[-2].pset, (char *) NULL, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 129:
#line 1103 "pars.yacc"
{
	    outputset(cg, yyvsp[-2].pset, (char *) yyvsp[0].pset, (char *) NULL);
	    free((char *) yyvsp[0].pset);
	}
break;
case 130:
#line 1108 "pars.yacc"
{
	    outputset(cg, yyvsp[-4].pset, (char *) yyvsp[-2].pset, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[-2].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 131:
#line 1114 "pars.yacc"
{
            extern char sformat[];
            do_writesets(maxgraph, -1, 1, (char *) yyvsp[0].pset, sformat);
            free((char *) yyvsp[0].pset);
        }
break;
case 132:
#line 1119 "pars.yacc"
{
	    push_world();
	}
break;
case 133:
#line 1122 "pars.yacc"
{
	    pop_world();
	}
break;
case 134:
#line 1125 "pars.yacc"
{
	    cycle_world_stack();
	}
break;
case 135:
#line 1128 "pars.yacc"
{
	    if ((int) yyvsp[0].val > 0)
		show_world_stack((int) yyvsp[0].val - 1);
	}
break;
case 136:
#line 1133 "pars.yacc"
{
	    add_world(cg, yyvsp[-14].val, yyvsp[-12].val, yyvsp[-10].val, yyvsp[-8].val, yyvsp[-6].val, yyvsp[-4].val, yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 137:
#line 1136 "pars.yacc"
{
	    clear_world_stack();
	}
break;
case 138:
#line 1139 "pars.yacc"
{
	    do_clear_boxes();
	}
break;
case 139:
#line 1142 "pars.yacc"
{
	    curbox = next_box();
	}
break;
case 140:
#line 1145 "pars.yacc"
{
	    curbox = (int) yyvsp[0].val;
	}
break;
case 141:
#line 1148 "pars.yacc"
{
	    boxes[curbox].active = yyvsp[0].pset;
	}
break;
case 142:
#line 1151 "pars.yacc"
{
	    boxes[curbox].gno = yyvsp[0].pset;
	}
break;
case 143:
#line 1155 "pars.yacc"
{
	    if (curbox >= 0 && curbox < maxboxes) {
		boxes[curbox].x1 = yyvsp[-6].val;
		boxes[curbox].y1 = yyvsp[-4].val;
		boxes[curbox].x2 = yyvsp[-2].val;
		boxes[curbox].y2 = yyvsp[0].val;
	    }
	}
break;
case 144:
#line 1163 "pars.yacc"
{
	    box_loctype = yyvsp[0].pset;
	}
break;
case 145:
#line 1166 "pars.yacc"
{
	    box_lines = checkon(LINESTYLE, box_lines, (int) yyvsp[0].val);
	}
break;
case 146:
#line 1169 "pars.yacc"
{
	    box_linew = checkon(LINEWIDTH, box_linew, (int) yyvsp[0].val);
	}
break;
case 147:
#line 1172 "pars.yacc"
{
	    box_color = checkon(COLOR, box_color, (int) yyvsp[0].val);
	}
break;
case 148:
#line 1175 "pars.yacc"
{
	    box_fill = yyvsp[0].pset;
	}
break;
case 149:
#line 1178 "pars.yacc"
{
	    box_fillcolor = checkon(COLOR, box_fillcolor, (int) yyvsp[0].val);
	}
break;
case 150:
#line 1181 "pars.yacc"
{
	    box_fillpat = checkon(PATTERN, box_fillpat, (int) yyvsp[0].val);
	}
break;
case 151:
#line 1185 "pars.yacc"
{
	    if (curbox >= 0 && curbox < maxboxes) {
		boxes[curbox].lines = box_lines;
		boxes[curbox].linew = box_linew;
		boxes[curbox].color = box_color;
		boxes[curbox].fill = box_fill;
		boxes[curbox].fillcolor = box_fillcolor;
		boxes[curbox].fillpattern = box_fillpat;
		boxes[curbox].loctype = box_loctype;
	    }
	}
break;
case 152:
#line 1196 "pars.yacc"
{
	    curline = next_line();
	}
break;
case 153:
#line 1199 "pars.yacc"
{
	    curline = (int) yyvsp[0].val;
	}
break;
case 154:
#line 1202 "pars.yacc"
{
	    do_clear_lines();
	}
break;
case 155:
#line 1205 "pars.yacc"
{
	    lines[curline].active = yyvsp[0].pset;
	}
break;
case 156:
#line 1208 "pars.yacc"
{
	    lines[curline].gno = yyvsp[0].pset;
	}
break;
case 157:
#line 1212 "pars.yacc"
{
	    lines[curline].x1 = yyvsp[-6].val;
	    lines[curline].y1 = yyvsp[-4].val;
	    lines[curline].x2 = yyvsp[-2].val;
	    lines[curline].y2 = yyvsp[0].val;
	}
break;
case 158:
#line 1218 "pars.yacc"
{
	    line_loctype = yyvsp[0].pset;
	}
break;
case 159:
#line 1221 "pars.yacc"
{
	    line_linew = checkon(LINEWIDTH, line_linew, (int) yyvsp[0].val);
	}
break;
case 160:
#line 1224 "pars.yacc"
{
	    line_lines = checkon(LINESTYLE, line_lines, (int) yyvsp[0].val);
	}
break;
case 161:
#line 1227 "pars.yacc"
{
	    line_color = checkon(COLOR, line_color, (int) yyvsp[0].val);
	}
break;
case 162:
#line 1230 "pars.yacc"
{
	    line_arrow = checkon(ARROW, line_arrow, (int) yyvsp[0].val);
	}
break;
case 163:
#line 1233 "pars.yacc"
{
	    line_asize = yyvsp[0].val;
	}
break;
case 164:
#line 1236 "pars.yacc"
{
	    line_atype = (int) yyvsp[0].val;
	}
break;
case 165:
#line 1240 "pars.yacc"
{
	    if (curline >= 0 && curline < maxlines) {
		lines[curline].lines = line_lines;
		lines[curline].linew = line_linew;
		lines[curline].color = line_color;
		lines[curline].arrow = line_arrow;
		lines[curline].asize = line_asize;
		lines[curline].atype = line_atype;
		lines[curline].loctype = line_loctype;
	    }
	}
break;
case 166:
#line 1251 "pars.yacc"
{
	    do_clear_text();
	}
break;
case 167:
#line 1254 "pars.yacc"
{ curstring = next_string(); }
break;
case 168:
#line 1255 "pars.yacc"
{ curstring = (int) yyvsp[0].val; }
break;
case 169:
#line 1256 "pars.yacc"
{ pstr[curstring].active = yyvsp[0].pset; }
break;
case 170:
#line 1257 "pars.yacc"
{ pstr[curstring].gno = yyvsp[0].pset; }
break;
case 171:
#line 1259 "pars.yacc"
{
	    pstr[curstring].x = yyvsp[-2].val;
	    pstr[curstring].y = yyvsp[0].val;
	}
break;
case 172:
#line 1263 "pars.yacc"
{ string_loctype = yyvsp[0].pset; }
break;
case 173:
#line 1264 "pars.yacc"
{ string_linew = checkon(LINEWIDTH, string_linew, (int) yyvsp[0].val); }
break;
case 174:
#line 1265 "pars.yacc"
{ string_color = checkon(COLOR, string_color, (int) yyvsp[0].val); }
break;
case 175:
#line 1266 "pars.yacc"
{ string_rot = (int) yyvsp[0].val; }
break;
case 176:
#line 1267 "pars.yacc"
{ string_font = checkon(FONTP, string_font, (int) yyvsp[0].val); }
break;
case 177:
#line 1268 "pars.yacc"
{ string_just = checkon(JUST, string_just, (int) yyvsp[0].val); }
break;
case 178:
#line 1269 "pars.yacc"
{ string_size = yyvsp[0].val; }
break;
case 179:
#line 1271 "pars.yacc"
{
	    set_plotstr_string(&pstr[curstring], (char *) yyvsp[0].pset);
	    pstr[curstring].linew = string_linew;
	    pstr[curstring].color = string_color;
	    pstr[curstring].font = string_font;
	    pstr[curstring].just = string_just;
	    pstr[curstring].loctype = string_loctype;
	    pstr[curstring].rot = string_rot;
	    pstr[curstring].charsize = string_size;
	    free((char *) yyvsp[0].pset);
	}
break;
case 180:
#line 1282 "pars.yacc"
{ timestamp.active = yyvsp[0].pset; }
break;
case 181:
#line 1283 "pars.yacc"
{ timestamp.font = checkon(FONTP, timestamp.font, (int) yyvsp[0].val); }
break;
case 182:
#line 1284 "pars.yacc"
{ timestamp.charsize = yyvsp[0].val; }
break;
case 183:
#line 1285 "pars.yacc"
{ timestamp.color = checkon(COLOR, timestamp.color, (int) yyvsp[0].val); }
break;
case 184:
#line 1286 "pars.yacc"
{ timestamp.linew = checkon(LINEWIDTH, timestamp.linew, (int) yyvsp[-1].pset); }
break;
case 185:
#line 1288 "pars.yacc"
{
	    timestamp.x = yyvsp[-2].val;
	    timestamp.y = yyvsp[0].val;
	}
break;
case 186:
#line 1292 "pars.yacc"
{
	    grdefaults.lines = (int) yyvsp[0].val;
	}
break;
case 187:
#line 1295 "pars.yacc"
{
	    grdefaults.linew = (int) yyvsp[0].val;
	}
break;
case 188:
#line 1298 "pars.yacc"
{
	    grdefaults.color = (int) yyvsp[0].val;
	}
break;
case 189:
#line 1301 "pars.yacc"
{
	    grdefaults.charsize = yyvsp[0].val;
	}
break;
case 190:
#line 1304 "pars.yacc"
{
	    grdefaults.font = (int) yyvsp[0].val;
	}
break;
case 191:
#line 1307 "pars.yacc"
{
	    grdefaults.fontsrc = (int) yyvsp[0].val;
	}
break;
case 192:
#line 1310 "pars.yacc"
{
	    grdefaults.symsize = yyvsp[0].val;
	}
break;
case 193:
#line 1314 "pars.yacc"
{
	    g[cg].w.xg1 = yyvsp[-6].val;
	    g[cg].w.yg1 = yyvsp[-4].val;
	    g[cg].w.xg2 = yyvsp[-2].val;
	    g[cg].w.yg2 = yyvsp[0].val;
	}
break;
case 194:
#line 1320 "pars.yacc"
{
	    g[cg].w.xg1 = yyvsp[0].val;
	}
break;
case 195:
#line 1323 "pars.yacc"
{
	    g[cg].w.xg2 = yyvsp[0].val;
	}
break;
case 196:
#line 1326 "pars.yacc"
{
	    g[cg].w.yg1 = yyvsp[0].val;
	}
break;
case 197:
#line 1329 "pars.yacc"
{
	    g[cg].w.yg2 = yyvsp[0].val;
	}
break;
case 198:
#line 1333 "pars.yacc"
{
            g[cg].rt.xg1 = yyvsp[-2].val;
            g[cg].rt.yg1 = yyvsp[0].val;
        }
break;
case 199:
#line 1338 "pars.yacc"
{
	    g[cg].v.xv1 = yyvsp[-6].val;
	    g[cg].v.yv1 = yyvsp[-4].val;
	    g[cg].v.xv2 = yyvsp[-2].val;
	    g[cg].v.yv2 = yyvsp[0].val;
	}
break;
case 200:
#line 1344 "pars.yacc"
{
	    g[cg].v.xv1 = yyvsp[0].val;
	}
break;
case 201:
#line 1347 "pars.yacc"
{
	    g[cg].v.xv2 = yyvsp[0].val;
	}
break;
case 202:
#line 1350 "pars.yacc"
{
	    g[cg].v.yv1 = yyvsp[0].val;
	}
break;
case 203:
#line 1353 "pars.yacc"
{
	    g[cg].v.yv2 = yyvsp[0].val;
	}
break;
case 204:
#line 1356 "pars.yacc"
{
	    set_plotstr_string(&g[cg].labs.title, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 205:
#line 1360 "pars.yacc"
{
	    g[cg].labs.title.font = checkon(FONTP, g[cg].labs.title.font, (int) yyvsp[0].val);
	}
break;
case 206:
#line 1363 "pars.yacc"
{
	    g[cg].labs.title.charsize = yyvsp[0].val;
	}
break;
case 207:
#line 1366 "pars.yacc"
{
	    g[cg].labs.title.color = checkon(COLOR, g[cg].labs.title.color, (int) yyvsp[0].val);
	}
break;
case 208:
#line 1370 "pars.yacc"
{
	    g[cg].labs.title.linew = checkon(LINEWIDTH, g[cg].labs.title.linew, (int) yyvsp[0].val);
	}
break;
case 209:
#line 1373 "pars.yacc"
{
	    set_plotstr_string(&g[cg].labs.stitle, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 210:
#line 1378 "pars.yacc"
{
	    g[cg].labs.stitle.font = checkon(FONTP, g[cg].labs.stitle.font, (int) yyvsp[0].val);
	}
break;
case 211:
#line 1381 "pars.yacc"
{
	    g[cg].labs.stitle.charsize = yyvsp[0].val;
	}
break;
case 212:
#line 1385 "pars.yacc"
{
	    g[cg].labs.stitle.color = checkon(COLOR, g[cg].labs.stitle.color, (int) yyvsp[0].val);
	}
break;
case 213:
#line 1389 "pars.yacc"
{
	    g[cg].labs.stitle.linew = checkon(LINEWIDTH, g[cg].labs.stitle.color, (int) yyvsp[0].val);
	}
break;
case 214:
#line 1392 "pars.yacc"
{
	    realloc_plots((int) yyvsp[0].val);
	}
break;
case 215:
#line 1395 "pars.yacc"
{
	    g[cg].l.active = yyvsp[0].pset;
	}
break;
case 216:
#line 1398 "pars.yacc"
{
	    g[cg].l.loctype = yyvsp[0].pset;
	}
break;
case 217:
#line 1401 "pars.yacc"
{
	    g[cg].l.layout = (int) yyvsp[0].val;
	}
break;
case 218:
#line 1404 "pars.yacc"
{
	    g[cg].l.vgap = (int) yyvsp[0].val;
	}
break;
case 219:
#line 1407 "pars.yacc"
{
	    g[cg].l.hgap = (int) yyvsp[0].val;
	}
break;
case 220:
#line 1410 "pars.yacc"
{
	    g[cg].l.len = (int) yyvsp[0].val;
	}
break;
case 221:
#line 1413 "pars.yacc"
{
	    g[cg].l.box = yyvsp[0].pset;
	}
break;
case 222:
#line 1416 "pars.yacc"
{
	    g[cg].l.boxfill = yyvsp[0].pset;
	}
break;
case 223:
#line 1419 "pars.yacc"
{
	    g[cg].l.boxfillusing = yyvsp[0].pset;
	}
break;
case 224:
#line 1423 "pars.yacc"
{
	    if (yyvsp[-1].pset == COLOR) {
		g[cg].l.boxfillcolor = (int) yyvsp[0].val;
	    } else {
		g[cg].l.boxfillpat = (int) yyvsp[0].val;
	    }
	}
break;
case 225:
#line 1430 "pars.yacc"
{
	    g[cg].l.boxlcolor = checkon(COLOR, g[cg].l.boxlcolor, (int) yyvsp[0].val);
	}
break;
case 226:
#line 1433 "pars.yacc"
{
	    g[cg].l.boxlines = checkon(LINESTYLE, g[cg].l.boxlines, (int) yyvsp[0].val);
	}
break;
case 227:
#line 1436 "pars.yacc"
{
	    g[cg].l.boxlinew = checkon(LINEWIDTH, g[cg].l.boxlinew, (int) yyvsp[0].val);
	}
break;
case 228:
#line 1439 "pars.yacc"
{
	    g[cg].l.legx = yyvsp[-2].val;
	    g[cg].l.legy = yyvsp[0].val;
	}
break;
case 229:
#line 1443 "pars.yacc"
{
	    g[cg].l.legx = yyvsp[0].val;
	}
break;
case 230:
#line 1446 "pars.yacc"
{
	    g[cg].l.legy = yyvsp[0].val;
	}
break;
case 231:
#line 1449 "pars.yacc"
{
	    g[cg].l.charsize = yyvsp[0].val;
	}
break;
case 232:
#line 1452 "pars.yacc"
{
	    g[cg].l.font = checkon(FONTP, g[cg].l.font, (int) yyvsp[0].val);
	}
break;
case 233:
#line 1455 "pars.yacc"
{
	    g[cg].l.lines = checkon(LINESTYLE, g[cg].l.lines, (int) yyvsp[0].val);
	}
break;
case 234:
#line 1458 "pars.yacc"
{
	    g[cg].l.linew = checkon(LINEWIDTH, g[cg].l.linew, (int) yyvsp[0].val);
	}
break;
case 235:
#line 1461 "pars.yacc"
{
	    g[cg].l.color = checkon(COLOR, g[cg].l.color, (int) yyvsp[0].val);
	}
break;
case 236:
#line 1464 "pars.yacc"
{
	    strcpy(g[cg].p[(int) yyvsp[-1].val].lstr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 237:
#line 1468 "pars.yacc"
{
	    g[cg].f.active = yyvsp[0].pset;
	}
break;
case 238:
#line 1471 "pars.yacc"
{
	    g[cg].f.type = (int) yyvsp[0].val;
	}
break;
case 239:
#line 1474 "pars.yacc"
{
	    g[cg].f.lines = checkon(LINESTYLE, g[cg].f.lines, (int) yyvsp[0].val);
	}
break;
case 240:
#line 1477 "pars.yacc"
{
	    g[cg].f.linew = checkon(LINEWIDTH, g[cg].f.linew, (int) yyvsp[0].val);
	}
break;
case 241:
#line 1480 "pars.yacc"
{
	    g[cg].f.color = checkon(COLOR, g[cg].f.color, (int) yyvsp[0].val);
	}
break;
case 242:
#line 1483 "pars.yacc"
{ g[cg].f.fillbg = yyvsp[0].pset; }
break;
case 243:
#line 1484 "pars.yacc"
{ g[cg].f.bgcolor = (int) yyvsp[0].val; }
break;
case 244:
#line 1485 "pars.yacc"
{ g[yyvsp[-1].pset].active = yyvsp[0].pset; }
break;
case 245:
#line 1486 "pars.yacc"
{ g[yyvsp[-2].pset].label = yyvsp[0].pset; }
break;
case 246:
#line 1487 "pars.yacc"
{ g[yyvsp[-3].pset].auto_type = yyvsp[0].pset; }
break;
case 247:
#line 1488 "pars.yacc"
{ g[yyvsp[-3].pset].auto_type = yyvsp[0].pset; }
break;
case 248:
#line 1489 "pars.yacc"
{ g[yyvsp[-2].pset].parmsread = (yyvsp[0].pset == FALSEP); }
break;
case 249:
#line 1490 "pars.yacc"
{ g[yyvsp[-2].pset].hidden = (yyvsp[0].pset == TRUEP); }
break;
case 250:
#line 1491 "pars.yacc"
{ g[yyvsp[-2].pset].type = yyvsp[0].pset; }
break;
case 251:
#line 1492 "pars.yacc"
{ g[yyvsp[-3].pset].barwid = yyvsp[0].val; }
break;
case 252:
#line 1493 "pars.yacc"
{ g[yyvsp[-3].pset].sbarwid = yyvsp[0].val; }
break;
case 253:
#line 1494 "pars.yacc"
{ g[yyvsp[-2].pset].pointset = (yyvsp[0].pset == ON); }
break;
case 254:
#line 1496 "pars.yacc"
{
	    g[yyvsp[-4].pset].fx = yyvsp[-1].pset;
	    g[yyvsp[-4].pset].fy = yyvsp[0].pset;
	}
break;
case 255:
#line 1501 "pars.yacc"
{
	    g[yyvsp[-5].pset].px = yyvsp[-2].val;
	    g[yyvsp[-5].pset].py = yyvsp[0].val;
	}
break;
case 256:
#line 1506 "pars.yacc"
{
	    g[yyvsp[-5].pset].dsx = yyvsp[-2].val;
	    g[yyvsp[-5].pset].dsy = yyvsp[0].val;
	}
break;
case 257:
#line 1510 "pars.yacc"
{ g[yyvsp[-3].pset].pt_type = (int) yyvsp[0].val; }
break;
case 258:
#line 1511 "pars.yacc"
{ realloc_graph_plots(yyvsp[-3].pset, (int) yyvsp[0].val); }
break;
case 259:
#line 1515 "pars.yacc"
{ g[cg].vp.vscale = yyvsp[0].val; }
break;
case 260:
#line 1516 "pars.yacc"
{ g[cg].vp.active = yyvsp[0].pset; }
break;
case 261:
#line 1517 "pars.yacc"
{ g[cg].vp.linew = (int) yyvsp[0].val; }
break;
case 262:
#line 1518 "pars.yacc"
{ g[cg].vp.lines = (int) yyvsp[0].val; }
break;
case 263:
#line 1519 "pars.yacc"
{ g[cg].vp.color = (int) yyvsp[0].val; }
break;
case 264:
#line 1520 "pars.yacc"
{ g[cg].vp.loctype = yyvsp[0].pset; }
break;
case 265:
#line 1521 "pars.yacc"
{ g[cg].vp.arrowtype = (int) yyvsp[0].val; }
break;
case 266:
#line 1525 "pars.yacc"
{ yyval.pset = XY; }
break;
case 267:
#line 1526 "pars.yacc"
{ yyval.pset = XYARC; }
break;
case 268:
#line 1527 "pars.yacc"
{ yyval.pset = XYBOX; }
break;
case 269:
#line 1528 "pars.yacc"
{ yyval.pset = XYBOXPLOT; }
break;
case 270:
#line 1529 "pars.yacc"
{ yyval.pset = XYHILO; }
break;
case 271:
#line 1530 "pars.yacc"
{ yyval.pset = XYRT; }
break;
case 272:
#line 1531 "pars.yacc"
{ yyval.pset = XYSEG; }
break;
case 273:
#line 1532 "pars.yacc"
{ yyval.pset = XYSTRING; }
break;
case 274:
#line 1533 "pars.yacc"
{ yyval.pset = XYDX; }
break;
case 275:
#line 1534 "pars.yacc"
{ yyval.pset = XYDY; }
break;
case 276:
#line 1535 "pars.yacc"
{ yyval.pset = XYDXDX; }
break;
case 277:
#line 1536 "pars.yacc"
{ yyval.pset = XYDYDY; }
break;
case 278:
#line 1537 "pars.yacc"
{ yyval.pset = XYDXDY; }
break;
case 279:
#line 1538 "pars.yacc"
{ yyval.pset = XYX2Y2; }
break;
case 280:
#line 1539 "pars.yacc"
{ yyval.pset = XYXX; }
break;
case 281:
#line 1540 "pars.yacc"
{ yyval.pset = XYYY; }
break;
case 282:
#line 1541 "pars.yacc"
{ yyval.pset = XYZ; }
break;
case 283:
#line 1542 "pars.yacc"
{ yyval.pset = XYZW; }
break;
case 284:
#line 1543 "pars.yacc"
{ yyval.pset = XYUV; }
break;
case 285:
#line 1544 "pars.yacc"
{ yyval.pset = TSV; }
break;
case 286:
#line 1545 "pars.yacc"
{ yyval.pset = NXY; }
break;
case 287:
#line 1546 "pars.yacc"
{ yyval.pset = BIN; }
break;
case 288:
#line 1547 "pars.yacc"
{ yyval.pset = POLY; }
break;
case 289:
#line 1548 "pars.yacc"
{ yyval.pset = RAWSPICE; }
break;
case 290:
#line 1552 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 291:
#line 1553 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 292:
#line 1554 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 293:
#line 1555 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 294:
#line 1556 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 295:
#line 1557 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 296:
#line 1558 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 297:
#line 1559 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 298:
#line 1560 "pars.yacc"
{ yyval.pset = XY;		/* not active */ }
break;
case 299:
#line 1561 "pars.yacc"
{ yyval.pset = XY;		/* not active */ }
break;
case 300:
#line 1562 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 301:
#line 1563 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 302:
#line 1564 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 303:
#line 1568 "pars.yacc"
{ yyval.pset = FREE; }
break;
case 304:
#line 1569 "pars.yacc"
{ yyval.pset = LANDSCAPE; }
break;
case 305:
#line 1570 "pars.yacc"
{ yyval.pset = PORTRAIT; }
break;
case 306:
#line 1571 "pars.yacc"
{ yyval.pset = FIXED; }
break;
case 314:
#line 1599 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 315:
#line 1602 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 316:
#line 1605 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, TYPE, yyvsp[0].pset, 0);
	}
break;
case 317:
#line 1608 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, MISSINGP, yyvsp[0].val, 0);
	}
break;
case 318:
#line 1611 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, PREC, (int) yyvsp[0].val, 0);
	}
break;
case 319:
#line 1614 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FORMAT, yyvsp[0].pset, 0);
	}
break;
case 320:
#line 1617 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, TYPE, (int) yyvsp[0].val, 0);
	}
break;
case 321:
#line 1620 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, FILL, (int) yyvsp[0].val, 0);
	}
break;
case 322:
#line 1623 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, CENTER, (yyvsp[0].pset == TRUEP), 0);
	}
break;
case 323:
#line 1626 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, SIZE, yyvsp[0].val, 0);
	}
break;
case 324:
#line 1629 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, CHAR, (int) yyvsp[0].val, 0);
	}
break;
case 325:
#line 1632 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, SKIP, (int) yyvsp[0].val, 0);
	}
break;
case 326:
#line 1635 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, COLOR, (int) yyvsp[0].val, 0);
	}
break;
case 327:
#line 1638 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 328:
#line 1641 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 329:
#line 1644 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, yyvsp[-1].pset, (int) yyvsp[0].val, 0);
	}
break;
case 330:
#line 1647 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, TYPE, (int) yyvsp[0].val, 0);
	}
break;
case 331:
#line 1650 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, WITH, yyvsp[0].pset, 0);
	}
break;
case 332:
#line 1653 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, yyvsp[-1].pset, (int) yyvsp[0].val, 0);
	}
break;
case 333:
#line 1656 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SKIP, (int) yyvsp[0].val, 0);
	}
break;
case 334:
#line 1659 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LENGTH, yyvsp[0].val, 0);
	}
break;
case 335:
#line 1662 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, TYPE, yyvsp[0].pset, 0);
	}
break;
case 336:
#line 1665 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 337:
#line 1668 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 338:
#line 1671 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 339:
#line 1674 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 340:
#line 1677 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 341:
#line 1680 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, XYZ, yyvsp[-2].val, yyvsp[0].val, 0);
	}
break;
case 342:
#line 1683 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, COMMENT, (char *) yyvsp[0].pset, 0);
	    free((char *) yyvsp[0].pset);
	}
break;
case 358:
#line 1714 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[0].pset, 0.0);
	}
break;
case 359:
#line 1717 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 360:
#line 1720 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 361:
#line 1723 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 362:
#line 1726 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 363:
#line 1729 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-2].pset, yyvsp[0].val);
	}
break;
case 364:
#line 1732 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].pset);
	}
break;
case 369:
#line 1742 "pars.yacc"
{
	    g[cg].t[naxis].active = yyvsp[0].pset;
	}
break;
case 372:
#line 1754 "pars.yacc"
{
	    g[cg].t[naxis].t_flag = yyvsp[0].pset;
	    g[cg].t[naxis].t_mflag = yyvsp[0].pset;
	}
break;
case 373:
#line 1758 "pars.yacc"
{
	    g[cg].t[naxis].t_flag = yyvsp[0].pset;
	}
break;
case 374:
#line 1761 "pars.yacc"
{
	    g[cg].t[naxis].t_mflag = yyvsp[0].pset;
	}
break;
case 375:
#line 1764 "pars.yacc"
{
	    g[cg].t[naxis].tmajor = yyvsp[0].val;
	}
break;
case 376:
#line 1767 "pars.yacc"
{
	    g[cg].t[naxis].tminor = yyvsp[0].val;
	}
break;
case 377:
#line 1770 "pars.yacc"
{
	    g[cg].t[naxis].offsx = yyvsp[0].val;
	}
break;
case 378:
#line 1773 "pars.yacc"
{
	    g[cg].t[naxis].offsy = yyvsp[0].val;
	}
break;
case 379:
#line 1776 "pars.yacc"
{
	    g[cg].t[naxis].alt = yyvsp[0].pset;
	}
break;
case 380:
#line 1779 "pars.yacc"
{
	    g[cg].t[naxis].tmin = yyvsp[0].val;
	}
break;
case 381:
#line 1782 "pars.yacc"
{
	    g[cg].t[naxis].tmax = yyvsp[0].val;
	}
break;
case 382:
#line 1785 "pars.yacc"
{
	    g[cg].t[naxis].t_num = (int) yyvsp[0].val;
	}
break;
case 383:
#line 1788 "pars.yacc"
{
	    g[cg].t[naxis].t_inout = yyvsp[0].pset;
	}
break;
case 384:
#line 1791 "pars.yacc"
{
	    g[cg].t[naxis].t_log = yyvsp[0].pset;
	}
break;
case 385:
#line 1794 "pars.yacc"
{
	    g[cg].t[naxis].t_size = yyvsp[0].val;
	}
break;
case 386:
#line 1797 "pars.yacc"
{
	    g[cg].t[naxis].t_size = yyvsp[0].val;
	}
break;
case 387:
#line 1800 "pars.yacc"
{
	    g[cg].t[naxis].t_msize = yyvsp[0].val;
	}
break;
case 388:
#line 1803 "pars.yacc"
{
	    g[cg].t[naxis].t_color = g[cg].t[naxis].t_mcolor = (int) yyvsp[0].val;
	}
break;
case 389:
#line 1806 "pars.yacc"
{
	    g[cg].t[naxis].t_linew = g[cg].t[naxis].t_mlinew = (int) yyvsp[0].val;
	}
break;
case 390:
#line 1809 "pars.yacc"
{
	    g[cg].t[naxis].t_color = (int) yyvsp[0].val;
	}
break;
case 391:
#line 1812 "pars.yacc"
{
	    g[cg].t[naxis].t_mcolor = (int) yyvsp[0].val;
	}
break;
case 392:
#line 1815 "pars.yacc"
{
	    g[cg].t[naxis].t_linew = (int) yyvsp[0].val;
	}
break;
case 393:
#line 1818 "pars.yacc"
{
	    g[cg].t[naxis].t_mlinew = (int) yyvsp[0].val;
	}
break;
case 394:
#line 1821 "pars.yacc"
{
	    g[cg].t[naxis].t_lines = (int) yyvsp[0].val;
	}
break;
case 395:
#line 1824 "pars.yacc"
{
	    g[cg].t[naxis].t_mlines = (int) yyvsp[0].val;
	}
break;
case 396:
#line 1827 "pars.yacc"
{
	    g[cg].t[naxis].t_gridflag = yyvsp[0].pset;
	}
break;
case 397:
#line 1830 "pars.yacc"
{
	    g[cg].t[naxis].t_mgridflag = yyvsp[0].pset;
	}
break;
case 398:
#line 1833 "pars.yacc"
{
	    g[cg].t[naxis].t_op = yyvsp[0].pset;
	}
break;
case 399:
#line 1836 "pars.yacc"
{
	    g[cg].t[naxis].t_type = AUTO;
	}
break;
case 400:
#line 1839 "pars.yacc"
{
	    g[cg].t[naxis].t_type = SPEC;
	}
break;
case 401:
#line 1842 "pars.yacc"
{
	    g[cg].t[naxis].t_spec = (int) yyvsp[0].val;
	}
break;
case 402:
#line 1845 "pars.yacc"
{
	    g[cg].t[naxis].t_specloc[(int) yyvsp[-2].val] = yyvsp[0].val;
	}
break;
case 405:
#line 1856 "pars.yacc"
{
	    g[cg].t[naxis].tl_flag = yyvsp[0].pset;
	}
break;
case 406:
#line 1859 "pars.yacc"
{
	    g[cg].t[naxis].tl_type = AUTO;
	}
break;
case 407:
#line 1862 "pars.yacc"
{
	    g[cg].t[naxis].tl_type = SPEC;
	}
break;
case 408:
#line 1865 "pars.yacc"
{
	    g[cg].t[naxis].tl_prec = (int) yyvsp[0].val;
	}
break;
case 409:
#line 1868 "pars.yacc"
{
	    g[cg].t[naxis].tl_format = yyvsp[0].pset;
	}
break;
case 410:
#line 1871 "pars.yacc"
{
	    g[cg].t[naxis].tl_format = yyvsp[0].val;
	}
break;
case 411:
#line 1874 "pars.yacc"
{
	    strcpy(g[cg].t[naxis].tl_appstr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 412:
#line 1878 "pars.yacc"
{
	    strcpy(g[cg].t[naxis].tl_prestr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 413:
#line 1882 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = HORIZONTAL;
	}
break;
case 414:
#line 1885 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = VERTICAL;
	}
break;
case 415:
#line 1888 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = SPEC;
	}
break;
case 416:
#line 1891 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = ON;
	}
break;
case 417:
#line 1894 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = CENTER;
	}
break;
case 418:
#line 1897 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = LEFT;
	}
break;
case 419:
#line 1900 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = RIGHT;
	}
break;
case 420:
#line 1903 "pars.yacc"
{
	    g[cg].t[naxis].tl_angle = (int) yyvsp[0].val;
	}
break;
case 421:
#line 1906 "pars.yacc"
{
	    g[cg].t[naxis].tl_just = (int) yyvsp[0].pset;
	}
break;
case 422:
#line 1909 "pars.yacc"
{
	    g[cg].t[naxis].tl_skip = (int) yyvsp[0].val;
	}
break;
case 423:
#line 1912 "pars.yacc"
{
	    g[cg].t[naxis].tl_staggered = (int) yyvsp[0].val;
	}
break;
case 424:
#line 1915 "pars.yacc"
{
	    g[cg].t[naxis].tl_op = yyvsp[0].pset;
	}
break;
case 425:
#line 1918 "pars.yacc"
{
	    g[cg].t[naxis].tl_sign = yyvsp[0].pset;
	}
break;
case 426:
#line 1921 "pars.yacc"
{
	    g[cg].t[naxis].tl_start = yyvsp[0].val;
	}
break;
case 427:
#line 1924 "pars.yacc"
{
	    g[cg].t[naxis].tl_stop = yyvsp[0].val;
	}
break;
case 428:
#line 1927 "pars.yacc"
{
	    g[cg].t[naxis].tl_starttype = (int) yyvsp[0].pset;
	}
break;
case 429:
#line 1930 "pars.yacc"
{
	    g[cg].t[naxis].tl_starttype = (int) yyvsp[0].pset;
	}
break;
case 430:
#line 1933 "pars.yacc"
{
	    g[cg].t[naxis].tl_stoptype = (int) yyvsp[0].pset;
	}
break;
case 431:
#line 1936 "pars.yacc"
{
	    g[cg].t[naxis].tl_stoptype = (int) yyvsp[0].pset;
	}
break;
case 432:
#line 1939 "pars.yacc"
{
	    g[cg].t[naxis].tl_vgap = yyvsp[0].val;
	}
break;
case 433:
#line 1942 "pars.yacc"
{
	    g[cg].t[naxis].tl_hgap = yyvsp[0].val;
	}
break;
case 434:
#line 1945 "pars.yacc"
{
	    g[cg].t[naxis].tl_charsize = yyvsp[0].val;
	}
break;
case 435:
#line 1948 "pars.yacc"
{
	    g[cg].t[naxis].tl_font = (int) yyvsp[0].val;
	}
break;
case 436:
#line 1951 "pars.yacc"
{
	    g[cg].t[naxis].tl_color = (int) yyvsp[0].val;
	}
break;
case 437:
#line 1954 "pars.yacc"
{
	    g[cg].t[naxis].tl_linew = (int) yyvsp[0].val;
	}
break;
case 438:
#line 1957 "pars.yacc"
{
	    set_plotstr_string(&g[cg].t[naxis].t_speclab[(int) yyvsp[-2].val], (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 439:
#line 1964 "pars.yacc"
{
	    set_plotstr_string(&g[cg].t[naxis].label, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 440:
#line 1968 "pars.yacc"
{
	    g[cg].t[naxis].label_layout = PERP;
	}
break;
case 441:
#line 1971 "pars.yacc"
{
	    g[cg].t[naxis].label_layout = PARA;
	}
break;
case 442:
#line 1974 "pars.yacc"
{
	    g[cg].t[naxis].label_place = yyvsp[0].pset;
	}
break;
case 443:
#line 1977 "pars.yacc"
{
	    g[cg].t[naxis].label_place = yyvsp[0].pset;
	}
break;
case 444:
#line 1980 "pars.yacc"
{
	    g[cg].t[naxis].label.x = yyvsp[-2].val;
	    g[cg].t[naxis].label.y = yyvsp[0].val;
	}
break;
case 445:
#line 1984 "pars.yacc"
{
	    g[cg].t[naxis].label.just = (int) yyvsp[0].pset;
	}
break;
case 446:
#line 1987 "pars.yacc"
{
	    g[cg].t[naxis].label.charsize = yyvsp[0].val;
	}
break;
case 447:
#line 1990 "pars.yacc"
{
	    g[cg].t[naxis].label.font = (int) yyvsp[0].val;
	}
break;
case 448:
#line 1993 "pars.yacc"
{
	    g[cg].t[naxis].label.color = (int) yyvsp[0].val;
	}
break;
case 449:
#line 1996 "pars.yacc"
{
	    g[cg].t[naxis].label.linew = (int) yyvsp[0].val;
	}
break;
case 450:
#line 2002 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbar = yyvsp[0].pset;
	}
break;
case 451:
#line 2005 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarcolor = (int) yyvsp[0].val;
	}
break;
case 452:
#line 2008 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarlines = (int) yyvsp[0].val;
	}
break;
case 453:
#line 2011 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarlinew = (int) yyvsp[0].val;
	}
break;
case 454:
#line 2018 "pars.yacc"
{
	    whichgraph = yyvsp[-2].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 455:
#line 2023 "pars.yacc"
{
	    whichgraph = cg;
	    whichset = yyvsp[0].pset;
	}
break;
case 456:
#line 2028 "pars.yacc"
{
	    whichgraph = cg;
	    whichset = yyvsp[0].pset;
	}
break;
case 457:
#line 2033 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 458:
#line 2038 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 459:
#line 2043 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 460:
#line 2049 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 461:
#line 2050 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 462:
#line 2051 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 463:
#line 2052 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 464:
#line 2053 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 465:
#line 2056 "pars.yacc"
{ yyval.pset = ON; }
break;
case 466:
#line 2057 "pars.yacc"
{ yyval.pset = OFF; }
break;
case 467:
#line 2060 "pars.yacc"
{ yyval.pset = COLOR; }
break;
case 468:
#line 2061 "pars.yacc"
{ yyval.pset = PATTERN; }
break;
case 469:
#line 2064 "pars.yacc"
{ yyval.pset = RUNAVG; }
break;
case 470:
#line 2065 "pars.yacc"
{ yyval.pset = RUNSTD; }
break;
case 471:
#line 2066 "pars.yacc"
{ yyval.pset = RUNMED; }
break;
case 472:
#line 2067 "pars.yacc"
{ yyval.pset = RUNMAX; }
break;
case 473:
#line 2068 "pars.yacc"
{ yyval.pset = RUNMIN; }
break;
case 474:
#line 2071 "pars.yacc"
{ yyval.pset = DFT; }
break;
case 475:
#line 2072 "pars.yacc"
{ yyval.pset = FFT; }
break;
case 476:
#line 2073 "pars.yacc"
{ yyval.pset = INVDFT; }
break;
case 477:
#line 2074 "pars.yacc"
{ yyval.pset = INVFFT; }
break;
case 478:
#line 2077 "pars.yacc"
{ yyval.pset = DISK; }
break;
case 479:
#line 2078 "pars.yacc"
{ yyval.pset = PIPE; }
break;
case 480:
#line 2081 "pars.yacc"
{ yyval.pset = PATTERN; }
break;
case 481:
#line 2082 "pars.yacc"
{ yyval.pset = COLOR; }
break;
case 482:
#line 2083 "pars.yacc"
{ yyval.pset = NONE; }
break;
case 483:
#line 2086 "pars.yacc"
{ yyval.pset = TOP; }
break;
case 484:
#line 2087 "pars.yacc"
{ yyval.pset = BOTTOM; }
break;
case 485:
#line 2088 "pars.yacc"
{ yyval.pset = LEFT; }
break;
case 486:
#line 2089 "pars.yacc"
{ yyval.pset = RIGHT; }
break;
case 487:
#line 2090 "pars.yacc"
{ yyval.pset = BOTH; }
break;
case 488:
#line 2093 "pars.yacc"
{ yyval.pset = RIGHT; }
break;
case 489:
#line 2094 "pars.yacc"
{ yyval.pset = LEFT; }
break;
case 490:
#line 2095 "pars.yacc"
{ yyval.pset = CENTER; }
break;
case 491:
#line 2098 "pars.yacc"
{ yyval.pset = MINP; }
break;
case 492:
#line 2099 "pars.yacc"
{ yyval.pset = MAXP; }
break;
case 493:
#line 2102 "pars.yacc"
{ yyval.pset = TRUEP; }
break;
case 494:
#line 2103 "pars.yacc"
{ yyval.pset = FALSEP; }
break;
case 495:
#line 2106 "pars.yacc"
{ yyval.pset = IN; }
break;
case 496:
#line 2107 "pars.yacc"
{ yyval.pset = OUT; }
break;
case 497:
#line 2108 "pars.yacc"
{ yyval.pset = BOTH; }
break;
case 498:
#line 2111 "pars.yacc"
{ yyval.pset = DECIMAL; }
break;
case 499:
#line 2112 "pars.yacc"
{ yyval.pset = EXPONENTIAL; }
break;
case 500:
#line 2113 "pars.yacc"
{ yyval.pset = POWER; }
break;
case 501:
#line 2114 "pars.yacc"
{ yyval.pset = GENERAL; }
break;
case 502:
#line 2115 "pars.yacc"
{ yyval.pset = DDMMYY; }
break;
case 503:
#line 2116 "pars.yacc"
{ yyval.pset = MMDDYY; }
break;
case 504:
#line 2117 "pars.yacc"
{ yyval.pset = YYMMDD; }
break;
case 505:
#line 2118 "pars.yacc"
{ yyval.pset = MMYY; }
break;
case 506:
#line 2119 "pars.yacc"
{ yyval.pset = MMDD; }
break;
case 507:
#line 2120 "pars.yacc"
{ yyval.pset = MONTHDAY; }
break;
case 508:
#line 2121 "pars.yacc"
{ yyval.pset = DAYMONTH; }
break;
case 509:
#line 2122 "pars.yacc"
{ yyval.pset = MONTHS; }
break;
case 510:
#line 2123 "pars.yacc"
{ yyval.pset = MONTHSY; }
break;
case 511:
#line 2124 "pars.yacc"
{ yyval.pset = MONTHL; }
break;
case 512:
#line 2125 "pars.yacc"
{ yyval.pset = DAYOFWEEKS; }
break;
case 513:
#line 2126 "pars.yacc"
{ yyval.pset = DAYOFWEEKL; }
break;
case 514:
#line 2127 "pars.yacc"
{ yyval.pset = DAYOFYEAR; }
break;
case 515:
#line 2128 "pars.yacc"
{ yyval.pset = HMS; }
break;
case 516:
#line 2129 "pars.yacc"
{ yyval.pset = MMDDHMS; }
break;
case 517:
#line 2130 "pars.yacc"
{ yyval.pset = MMDDYYHMS; }
break;
case 518:
#line 2131 "pars.yacc"
{ yyval.pset = YYMMDDHMS; }
break;
case 519:
#line 2132 "pars.yacc"
{ yyval.pset = DEGREESLON; }
break;
case 520:
#line 2133 "pars.yacc"
{ yyval.pset = DEGREESMMLON; }
break;
case 521:
#line 2134 "pars.yacc"
{ yyval.pset = DEGREESMMSSLON; }
break;
case 522:
#line 2135 "pars.yacc"
{ yyval.pset = MMSSLON; }
break;
case 523:
#line 2136 "pars.yacc"
{ yyval.pset = DEGREESLAT; }
break;
case 524:
#line 2137 "pars.yacc"
{ yyval.pset = DEGREESMMLAT; }
break;
case 525:
#line 2138 "pars.yacc"
{ yyval.pset = DEGREESMMSSLAT; }
break;
case 526:
#line 2139 "pars.yacc"
{ yyval.pset = MMSSLAT; }
break;
case 527:
#line 2142 "pars.yacc"
{ yyval.pset = NORMAL; }
break;
case 528:
#line 2143 "pars.yacc"
{ yyval.pset = ABSOLUTE; }
break;
case 529:
#line 2144 "pars.yacc"
{ yyval.pset = NEGATE; }
break;
case 530:
#line 2147 "pars.yacc"
{ yyval.pset = UP; }
break;
case 531:
#line 2148 "pars.yacc"
{ yyval.pset = DOWN; }
break;
case 532:
#line 2149 "pars.yacc"
{ yyval.pset = RIGHT; }
break;
case 533:
#line 2150 "pars.yacc"
{ yyval.pset = LEFT; }
break;
case 534:
#line 2151 "pars.yacc"
{ yyval.pset = IN; }
break;
case 535:
#line 2152 "pars.yacc"
{ yyval.pset = OUT; }
break;
case 536:
#line 2155 "pars.yacc"
{ yyval.pset = WORLD; }
break;
case 537:
#line 2156 "pars.yacc"
{ yyval.pset = VIEW; }
break;
case 538:
#line 2159 "pars.yacc"
{ yyval.pset = ASCENDING; }
break;
case 539:
#line 2160 "pars.yacc"
{ yyval.pset = DESCENDING; }
break;
case 540:
#line 2163 "pars.yacc"
{ yyval.pset = X; }
break;
case 541:
#line 2164 "pars.yacc"
{ yyval.pset = Y; }
break;
case 542:
#line 2167 "pars.yacc"
{ yyval.pset = X; }
break;
case 543:
#line 2168 "pars.yacc"
{ yyval.pset = Y; }
break;
case 544:
#line 2169 "pars.yacc"
{ yyval.pset = X0; }
break;
case 545:
#line 2170 "pars.yacc"
{ yyval.pset = Y0; }
break;
case 546:
#line 2171 "pars.yacc"
{ yyval.pset = Y1; }
break;
case 547:
#line 2172 "pars.yacc"
{ yyval.pset = Y2; }
break;
case 548:
#line 2173 "pars.yacc"
{ yyval.pset = Y3; }
break;
case 549:
#line 2174 "pars.yacc"
{ yyval.pset = Y4; }
break;
case 550:
#line 2175 "pars.yacc"
{ yyval.pset = Y5; }
break;
case 551:
#line 2180 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    if (itmp >= ls) {
		yyerror("Subscript out of range");
		return 1;
	    } else {
		yyvsp[-5].ptr[itmp] = yyvsp[0].val;
		result = yyvsp[0].val;
	    }
	}
break;
case 552:
#line 2191 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(cg, curset, yyvsp[-3].val);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(cg, curset);
	    update_set_status(cg, curset);
	}
break;
case 553:
#line 2206 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(cg, yyvsp[-7].pset, yyvsp[-5].pset);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(cg, yyvsp[-7].pset);
	    update_set_status(cg, yyvsp[-7].pset);
	}
break;
case 554:
#line 2221 "pars.yacc"
{
	    set_prop(cg, SET, SETNUM, yyvsp[-4].pset, SYMBOL, TYPE, (int) yyvsp[0].val, 0);
	    result = 0;
	}
break;
case 555:
#line 2233 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(yyvsp[-9].pset, yyvsp[-7].pset, yyvsp[-5].pset);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(yyvsp[-9].pset, yyvsp[-7].pset);
	    update_set_status(yyvsp[-9].pset, yyvsp[-7].pset);
	}
break;
case 556:
#line 2251 "pars.yacc"
{
	    if (yyvsp[-2].pset == X) {
		*xx = yyvsp[0].val;
	    } else {
		*yy = yyvsp[0].val;
	    }
	}
break;
case 557:
#line 2262 "pars.yacc"
{
	    int i;
	    if (ls < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (ls > maxarr) {
		maxarr = ls;
		init_scratch_arrays(ls);
	    }
	    for (i = 0; i < lxy; i++) {
		yyvsp[-2].ptr[i] = yyvsp[0].ptr[i];
	    }
	    result = yyvsp[0].ptr[0];
	}
break;
case 558:
#line 2277 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, curset)) {
		activateset(cg, curset);
		setlength(cg, curset, lxy);
		setcomment(cg, curset, "Created");
	    }
	    ptr = getvptr(cg, curset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(cg, curset);
	        update_set_status(cg, curset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 559:
#line 2300 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
	        do_copyset(cg, yyvsp[0].pset, cg, yyvsp[-2].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 560:
#line 2309 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
	        do_copyset(cg, yyvsp[0].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 561:
#line 2318 "pars.yacc"
{
	    if (isactive_set(yyvsp[-2].pset, yyvsp[0].pset)) {
	        do_copyset(yyvsp[-2].pset, yyvsp[0].pset, cg, yyvsp[-4].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 562:
#line 2327 "pars.yacc"
{
	    if (isactive_set(yyvsp[-2].pset, yyvsp[0].pset)) {
	        do_copyset(yyvsp[-2].pset, yyvsp[0].pset, yyvsp[-6].pset, yyvsp[-4].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 563:
#line 2335 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, yyvsp[-4].pset)) {
		activateset(cg, yyvsp[-4].pset);
		setlength(cg, yyvsp[-4].pset, lxy);
		setcomment(cg, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(cg, yyvsp[-4].pset);
	        update_set_status(cg, yyvsp[-4].pset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 564:
#line 2358 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(yyvsp[-6].pset, yyvsp[-4].pset)) {
		activateset(yyvsp[-6].pset, yyvsp[-4].pset);
		setlength(yyvsp[-6].pset, yyvsp[-4].pset, lxy);
		setcomment(yyvsp[-6].pset, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(yyvsp[-6].pset, yyvsp[-4].pset);
	        update_set_status(yyvsp[-6].pset, yyvsp[-4].pset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 565:
#line 2381 "pars.yacc"
{
	    int i;
	    if (lxy < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (lxy > maxarr) {
		maxarr = lxy;
		init_scratch_arrays(lxy);
	    }
	    for (i = 0; i < lxy; i++) {
		yyvsp[-2].ptr[i] = yyvsp[0].val;
	    }
	    result = yyvsp[0].val;
	}
break;
case 566:
#line 2396 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, curset)) {
		activateset(cg, curset);
		setlength(cg, curset, lxy);
		setcomment(cg, curset, "Created");
	    }
	    ptr = getvptr(cg, curset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(cg, curset);
	        update_set_status(cg, curset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 567:
#line 2419 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, yyvsp[-4].pset)) {
		activateset(cg, yyvsp[-4].pset);
		setlength(cg, yyvsp[-4].pset, lxy);
		setcomment(cg, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(cg, yyvsp[-4].pset);
	        update_set_status(cg, yyvsp[-4].pset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 568:
#line 2442 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(yyvsp[-6].pset, yyvsp[-4].pset)) {
		activateset(yyvsp[-6].pset, yyvsp[-4].pset);
		setlength(yyvsp[-6].pset, yyvsp[-4].pset, lxy);
		setcomment(yyvsp[-6].pset, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(yyvsp[-6].pset, yyvsp[-4].pset);
	        update_set_status(yyvsp[-6].pset, yyvsp[-4].pset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 569:
#line 2468 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (lxy < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (lxy > maxarr) {
		maxarr = lxy;
		init_scratch_arrays(lxy);
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].ptr[i];
	    }
	}
break;
case 570:
#line 2484 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(cg, curset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 571:
#line 2498 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(cg, yyvsp[-2].pset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 572:
#line 2512 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 573:
#line 2526 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].val;
	    }
	}
break;
case 574:
#line 2535 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val + yyvsp[0].val;
	    }
	}
break;
case 575:
#line 2544 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] + yyvsp[0].ptr[i];
	    }
	}
break;
case 576:
#line 2553 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val + yyvsp[0].ptr[i];
	    }
	}
break;
case 577:
#line 2562 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] + yyvsp[0].val;
	    }
	}
break;
case 578:
#line 2571 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val - yyvsp[0].val;
	    }
	}
break;
case 579:
#line 2580 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] - yyvsp[0].ptr[i];
	    }
	}
break;
case 580:
#line 2589 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val - yyvsp[0].ptr[i];
	    }
	}
break;
case 581:
#line 2598 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] - yyvsp[0].val;
	    }
	}
break;
case 582:
#line 2607 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val * yyvsp[0].val;
	    }
	}
break;
case 583:
#line 2616 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] * yyvsp[0].ptr[i];
	    }
	}
break;
case 584:
#line 2625 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val * yyvsp[0].ptr[i];
	    }
	}
break;
case 585:
#line 2634 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] * yyvsp[0].val;
	    }
	}
break;
case 586:
#line 2643 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (yyvsp[0].val == 0.0) {
		yyerror("Divide by Zero");
		return 1;
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val / yyvsp[0].val;
	    }
	}
break;
case 587:
#line 2656 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		if (yyvsp[0].ptr[i] == 0.0) {
		    yyerror("Divide by Zero");
		    return 1;
		}
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] / yyvsp[0].ptr[i];
	    }
	}
break;
case 588:
#line 2671 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		if (yyvsp[0].ptr[i] == 0.0) {
		    yyerror("Divide by Zero");
		    return 1;
		}
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val / yyvsp[0].ptr[i];
	    }
	}
break;
case 589:
#line 2686 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (yyvsp[0].val == 0.0) {
		yyerror("Divide by Zero");
		return 1;
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] / yyvsp[0].val;
	    }
	}
break;
case 590:
#line 2699 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].val, yyvsp[0].val);
	    }
	}
break;
case 591:
#line 2708 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].val, yyvsp[0].ptr[i]);
	    }
	}
break;
case 592:
#line 2717 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].ptr[i], yyvsp[0].val);
	    }
	}
break;
case 593:
#line 2726 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].ptr[i], yyvsp[0].ptr[i]);
	    }
	}
break;
case 594:
#line 2735 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fabs(yyvsp[-1].val);
	    }
	}
break;
case 595:
#line 2744 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fabs(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 596:
#line 2753 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = acos(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 597:
#line 2762 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = asin(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 598:
#line 2771 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atan(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 599:
#line 2780 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atan2(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 600:
#line 2789 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ceil(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 601:
#line 2798 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = cos(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 602:
#line 2807 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] *= M_PI / 180.0;
	    }
	}
break;
case 603:
#line 2816 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = erf(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 604:
#line 2825 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = erfc(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 605:
#line 2834 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = exp(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 606:
#line 2843 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = floor(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 607:
#line 2852 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 608:
#line 2861 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].val, yyvsp[-1].ptr[i]);
	    }
	}
break;
case 609:
#line 2870 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].ptr[i], yyvsp[-1].val);
	    }
	}
break;
case 610:
#line 2879 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].val, yyvsp[-1].val);
	    }
	}
break;
case 611:
#line 2888 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = i + 1;
	    }
	}
break;
case 612:
#line 2897 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].func;
	    }
	}
break;
case 613:
#line 2906 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = (int) yyvsp[-1].ptr[i];
	    }
	}
break;
case 614:
#line 2915 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invnorm(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 615:
#line 2924 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invt(yyvsp[-3].val, (int) yyvsp[-1].val);
	    }
	}
break;
case 616:
#line 2933 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invt(yyvsp[-3].ptr[i], (int) yyvsp[-1].val);
	    }
	}
break;
case 617:
#line 2942 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = lrand48() % (long) (yyvsp[-1].val);
	    }
	}
break;
case 618:
#line 2951 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = lgamma(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 619:
#line 2960 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = log(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 620:
#line 2969 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = log10(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 621:
#line 2978 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = 1.0 / (1.0 + exp(-(yyvsp[-5].ptr[i] - yyvsp[-3].val)/ yyvsp[-1].val));
	    }
	}
break;
case 622:
#line 2987 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-3].ptr[i] >= yyvsp[-1].ptr[i] ? yyvsp[-3].ptr[i] : yyvsp[-1].ptr[i];
	    }
	}
break;
case 623:
#line 2996 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-3].ptr[i] <= yyvsp[-1].ptr[i] ? yyvsp[-3].ptr[i] : yyvsp[-1].ptr[i];
	    }
	}
break;
case 624:
#line 3005 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fmod(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 625:
#line 3014 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fx(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 626:
#line 3023 "pars.yacc"
{
	    int i;
	    double tmp;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = normp(yyvsp[-1].ptr[i], &tmp);
	    }
	}
break;
case 627:
#line 3033 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = M_PI;
	    }
	}
break;
case 628:
#line 3042 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = M_PI / 180.0;
	    }
	}
break;
case 629:
#line 3051 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = (double) drand48();
	    }
	}
break;
case 630:
#line 3060 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 631:
#line 3069 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].val, yyvsp[-1].ptr[i]);
	    }
	}
break;
case 632:
#line 3078 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].ptr[i], yyvsp[-1].val);
	    }
	}
break;
case 633:
#line 3087 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].val, yyvsp[-1].val);
	    }
	}
break;
case 634:
#line 3096 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sin(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 635:
#line 3105 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-1].ptr[i] * yyvsp[-1].ptr[i];
	    }
	}
break;
case 636:
#line 3114 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sqrt(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 637:
#line 3123 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = tan(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 638:
#line 3131 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
	        if ((int) yyvsp[-4].ptr[i]) {
		    yyval.ptr[i] = yyvsp[-2].ptr[i];
	        } else {
		    yyval.ptr[i] = yyvsp[0].ptr[i];
	        }
	    }
	}
break;
case 639:
#line 3144 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] > yyvsp[0].ptr[i];
	    }
	}
break;
case 640:
#line 3153 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] < yyvsp[0].ptr[i];
	    }
	}
break;
case 641:
#line 3162 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] <= yyvsp[0].ptr[i];
	    }
	}
break;
case 642:
#line 3171 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] >= yyvsp[0].ptr[i];
	    }
	}
break;
case 643:
#line 3180 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] == yyvsp[0].ptr[i];
	    }
	}
break;
case 644:
#line 3189 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] != yyvsp[0].ptr[i];
	    }
	}
break;
case 645:
#line 3198 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] && yyvsp[0].ptr[i];
	    }
	}
break;
case 646:
#line 3207 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] || yyvsp[0].ptr[i];
	    }
	}
break;
case 647:
#line 3216 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = !(yyvsp[0].ptr[i]);
	    }
	}
break;
case 648:
#line 3225 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-1].ptr[i];
	    }
	}
break;
case 649:
#line 3233 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = -yyvsp[0].ptr[i];
	    }
	}
break;
case 651:
#line 3244 "pars.yacc"
{
	    yyval.val = yyvsp[0].val;
	}
break;
case 652:
#line 3247 "pars.yacc"
{
	    yyval.val = yyvsp[-3].ptr[(int) yyvsp[-1].val];
	}
break;
case 653:
#line 3250 "pars.yacc"
{
	    yyval.val = (yyvsp[0].pset == X) ? *xx : *yy;
	}
break;
case 654:
#line 3253 "pars.yacc"
{
	    double *ptr = getvptr(cg, curset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 655:
#line 3263 "pars.yacc"
{
	    double *ptr = getvptr(cg, yyvsp[-5].pset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 656:
#line 3273 "pars.yacc"
{
	    double *ptr = getvptr(yyvsp[-7].pset, yyvsp[-5].pset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 657:
#line 3283 "pars.yacc"
{
	    double *ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    switch (yyvsp[0].pset) {
	    case MINP:
		yyval.val = vmin(ptr, g[cg].p[yyvsp[-4].pset].len);
		break;
	    case MAXP:
		yyval.val = vmax(ptr, g[cg].p[yyvsp[-4].pset].len);
		break;
	    }
	}
break;
case 658:
#line 3298 "pars.yacc"
{
	    double *ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    switch (yyvsp[0].pset) {
	    case MINP:
		yyval.val = vmin(ptr, g[yyvsp[-6].pset].p[yyvsp[-4].pset].len);
		break;
	    case MAXP:
		yyval.val = vmax(ptr, g[yyvsp[-6].pset].p[yyvsp[-4].pset].len);
		break;
	    }
	}
break;
case 659:
#line 3313 "pars.yacc"
{
	    yyval.val = g[cg].p[yyvsp[-2].pset].len;
	}
break;
case 660:
#line 3317 "pars.yacc"
{
	    double bar, sd;
	    double *ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
		stasum(ptr, getsetlength(cg, yyvsp[-4].pset), &bar, &sd, 0);
	        yyval.val = bar;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 661:
#line 3329 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val + yyvsp[0].val;
	}
break;
case 662:
#line 3332 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val - yyvsp[0].val;
	}
break;
case 663:
#line 3335 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val * yyvsp[0].val;
	}
break;
case 664:
#line 3339 "pars.yacc"
{
	    if (yyvsp[0].val != 0.0) {
		yyval.val = yyvsp[-2].val / yyvsp[0].val;
	    } else {
		yyerror("Divide by Zero");
		return 1;
	    }
	}
break;
case 665:
#line 3347 "pars.yacc"
{
	    yyval.val = fmod(yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 666:
#line 3350 "pars.yacc"
{
	    yyval.val = pow(yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 667:
#line 3353 "pars.yacc"
{
	    yyval.val = fabs(yyvsp[-1].val);
	}
break;
case 668:
#line 3356 "pars.yacc"
{
	    yyval.val = acos(yyvsp[-1].val);
	}
break;
case 669:
#line 3359 "pars.yacc"
{
	    yyval.val = asin(yyvsp[-1].val);
	}
break;
case 670:
#line 3362 "pars.yacc"
{
	    yyval.val = atan(yyvsp[-1].val);
	}
break;
case 671:
#line 3365 "pars.yacc"
{
	    yyval.val = atan2(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 672:
#line 3368 "pars.yacc"
{
	    yyval.val = ceil(yyvsp[-1].val);
	}
break;
case 673:
#line 3371 "pars.yacc"
{
	    yyval.val = cos(yyvsp[-1].val);
	}
break;
case 674:
#line 3374 "pars.yacc"
{
	    yyval.val = 180.0 / M_PI;
	}
break;
case 675:
#line 3377 "pars.yacc"
{
	    yyval.val = erf(yyvsp[-1].val);
	}
break;
case 676:
#line 3380 "pars.yacc"
{
	    yyval.val = erfc(yyvsp[-1].val);
	}
break;
case 677:
#line 3383 "pars.yacc"
{
	    yyval.val = exp(yyvsp[-1].val);
	}
break;
case 678:
#line 3386 "pars.yacc"
{
	    yyval.val = floor(yyvsp[-1].val);
	}
break;
case 679:
#line 3389 "pars.yacc"
{
	    yyval.val = my_hypot(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 680:
#line 3392 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.xv1;
	}
break;
case 681:
#line 3395 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.xv2;
	}
break;
case 682:
#line 3398 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.yv1;
	}
break;
case 683:
#line 3401 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.yv2;
	}
break;
case 684:
#line 3404 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.xg1;
	}
break;
case 685:
#line 3407 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.xg2;
	}
break;
case 686:
#line 3410 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.yg1;
	}
break;
case 687:
#line 3413 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.yg2;
	}
break;
case 688:
#line 3416 "pars.yacc"
{
	    yyval.val = g[cg].v.xv1;
	}
break;
case 689:
#line 3419 "pars.yacc"
{
	    yyval.val = g[cg].v.xv2;
	}
break;
case 690:
#line 3422 "pars.yacc"
{
	    yyval.val = g[cg].v.yv1;
	}
break;
case 691:
#line 3425 "pars.yacc"
{
	    yyval.val = g[cg].v.yv2;
	}
break;
case 692:
#line 3428 "pars.yacc"
{
	    yyval.val = g[cg].w.xg1;
	}
break;
case 693:
#line 3431 "pars.yacc"
{
	    yyval.val = g[cg].w.xg2;
	}
break;
case 694:
#line 3434 "pars.yacc"
{
	    yyval.val = g[cg].w.yg1;
	}
break;
case 695:
#line 3437 "pars.yacc"
{
	    yyval.val = g[cg].w.yg2;
	}
break;
case 696:
#line 3440 "pars.yacc"
{
	    yyval.val = g[cg].w.xg2 - g[cg].w.xg1;
	}
break;
case 697:
#line 3443 "pars.yacc"
{
	    yyval.val = g[cg].w.yg2 - g[cg].w.yg1;
	}
break;
case 698:
#line 3446 "pars.yacc"
{
	    yyval.val = setindex;
	}
break;
case 699:
#line 3449 "pars.yacc"
{
	    yyval.val = setsetno;
	}
break;
case 700:
#line 3452 "pars.yacc"
{
	    yyval.val = (long) yyvsp[-1].val;
	}
break;
case 701:
#line 3455 "pars.yacc"
{
	    yyval.val = invnorm(yyvsp[-1].val);
	}
break;
case 702:
#line 3458 "pars.yacc"
{
	    yyval.val = invt(yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 703:
#line 3461 "pars.yacc"
{
	    yyval.val = lrand48() % (long) (yyvsp[-1].val);
	}
break;
case 704:
#line 3464 "pars.yacc"
{ /* yr, mo, day */
	    yyval.val = julday((int) yyvsp[-3].val, (int) yyvsp[-1].val, (int) yyvsp[-5].val, 12, 0, 0.0);
	}
break;
case 705:
#line 3468 "pars.yacc"
{ /* yr, mo, day, hr, min, sec */
	    yyval.val = julday((int) yyvsp[-9].val, (int) yyvsp[-7].val, (int) yyvsp[-11].val, (int) yyvsp[-5].val, (int) yyvsp[-3].val, (double) yyvsp[-1].val);
	}
break;
case 706:
#line 3471 "pars.yacc"
{
	    yyval.val = lgamma(yyvsp[-1].val);
	}
break;
case 707:
#line 3474 "pars.yacc"
{
	    yyval.val = log(yyvsp[-1].val);
	}
break;
case 708:
#line 3477 "pars.yacc"
{
	    yyval.val = log10(yyvsp[-1].val);
	}
break;
case 709:
#line 3481 "pars.yacc"
{
	    yyval.val = 1.0 / (1.0 + exp(-(yyvsp[-5].val - yyvsp[-3].val)/ yyvsp[-1].val));
	}
break;
case 710:
#line 3484 "pars.yacc"
{
	    yyval.val = yyvsp[-3].val >= yyvsp[-1].val ? yyvsp[-3].val : yyvsp[-1].val;
	}
break;
case 711:
#line 3487 "pars.yacc"
{
	    yyval.val = yyvsp[-3].val <= yyvsp[-1].val ? yyvsp[-3].val : yyvsp[-1].val;
	}
break;
case 712:
#line 3490 "pars.yacc"
{
	    yyval.val = fmod(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 713:
#line 3493 "pars.yacc"
{
	    yyval.val = fx(yyvsp[-1].val);
	}
break;
case 714:
#line 3496 "pars.yacc"
{
	    double tmp;
	    yyval.val = normp(yyvsp[-1].val, &tmp);
	}
break;
case 715:
#line 3500 "pars.yacc"
{
	    yyval.val = M_PI;
	}
break;
case 716:
#line 3503 "pars.yacc"
{
	    yyval.val = M_PI / 180.0;
	}
break;
case 717:
#line 3506 "pars.yacc"
{
	    yyval.val = (double) drand48();
	}
break;
case 718:
#line 3509 "pars.yacc"
{
	    yyval.val = rnorm(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 719:
#line 3512 "pars.yacc"
{
	    yyval.val = sin(yyvsp[-1].val);
	}
break;
case 720:
#line 3515 "pars.yacc"
{
	    yyval.val = pow(yyvsp[-1].val, 2.0);
	}
break;
case 721:
#line 3518 "pars.yacc"
{
	    yyval.val = sqrt(yyvsp[-1].val);
	}
break;
case 722:
#line 3521 "pars.yacc"
{
	    yyval.val = tan(yyvsp[-1].val);
	}
break;
case 723:
#line 3524 "pars.yacc"
{
	    if ((int) yyvsp[-4].val) {
		yyval.val = yyvsp[-2].val;
	    } else {
		yyval.val = yyvsp[0].val;
	    }
	}
break;
case 724:
#line 3531 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val > yyvsp[0].val;
	}
break;
case 725:
#line 3534 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val < yyvsp[0].val;
	}
break;
case 726:
#line 3537 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val <= yyvsp[0].val;
	}
break;
case 727:
#line 3540 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val >= yyvsp[0].val;
	}
break;
case 728:
#line 3543 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val == yyvsp[0].val;
	}
break;
case 729:
#line 3546 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val != yyvsp[0].val;
	}
break;
case 730:
#line 3549 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val && yyvsp[0].val;
	}
break;
case 731:
#line 3552 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val || yyvsp[0].val;
	}
break;
case 732:
#line 3555 "pars.yacc"
{
	    yyval.val = !(yyvsp[0].val);
	}
break;
case 733:
#line 3558 "pars.yacc"
{
	    yyval.val = yyvsp[-1].val;
	}
break;
case 734:
#line 3561 "pars.yacc"
{
	    yyval.val = -yyvsp[0].val;
	}
break;
#line 10372 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
